Package: mobileRNA
Type: Package
Title: mobileRNA: Investigate the RNA mobilome & population-scale
        changes
Version: 1.8.0
Authors@R: c(person("Katie", "Jeynes-Cupper", 
    email = "kejc@illinois.edu", role = c("aut", "cre"), 
     comment = c(ORCID = "0009-0000-1350-1371")),
    person("Marco", "Catoni", email = "m.catoni@bham.ac.uk", role = "aut", 
    comment= c(ORCID = "0000-0002-3258-2522")))
Description: Genomic analysis can be utilised to identify differences between RNA 
  populations in two conditions, both in production and abundance. This includes 
  the identification of RNAs produced by multiple genomes within a biological 
  system. For example, RNA produced by pathogens within a host or mobile RNAs in
  plant graft systems. The mobileRNA package provides methods to pre-process, 
  analyse and visualise the sRNA and mRNA populations based on the premise of
  mapping reads to all genotypes at the same time. 
License: MIT + file LICENSE
Depends: R (>= 4.3.0)
VignetteBuilder: knitr
Encoding: UTF-8
LazyData: FALSE
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.3
Suggests: knitr, rmarkdown, BiocStyle, testthat (>= 3.0.0)
Imports: dplyr, tidyr, ggplot2, BiocGenerics, DESeq2, edgeR, ggrepel,
        grDevices, pheatmap, utils, tidyselect, progress, RColorBrewer,
        GenomicRanges, rtracklayer, data.table, SimDesign, scales,
        IRanges, stats, methods, Biostrings, reticulate, S4Vectors,
        GenomeInfoDb, SummarizedExperiment, rlang, bioseq, grid
biocViews: Visualization, RNASeq, Sequencing, SmallRNA, GenomeAssembly,
        Clustering, ExperimentalDesign, QualityControl, WorkflowStep,
        Alignment, Preprocessing
BiocType: Software
BugReports: https://github.com/KJeynesCupper/mobileRNA/issues
SystemRequirements: GNU make, ShortStack (>= 4.0), HTSeq, HISAT2,
        SAMtools, Conda
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/mobileRNA
git_branch: RELEASE_3_23
git_last_commit: 8240325
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:21:07 UTC; biocbuild
Author: Katie Jeynes-Cupper [aut, cre] (ORCID:
    <https://orcid.org/0009-0000-1350-1371>),
  Marco Catoni [aut] (ORCID: <https://orcid.org/0000-0002-3258-2522>)
Maintainer: Katie Jeynes-Cupper <kejc@illinois.edu>

mobileRNA <a href="kjeynescupper.github.io/mobileRNA/"><img src="man/figures/logo.png" align="right" height="138" /></a>
======================================================================

An `R` package for analysis of sRNA & mRNA populations in plants and animals. Specalised in the identification of RNA populations in systems with multiple genomes, such as plant graft systems. 

<br> 

<!-- badges: start -->
[![R build
status](https://github.com/KJeynesCupper/mobileRNA/workflows/R-CMD-check/badge.svg)](https://github.com/KJeynesCupper/mobileRNA/actions)
<!-- badges: end -->

Author
======================================================================
Katie Jeynes-Cupper, University of Illinois Urbana-Champaign, kejc@illinois.edu
Marco Catoni, University of Birmingham


IMPORTANT UPDATES
======================================================================
Recently we were made aware of a bug in the RNAmergeGenomes function 
which has now been fixed. Similarly, we introduced a new plotting function to 
plot the distribution of sRNAs across genomic features. 

Table of Contents
======================================================================
-   [Overview](#Overview)
-   [Installation](#installation)
-   [Quick Start](#Quick-Start)
-   [Output](#Output)
-   [Advanced Analysis](#Advanced-Analysis)
<br>

Overview
======================================================================

**mobileRNA** is an `R` package that provides a pipeline for 
pre-processing and analysis of small RNA (sRNA) and messenger RNA (mRNA) 
sequencing data, primarily for the identification of mobile RNAs in plant graft 
systems. But, likely has other applications for systems containing more than 
one genotype, such as dual-host systems, to identify RNA molecules produced by 
each genotypes. **mobileRNA** also supports routine treatment vs control 
analysis to identify changes in sRNA population (abundance & production). These 
two workflows have be separated as mobile RNA analysis & the core RNA analysis, 
respectively [(Figure 1)](https://github.com/KJeynesCupper/mobileRNA/blob/main/man/figures/mobileRNA_graphic_1.png).

Most available genomics approaches to identify RNA molecules produced by two
different genotypes in a biological sample involve the alignment on a genotype 
of reference and post alignment screening of genetic variants. These methods 
have many possible limitations. **mobileRNA** aims to circumvents such problems 
with an alignment step which is simultaneously performed on both genomes 
involved. This approach considers that alignment tools already implement an 
algorithm ideal for identifying the best matches of reads to a given genome 
reference, but they do not account for potential matches to DNA sequences which 
are not provided as reference. The downstream analysis allows for differential 
analysis for the comparison in abundance, the identification of changes in RNA
production and the identification of putative mobile RNA molecules via
the filtering of RNA molecules which uniquely map to the mobile genome
of to the other grafting partner involved, which would represent the
putative mobile RNA molecules.

<br>

<p>
    <img src="./man/figures/mobileRNA_graphic_1.png" width = 800 height= 550 align="centre" />
</p>

**Figure 1: Basic diagram of mobileRNA workflows.**


<br> 

Installation 
======================================================================
The latest version of the package can be install directly from this
GitHub repo:

``` r

if (!require("devtools")) install.packages("devtools")
devtools::install_github("KJeynesCupper/mobileRNA", ref = "main")

```
To install from Bioconductor:
``` r

if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("mobileRNA")

```
Load package into R library:
``` r

library(mobileRNA)

```
<br>

Installation of OS dependencies 
======================================================================
In order to utilise the **mobileRNA** method, please install the following
OS dependencies within a Conda environment: 

For sRNA data, `ShortStack` (>= 4.0) (Axtell 2013) is requires. Please consider 
that `ShortStack` is not available for Windows, hence, Windows users will either 
need to opt to use a virtual machine or 
[Windows Subsystem for Linux](https://docs.microsoft.com/en-us/windows/wsl/install-win10)
In either case, both `R` and `ShortStack` will need to be installed and used on 
the Linux side. Please head to [ShortStack](https://github.com/MikeAxtell/ShortStack#install-using-conda-recommended) 
to see the recommended installation instructions with Conda.
This will ensure all dependencies are available within the same environment. 

For mRNA data, [HISAT2](https://anaconda.org/bioconda/hisat2) (Kim 2015), 
[HTSeq](https://htseq.readthedocs.io/en/master/install.html) 
(Anders, Pyl, and Huber 2014), 
[SAMtools](https://anaconda.org/bioconda/samtools) (Danecek P 2021) are required 
within the same Conda environment [@Anaconda].


Quick Start for mobile sRNA analysis
======================================================================
The example data set included with **mobileRNA** simulates grafting
between eggplant and tomato where the scion is eggplant and tomato
is the rootstock. There is example mRNAseq and sRNAseq files which represent
samples taken from an eggplant leaf tissue. Here we will locate sRNA
produced by the tomato rootstock which have traveled into the eggplant leaves

<br>

## 1. Merging genome assemblies

Merge the FASTA genome assemblies of tomato and eggplant into a single
reference file stored in your desired directory.

```r
fasta_1 <- system.file("extdata","reduced_chr12_Eggplant.fa.gz", 
                       package="mobileRNA")

fasta_2 <-system.file("extdata","reduced_chr2_Tomato.fa.gz",
                      package="mobileRNA")
# define temporary output directory - replace with your directory
output_assembly_file <- file.path(tempfile("merged_assembly", 
                                           fileext = ".fa"))

# merge
merged_reference <- RNAmergeGenomes(genomeA = fasta_1,
                                    genomeB = fasta_2,
                                    output_file = output_assembly_file)
```

<br>

## 2. Alignment

Align sRNA sequencing reads to the merged genome using our unique
alignment pipeline wrapped by the `mapRNA()` function.

``` r
samples <- system.file("extdata/sRNAseq",package="mobileRNA")

output_location <- tempdir()

mapRNA(input = "sRNA",
       input_files_dir = samples, 
       output_dir = output_location, 
       genomefile = output_assembly_file,
       condaenv = "/Users/user-name/miniconda3/envs/ShortStack4",
       mmap = "n")

```

<br>

## 3. Import pre-processed data into R

Import the results from the alignment step into R using the
`RNAimport()` function. This requires the directory storing the sample
output folders and the same of the samples to import from the directory.

``` r
# Directory containing results
results_dir <-  file.path(output_location,"2_alignment_results")

# Sample names and total number of reads, in the same order. 
sample_names <- c("selfgraft_demo_1", "selfgraft_demo_2", "selfgraft_demo_3",
              "heterograft_demo_1", "heterograft_demo_2", "heterograft_demo_3")


sRNA_data <- RNAimport(input = "sRNA", 
                       directory = results_dir,
                       samples = sample_names)
                           
```

Now lets use the comprehensive dataset, load the pre-processed data:

```{r Load, message=FALSE}

data("sRNA_data")

```

<br>

## 4. Calculate the consensus dicercall

For a given sRNA cluster, each replicate has determined the dicercall,
also known as the sRNA class, based on the length in nucleotides of the
most abundant sRNA. This can be drawn from all samples or named samples.
The output can be used as threshold values for downstream analysis, and
to remove data noise depending on data quality.

``` r

sRNA_data_summary <- RNAdicercall(data = sRNA_data, tidy = TRUE )
```

<br>

## 5. Differential analysis of sRNA population

Undertake differential analysis of sRNA within the experimental design
to explore changes in abundance. The function allows for two methods;
`edgeR` or `DESeq`.

``` r
## sample conditions in order within dataframe
groups <- c("Selfgraft", "Selfgraft", "Selfgraft", 
            "Heterograft", "Heterograft", "Heterograft")


## Differential analysis of whole dataset: DESeq2 method 
sRNA_DESeq2 <- RNAdifferentialAnalysis(data = sRNA_data,
                                       group = groups,
                                       method = "DESeq2")
                              



                              
# save output as txt file 
write.table(sRNA_DESeq2, "./sRNA_DA_output.txt")

```

Summarise results:

```r

RNAsummary(sRNA_DESeq2)

```

How about summarizing the sRNA population which are statistically
significant:

``` r

RNAsummary(sRNA_DESeq2, alpha=0.05)

```

## 6. Identify putuative mobile sRNA

Select the putative mobile sRNA clusters using `RNAmobile()`. This
requires supplying the function with a unique identifier of the
rootstock genome. The merging step placed the prefix "B" to the tomato
chromosomes.

``` r
# define control samples
controls <- c("selfgraft_1", "selfgraft_2", "selfgraft_3")

mobile_sRNA <- RNAmobile(input = "sRNA",
                         data = sRNA_DESeq2, 
                         controls = controls,
                         genome.ID = "B", 
                         task = "keep")



# save output as txt file 
write.table(mobile_sRNA, "./sRNA_mobile_output.txt")

```

<br>

Output
======================================================================
A data frame where rows represent potential mobile sRNA clusters. The
columns include information on the cluster, individual sample
replicates, and more.

#### Information on the cluster:

-   `Locus`: Name of the chromosome or scaffold, start position & end
    position
-   `chr`: Name of the chromosome or scaffold
-   `start` : Start position of the cluster
-   `end` : End position of the cluster

#### Information on each sample replicate:

-   `Cluster`: Cluster Name
-   `Dicercall` : The size of most abundant small RNA size
-   `Count` : Number of reads, default is uniquely aligned (*e.g.* not
    multi-mapping).
-   `MajorRNA` : RNA sequence of the most abundant sRNA in cluster
    within the sample
-   `RPM` : Reads per Million
-   `FPKM` : Fragments Per Kilobase of transcript per Million

#### Other information

-   `DicerConsensus` : Consensus sRNA class
-   `DicerCounts` : Number of replicates which contributed to the
    consensus dicercall sRNA class
-   `CountMean` : Count mean (Calculated by `RNAdifferentialAnalysis()`)
-   `log2FoldChange` : Log2FoldChange--The effect size estimate
-   `pvalue` : P value, the probability under the assumption of no
    effect or no difference, of obtaining a result equal to or more
    extreme than what was actually observed
-   `padjusted` : A p-value adjustment
-   `logCPM` : log counts per million, measure of expression level <br>

<br>

Mobile mRNA Analysis
======================================================================
For the identification of mobile mRNA, the same `mobileRNA` workflow can be
used. For the alignment step, as well as using a merged genome assembly file
(FASTA) the user will also need to generate a merged genome gene annotation file
(GFF) with the same chromosome labels. As well as a dataframe contain 
sample data where rows represent samples, and column 1 stores the sample names, 
column 2 stores the fastq file name for mate 1 and, for pair-end alignment, 
column 3 stores the fastq file name for mate 2. While for all other downstream 
functions simply change some of the parameters to set the option to mRNA input 
data type. 

<br>

Advanced Analysis
======================================================================
The quick start analysis allows for the retrieval of a data frame the
sRNA total population in the experimental design and also the candidate
mobile sRNAs. Users may want to advance the analysis and plot the data:

-   Exploratory and quality control analysis, such as PCA and distance
    matrices.
-   Summary values including RPM mean and Count mean across specific
    samples.
-   Plotting of the distribution of sRNA classes and the consensus
    dicercall across individual replicates or across the data set.
-   Volcano plot for mRNA data 


Advanced features also include tools to assist functional analysis: 

* Identify genomic features associates with the sRNA clusters (ie. to explore the RNA expression of sRNA-producing genes in parallel analysis)
* Extract consensus RNA sequence for target prediction analysis

<br>
<br>


# References 
Anders, Simon, Paul Theodor Pyl, and Wolfgang Huber. 2014. “HTSeq – A Python framework to work with high-throughput sequencing data.” Bioinformatics. http://dx.doi.org/10.1093/bioinformatics/btu638.

Axtell, MJ. 2013. “ShortStack: comprehensive annotation and quantification of small RNA genes.” Rna 19: 740–51. https://doi.org/10.1093/nar/gky316.

Danecek P, Liddle J, Bonfield JK. 2021. “Twelve years of SAMtools and BCFtools.” GigaScience 10. http://dx.doi.org/10.1186/s13059-014-0550-8.

Kim, Langmead, D. 2015. “HISAT: a fast spliced aligner with low memory requirements.” Nature Methods 12. https://www.nature.com/articles/nmeth.3317.

*Last updated:* 18-10-2023

- reduced_chr12_Eggplant.gff was obtained by downloading 
  Eggplant_V4.1_function_IPR_final.gff from 
  https://solgenomics.net/ftp/genomes/Solanum_melongena_V4.1/ in Octobter 2023,
  retaining only a few genomic features from chromosome 12 and 
  renaming the file.
  
- reduced_chr12_Eggplant.fa was obtained by downloading 
  Eggplant_V4.1.fa from 
  https://solgenomics.net/ftp/genomes/Solanum_melongena_V4.1/ in Octobter 2023,
  retaining only a section of the nucleotide sequence from chromosome 12 and 
  renaming the file.

- reduced_chr2_Tomato.gff was obtained by downloading 
  ITAG4.1_gene_models.gff from 
  https://solgenomics.net/ftp/tomato_genome/Heinz1706/annotation/ITAG4.1_release/
  in Octobter 2023,
  retaining only a few genomic features from chromosome 12 and 
  renaming the file.
  
- prefix_reduced_chr2_Tomato.gff was obtained by downloading 
  ITAG4.1_gene_models.gff from 
  https://solgenomics.net/ftp/tomato_genome/Heinz1706/annotation/ITAG4.1_release/
  in Octobter 2023,
  retaining only a few genomic features from chromosome 12 and 
  renaming the file. Contains "B_" prefix to chromosome names. 
  
- reduced_chr2_Tomato.fa was obtained by downloading 
  S_lycopersicum_chromosomes.4.00.fa from 
  https://solgenomics.net/ftp/tomato_genome/Heinz1706/assembly/build_4.00/
  in Octobter 2023, retaining only a section of the nucleotide sequence from 
  chromosome 12 and renaming the file.
  
  
- /mRNAseq/selfgraft_mRNAdemo_1.fq is a demo mRNAseq FASTQ file for a self-graft control 
  Eggplant (Solanum melongena). The original biological data file was taken from 
  the study Villanueva, G., Vilanova, S., Plazas, M., Prohens, J., & Gramazio, 
  P. (2023). Transcriptome profiles of eggplant (Solanum melongena) and its wild
  relative S. dasyphyllum under different levels of osmotic stress provide 
  insights into response mechanisms to drought. Current Plant Biology, 33, 
  100276. Accession number SRR10060529. This file was reduced in size to support 
  the workflow. 

- /mRNAseq/selfgraft_mRNAdemo_2.fq is a demo mRNAseq FASTQ file for a self-graft control 
  Eggplant (Solanum melongena). The original biological data file was taken from 
  the study Villanueva, G., Vilanova, S., Plazas, M., Prohens, J., & Gramazio, 
  P. (2023). Transcriptome profiles of eggplant (Solanum melongena) and its wild 
  relative S. dasyphyllum under different levels of osmotic stress provide 
  insights into response mechanisms to drought. Current Plant Biology, 33, 
  100276. Accession number SRR10060530. This file was reduced in size to support 
  the workflow. 

- /mRNAseq/heterograft_mRNAdemo_1.fq is a demo simulated mRNAseq FASTQ file for a 
  heterograft, simulating an Eggplant (Solanum melongena) scion and Tomato 
  (Solanum lycopersicum) rootstock. The original bioloigcal data for Eggplant 
  was taken from the study Villanueva, G., Vilanova, S., Plazas, M., Prohens, 
  J., & Gramazio, P. (2023). Transcriptome profiles of eggplant 
  (Solanum melongena) and its wild relative S. dasyphyllum 
  under different levels of osmotic stress provide insights into response 
  mechanisms to drought. Current Plant Biology, 33, 100276. Accession 
  number SRR10060529. The biological data for Tomato was taken from Tomato 
  Genome Consortium, X. (2012). The tomato genome sequence provides insights 
  into fleshy fruit evolution. Nature, 485(7400), 635. Accession number 
  SRR404309. This file was reduced in size to support the workflow. 

- /mRNAseq/heterograft_mRNAdemo_2.fq is a demo simulated mRNAseq FASTQ file for a 
  heterograft, simulating an Eggplant (Solanum melongena) scion and Tomato 
  (Solanum lycopersicum) rootstock. The original biological data for Eggplant 
  was taken from the study Villanueva, G., Vilanova, S., Plazas, M., Prohens, 
  J., & Gramazio, P. (2023). Transcriptome profiles of eggplant 
  (Solanum melongena) and its wild relative S. dasyphyllum 
  under different levels of osmotic stress provide insights into response 
  mechanisms to drought. Current Plant Biology, 33, 100276. Accession 
  number SRR10060530. The biological data for Tomato was taken from Tomato 
  Genome Consortium, X. (2012). The tomato genome sequence provides insights 
  into fleshy fruit evolution. Nature, 485(7400), 635. Accession number 
  SRR404309. This file was reduced in size to support the workflow. 


- /sRNAseq/selfgraft_demo_1.fq is a demo sRNAseq FASTQ file for a self-graft control 
  Eggplant (Solanum melongena). The original biological data file was taken
  from the study Li, B., Zhang, J., Gao, X., Pan, X., Zhou, R., & Wu, Y. (2022).
  Identification and Functional Analysis of MicroRNAs and Their Target Genes in 
  Reverse Thermosensitive Genic Male Sterility of Eggplant. Journal of the 
  American Society for Horticultural Science, 147(5), 249-259. Accession 
  number SRR17301403. This file was reduced in size to support the workflow. 

- /sRNAseq/selfgraft_demo_2.fq is a demo sRNAseq FASTQ file for a self-graft control 
  Eggplant (Solanum melongena). The original biological data file was taken
  from the study Li, B., Zhang, J., Gao, X., Pan, X., Zhou, R., & Wu, Y. (2022).
  Identification and Functional Analysis of MicroRNAs and Their Target Genes in 
  Reverse Thermosensitive Genic Male Sterility of Eggplant. Journal of the 
  American Society for Horticultural Science, 147(5), 249-259. Accession 
  number SRR17312491. This file was reduced in size to support the workflow. 

- /sRNAseq/selfgraft_demo_3.fq is a demo sRNAseq FASTQ file for a self-graft control 
  Eggplant (Solanum melongena). The original biological data file was taken
  from the study Li, B., Zhang, J., Gao, X., Pan, X., Zhou, R., & Wu, Y. (2022).
  Identification and Functional Analysis of MicroRNAs and Their Target Genes in 
  Reverse Thermosensitive Genic Male Sterility of Eggplant. Journal of the 
  American Society for Horticultural Science, 147(5), 249-259. Accession 
  number SRR17312490. This file was reduced in size to support the workflow. 


- /sRNAseq/heterograft_demo_1.fq is a demo simulated sRNAseq FASTQ file for a 
  heterograft, similuating an Eggplant (Solanum melongena) scion and Tomato 
  (Solanum lycopersicum) rootstock. The original biological data for Eggplant 
  was taken from the study Li, B., Zhang, J., Gao, X., Pan, X., Zhou, R., & Wu, 
  Y. (2022). Identification and Functional Analysis of MicroRNAs and Their 
  Target Genes in Reverse Thermosensitive Genic Male Sterility of Eggplant. 
  Journal of the American Society for Horticultural Science, 147(5), 249-259. 
  Accession number SRR17301403. The biological data for Tomato was taken from 
  Qing, Y., Zheng, Y., Mlotshwa, S., Smith, H. N., Wang, X., Zhai, X., ... & 
  Fei, Z. (2022). Dynamically expressed small RNAs, substantially driven by 
  genomic structural variants, contribute to transcriptomic changes during 
  tomato domestication. The Plant Journal, 110(6), 1536-1550. Accession number 
  SRR16077825. This file was reduced in size to support the workflow. 
  
- /sRNAseq/heterograft_demo_2.fq is a demo simulated sRNAseq FASTQ file for a 
  heterograft, similuating an Eggplant (Solanum melongena) scion and Tomato 
  (Solanum lycopersicum) rootstock. The original biological data for Eggplant 
  was taken from the study Li, B., Zhang, J., Gao, X., Pan, X., Zhou, R., & Wu, 
  Y. (2022). Identification and Functional Analysis of MicroRNAs and Their 
  Target Genes in Reverse Thermosensitive Genic Male Sterility of Eggplant. 
  Journal of the American Society for Horticultural Science, 147(5), 249-259. 
  Accession number SRR17312491. The biological data for Tomato was taken from 
  Qing, Y., Zheng, Y., Mlotshwa, S., Smith, H. N., Wang, X., Zhai, X., ... & 
  Fei, Z. (2022). Dynamically expressed small RNAs, substantially driven by 
  genomic structural variants, contribute to transcriptomic changes during 
  tomato domestication. The Plant Journal, 110(6), 1536-1550. Accession number 
  SRR16077825. This file was reduced in size to support the workflow. 


- /sRNAseq/heterograft_demo_3.fq is a demo simulated sRNAseq FASTQ file for a 
  heterograft, similuating an Eggplant (Solanum melongena) scion and Tomato 
  (Solanum lycopersicum) rootstock. The original biological data for Eggplant 
  was taken from the study Li, B., Zhang, J., Gao, X., Pan, X., Zhou, R., & Wu, 
  Y. (2022). Identification and Functional Analysis of MicroRNAs and Their 
  Target Genes in Reverse Thermosensitive Genic Male Sterility of Eggplant. 
  Journal of the American Society for Horticultural Science, 147(5), 249-259. 
  Accession number SRR17312490. The biological data for Tomato was taken from 
  Qing, Y., Zheng, Y., Mlotshwa, S., Smith, H. N., Wang, X., Zhai, X., ... & 
  Fei, Z. (2022). Dynamically expressed small RNAs, substantially driven by 
  genomic structural variants, contribute to transcriptomic changes during 
  tomato domestication. The Plant Journal, 110(6), 1536-1550. Accession number 
  SRR16077825. This file was reduced in size to support the workflow. 

#' Convert a `mobileRNA` dataframe to a SummarizedExperiment object 
#'
#'
#'@description 
#'Convert any `mobileRNA` output dataframe into a SummarizedExperiment object.
#'
#'@param data data.frame produced by the \pkg{mobileRNA} package. 
#'@param input character; must be either "sRNA" or "mRNA"
#'@details 
#'The function relies on the naming structure of columns created by functions
#'in the \pkg{mobileRNA} package. It is able to extract the sample names 
#'based on these additions, and organise the data appropriately. 
#'
#' @return A `SummarizedExperiment` object containing information from working 
#' data frame.  
#'
#'#'**For sRNAseq data** 
#'* The rownames contain the locus name and the cluster name. 
#'* The assays represent the additional information including DicerCall, Count, RPM, MajorRNA. 
#'* The rowData includes the Cluster ID, the DicerCounts & the DicerConsensus. 
#'* The colnames represents the sample replicate names.
#'
#'**For mRNAseq data** 
#'* The rownames contain the gene names.
#'* The assays represent the additional information including Count & FPKM. 
#'* The rowData includes the gene & the SampleCounts. 
#'* The colnames represents the sample replicate names.
#'
#'@examples
#' # load data.frame
#'data("sRNA_data")
#'
#'se <- RNAdf2se(input = "sRNA", data = sRNA_data)
#'
#'@export
#'@importFrom SummarizedExperiment SummarizedExperiment
#'@importFrom GenomicRanges GRanges
#'@importFrom IRanges IRanges
#'@importFrom S4Vectors DataFrame
#'@importFrom dplyr select
RNAdf2se <- function(input= c("sRNA", "mRNA"), data){
  if (base::missing(data)) {
    stop("data is missing. data must be an object of class matrix, data.frame, 
         DataFrame")
  }
  if (!base::inherits(data, c("matrix", "data.frame", "DataFrame"))) {
    stop("data must be an object of class matrix, data.frame, DataFrame")
  }
  if (missing(input) || !is.character(input)) {
    stop("style parameter is missing or not a character vector.")
  }
  
  # Check if input is one of the allowed values
  allowed_input <- c("sRNA", "mRNA")
  if (!input %in% allowed_input) {
    stop("input parameter must be one of 'sRNA' or 'mRNA'.")
  }
  
  if(input == "sRNA"){
    # create gene locations
    if("DicerCounts" %in% colnames(data)) {
      rowRanges <- GenomicRanges::GRanges(data$chr,
                                        IRanges::IRanges(as.numeric(data$start),
                                                          as.numeric(data$end)),
                                          Cluster = data$Cluster, 
                                          DicerCounts = data$DicerCounts,
                                          DicerConsensus= data$DicerConsensus)
    } else {
      rowRanges <- GenomicRanges::GRanges(data$chr,
                                        IRanges::IRanges(as.numeric(data$start),
                                                          as.numeric(data$end)),
                                          Cluster = data$Cluster)
    }
    
    # create table for the columns
    col_names <- colnames(data) # extract sample names 
    sample_names <- unique(vapply(base::strsplit(col_names, "_"), 
                                   function(x) paste(x[-1], collapse = "_"), 
                                  character(1))) 
    sample_names <- sample_names[nzchar(sample_names)] # remove empties
    
    colData <- S4Vectors::DataFrame(samples=sample_names,
                                    row.names=sample_names)
    
    
    # make matrix for all information 
    extra <- S4Vectors::DataFrame(data[, !names(data) %in% c("chr", "start",
                                                             "end", 
                                                             "Cluster", "Locus", 
                                                             "DicerCounts", 
                                                             "DicerConsensus"), 
                                       drop = FALSE])
    extra_vrs <-  gsub("^(.*?)_.*", "\\1", colnames(extra))
    extra_vrs_unique <- unique(extra_vrs)
    element_counts <- table(extra_vrs) # Count occurrences of each element
    occurrences_check <- all(element_counts == length(sample_names)) 
    # Check if all elements have same occurrences
    if(occurrences_check == FALSE){
      stop("data is missing information for all replicates")
    }
    assay_list <- list()
    # create matrix for each extra data and count  
    for(i in seq_along(extra_vrs_unique) ){
      extra_matrix <-as.matrix(data %>% dplyr::select(
        starts_with(extra_vrs_unique[i])))
      colnames(extra_matrix) <- NULL
      assay_list[[i]] <- extra_matrix
    }
    names(assay_list) <- extra_vrs_unique
    # create SummarizedExperiment object
    se <- SummarizedExperiment::SummarizedExperiment(assays= assay_list,
                                                     rowRanges=rowRanges, 
                                                     colData=colData)
    rownames(se) <- paste0(data$Locus, " (",data$Cluster, ")" )
  } else 
    if( input == "mRNA"){
      # create gene locations
      
      rowRanges <- GenomicRanges::GRanges(data$chr,
                                      IRanges::IRanges(as.numeric(data$start), 
                                                          as.numeric(data$end), 
                                                       as.numeric(data$width)),
                                          Gene = data$Gene, 
                                  SampleCounts = as.numeric(data$SampleCounts))
      
      # create table for the columns
      col_names <- colnames(data) # extract sample names 
      sample_names <- unique(vapply(base::strsplit(col_names, "_"), 
                                    function(x) paste(x[-1], collapse = "_"), 
                                    character(1))) 
      sample_names <- sample_names[nzchar(sample_names)] # remove empties
      
      colData <- S4Vectors::DataFrame(samples=sample_names,
                                      row.names=sample_names)
      
      
      # make matrix for all information 
      extra <- S4Vectors::DataFrame(data[, !names(data) %in% c("chr", "start", 
                                                               "end", 
                                                               "Gene", "Locus",
                                                               "width", 
                                                               "SampleCounts"), 
                                         drop = FALSE])
      extra_vrs <-  gsub("^(.*?)_.*", "\\1", colnames(extra))
      extra_vrs_unique <- unique(extra_vrs)
      element_counts <- table(extra_vrs) # Count occurrences of each element
      occurrences_check <- all(element_counts == length(sample_names)) 
      # Check if all elements have same occurrences
      if(occurrences_check == FALSE){
        stop("data is missing information for all replicates")
      }
      assay_list <- list()
      # create matrix for each extra data and count  
      for(i in seq_len(nrow(extra_vrs_unique))){
        extra_matrix <-as.matrix(data %>% dplyr::select(
          starts_with(extra_vrs_unique[i])))
        colnames(extra_matrix) <- NULL
        assay_list[[i]] <- extra_matrix
      }
      names(assay_list) <- extra_vrs_unique
      # create SummarizedExperiment object
      se <- SummarizedExperiment::SummarizedExperiment(assays= assay_list,
                                                       rowRanges=rowRanges, 
                                                       colData=colData)
      rownames(se) <- data$Gene 
    }
  return(se)
}

#' Define the consensus dicercall for each sRNA cluster
#'
#' @description The sRNA dicercall represents the length in nucleotides of the 
#' most abundant sRNA sequence within a cluster. The function calculates the 
#' consensus dicercall classification.
#'
#' @details
#' For each sample, the alignment/clustering step predicted the sRNA 
#' dicercall for each cluster. This value is stored in the columns starting 
#' with "DicerCall_".  This value represents the length of nucleotides of 
#' the most abundant sRNA within the cluster. For some clusters, there is no 
#' particular sRNA which is more abundant than another, hence, it is stated as 
#' "NA" or "N", which is referred to as unclassified. The `RNAdicercall()` 
#' function calculate the consensus dicercall for each sRNA cluster based on 
#' the values across replicates. There are several parameters which will alter
#' the output, including the handling of ties and the method to draw the 
#' consensus from. 
#'  
#' When ties.method = "random", as per default, ties are broken at random. 
#' In this case, the determination of a tie assumes that the entries are 
#' probabilities: there is a relative tolerance of 1e-5, relative to the 
#' largest (in magnitude, omitting infinity) entry in the row.
#' 
#' When ties.method = "exclude", ties between sRNA classification are ruled as 
#' unclassified ("N"). However, when there is a tie between the choice of a 
#' class or unclassified result the `exclude` option will always select the 
#' class choice over the unclassified result.
#'  
#' If users are working with a chimeric system, utilise the `chimeric=TRUE`
#' parameter and state `genome.ID` and `controls` parameter variables. This will
#' remove any potential mapping errors which could introduce false interpretation. 
#' 
#' To remove excess data noise, `tidy=TRUE` can be used to removed unclassified 
#' ("N") sRNA clusters, resulting in a reduced data set size. 
#' 
#' @param data data.frame; originally generated by [mobileRNA::RNAimport()].
#'
#' @param conditions character; vector containing sample replicate names. When 
#' supplied, the data from the named replicates will be the only ones used to 
#' calculate the dicercall consensus for each sRNA cluster. Each 
#' string should represent a sample name present in the dataframe supplied to
#' the `data` argument.
#'
#' @param tidy logical; tidy-up data by removing sRNA clusters with an unknown 
#' or unclassified result. Default setting \code{tidy=FALSE}, removes excess 
#' background noise. 
#'  
#' @param ties.method character; string specifying how ties are handled, choose
#' either "exclude" or "random". When using `random`, if there is a tie one of 
#' the classes will be chosen at random. While, when using `exclude` if there is 
#' a tie the class is set to undefined, however, if there is a tie between a 
#' undefined and a known class, the known class takes president (eg 3x24-nt and
#' 3xN-nt, then it will be classed as 24nt). Default setting 
#' `ties.method="exclude"`. 
#' 
#' 
#'@param chimeric logical; state whether the system is chimeric and contains 
#'multiple genomes/genotypes. 
#'
#'@param controls character; vector of control condition sample names. 
#'
#'@param genome.ID character; chromosome identifier of the genome representing 
#'either the origin of mobile molecules or the other genome in the chimeric 
#'system.
#'
#'@return The original input data with two additional columns appended known as
#'`DicerCounts` and `DicerConsensus`. The `DicerCounts` column stores the number 
#'of replicates that contributed to defining the consensus dicer-derived sRNA 
#'class. Note that when utilising the `exclude` ties methods, the `DicerCounts` 
#'will be represented as 0 when a tie is identified. While, the `DicerConsensus`
#'stores the consensus dicercall. 
#' 
#'
#'
#' @examples
#'  # load data 
#'  data("sRNA_data")
#'
#' # define consensus sRNA classes.
#' conditions <- c("heterograft_1", "heterograft_2", "heterograft_3")
#'
#' # Run function to define sRNA class for each cluster.
#' sRNA_data_dicercall <- RNAdicercall(data = sRNA_data,
#'                                   conditions = conditions,
#'                                   tidy=TRUE)
#'
#' @export
#' @importFrom dplyr %>%
#' @importFrom dplyr mutate
#' @importFrom dplyr filter
#' @importFrom tidyr replace_na
RNAdicercall <- function(data, conditions = NULL, ties.method = NULL, 
                         tidy = FALSE, chimeric = FALSE, controls = NULL, 
                         genome.ID = NULL) {
  if (base::missing(data)) {
    stop("data is missing. data must be an object of class matrix, data.frame, 
         DataFrame")
  }
  if (!base::inherits(data, c("matrix", "data.frame", "DataFrame"))) {
    stop("data must be an object of class matrix, data.frame, DataFrame")
  }
  if(is.null(ties.method)){
    ties.method <-  "exclude"
  }
  data[is.na(data)] <- "N"
  
  # remove mapping errors:
  if(chimeric){
    data <- .remove_mapping_errors_V2(data = data,controls = controls, 
                                      genome.ID = genome.ID)
  }
  
  class_colnames <- colnames(data)[grep("DicerCall_", colnames(data))]
  
  if (!is.null(conditions)) {
    message("Calculating consensus dicercall based on the select replicates...")
    onlyconditions <- base::unique(grep(paste(conditions, collapse = "|"), 
                                        class_colnames, value = TRUE))
  }
  else if (is.null(conditions)) {
    message("Calculating consensus dicercall based on all replicates...")
    onlyconditions <- class_colnames
  }
  # unique values across the dicer call columns 
  unique_vals <- unique(unlist(data[onlyconditions]))
  # rowsum of columsn. 
  for (value in unique_vals) {
    add_col <- paste0("nt_", value)
    data[add_col] <- rowSums(data[onlyconditions] == value)
  }
  
  # search columns based on location 
  t <- grep("^nt", base::names(data))
  
  if (ties.method == "random"){
    message("---The consensus dicercall will be choose at random in the case of a tie.")
    new_df <- data 
    new_df$DicerCounts <- apply(new_df[t], 1, max)
    new_df <- new_df %>% 
      dplyr::mutate(DicerConsensus = base::names(data)[t]
                    [max.col(data[t], ties.method = "random")* NA^(
                      rowSums(data[t]) ==0)]) %>%
      dplyr::mutate(DicerConsensus = tidyr::replace_na(DicerConsensus, "N")) 
    
  } else 
    if(ties.method == "exclude"){
    message("---The consensus dicercall will be excluded in the case of a tie.") 
      new_df <- data
      # Initialize result vector
      result <- vector("character", nrow(new_df))
      result[] <- "N"
      dicer_counts <- vector("character", nrow(new_df))
      dicer_counts[] <- "N"
      
      # For loop to check for two matching non-zero numbers within the same row
      for (i in seq_len(nrow(new_df)) ) {
        row_values <- new_df[t][i, ]
        if(rowSums(row_values) == 0){ # if no class across reps:
          classification <- "N"
          dicer_counts_val <- length(onlyconditions)
        } 
          non_zero_values <- as.numeric(row_values[row_values != 0])
          values_table <- table(non_zero_values)
          max_value <- max(non_zero_values)
          # Check if the maximum value is duplicated
          if (!is.na(values_table[max_value]) && values_table[max_value] > 1) {
            dicer_counts_val <- 0
            classification <- "N"
          } else {
            numeric_class <- names(row_values[, row_values[1, ] > 0, 
                                              drop = FALSE])
            max_value <- max(unlist(row_values))
            if(length(numeric_class) ==  1 ){ 
              # if there is only one class
              # and if it is the max acros other results
              classification <- numeric_class
              count_max <- max.col(row_values)
              dicer_counts_val<- as.numeric(row_values[,count_max])
            } else
              if(sum(unlist(row_values) == max_value) == 1){
                count_max <- max.col(row_values)
                classification <- colnames(row_values)[count_max]
                dicer_counts_val<- as.numeric(row_values[,count_max])
              } else 
            if(length(names(row_values[, row_values[1, ] > 0]))>= 2){
              if(sum(nchar(numeric_class)) > 10){
                # if tie between two different classes
                dicer_counts_val <- 0
                classification <- "N"
              } else {
                if(sum(nchar(numeric_class)) < 10){
                  # if tie with class and unclassed
                  index_longest <- which.max(nchar(numeric_class))
                  classification <- numeric_class[index_longest]
                  dicer_counts_val <- row_values[1, classification]
                }
              }
            } 
          }
        result[i] <- classification
        dicer_counts[i] <- dicer_counts_val
      }
      new_df$DicerCounts <- as.numeric(dicer_counts)
      new_df$DicerConsensus <- result
    } 
  # remove calulation columns 
   new_df <- new_df[, !grepl("^nt_", colnames(new_df))]
  # remove nt from output values
  new_df$DicerConsensus <- gsub("^nt_", "", new_df$DicerConsensus)
  
  if (tidy) {
    message("---Removing sRNA clusters with no consensus dicercall")
    new_df_tidy <- new_df %>% dplyr::filter(DicerConsensus != "N")
    return(new_df_tidy)
  }
  message("Complete!")
    return(new_df)
}

#' Identify putative RNA molecules produced by the non-tissue sample genome
#'
#' @description A function to identify the putative sRNA or mRNA  molecules
#' produced by the non-tissue sample genome. Includes putative RNA mobilome or
#' RNAs not expected to be found within the tissue of origin.
#'
#'@references
#' baymobil \url{https://doi.org/10.21203/rs.3.rs-2520491/v1}
#'
#'
#' @details
#' The function identifies candidate sRNAs or mRNAs produced by a specific
#' genome/genotype. It does so by either keeping or removing those mapped to a
#' given genome. To do so, it requires a common pre-fix across chromosomes of
#' the given genome. See[mobileRNA::RNAmergeGenomes()] for more information.
#' In addition, it removes RNAs which were likely to be falsely mapped. These
#' are those which were mapped to the non-tissue genotype in the control
#' samples.
#'
#' **For sRNAseq:**
#' A greater confidence in the sRNA candidates can be achieved by setting
#' a threshold that considers the number of replicates which contributed to
#' defining the consensus dicercall (ie. consensus sRNA classification). This
#' parameter filters based on the `DicerCounts` column introduced by the
#' [mobileRNA::RNAdicercall()] function.
#'
#' **For mRNAseq:**
#' A greater confidence in the mRNA candidates can be achieved by setting
#' a threshold that considers the number of replicates which contained reads
#' for the mRNA molecule. This parameter filters based on the `SampleCounts`
#' column introduced by the [mobileRNA::RNAimport()] function.
#'
#' Alternatively, utilize the `baymobil` algorithm, which identifies the mobile
#' mRNAs using exact Bayesian inference based on SNP variant information. This
#' option requires the user to input substantially more information. Please
#' be aware this option requires significant processing time (so, maybe get a
#' brew while this runs). Note that this option produces additional files, see
#' `Value` section for more details.
#'
#'
#' **Statistical Analysis**
#' The function also allows for filtering using statistical inference generated
#' from the differential analysis of the total data set using the function
#' [mobileRNA::RNAdifferentialAnalysis()]. When `statistical=TRUE`, the feature
#' is enabled and selects molecules that meet the adjusted p-value
#' cutoff defined by `alpha`.
#'
#'
#'
#' @param input character; must be either "sRNA" or "mRNA" to represent the type
#' of data.
#'
#' @param data data.frame; generated through the \pkg{mobileRNA} method.
#'
#' @param controls character vector; containing names of control samples.
#'
#' @param genome.ID character; string or chromosome identifier related to the
#' chromosomes in a given genome. A distinguishing feature of the genome of
#' interest or non-interest in the chromosome name (`chr` column).
#'
#' @param task character; string to set the method to keep or remove the
#' chromosomes containing the identifying string. To keep the chromosomes with
#' the ID, set task=keep. To remove, set `task="remove"`. As default, task is
#' set to `keep`.
#'
#' @param statistical If TRUE, will undertake statistical filtering based on the
#' a p-value or adjusted p-value threshold stated by `alpha`.Default
#' set at FALSE. Requires presence of columns containing statistical data.
#' In order to filter by the adjusted p-value, a column named `padjusted` must
#' be present. See [mobileRNA::RNAdifferentialAnalysis()] to calculate
#' statistical values.
#'
#' @param alpha numeric; adjusted p-value cutoff as the target FDR for
#' independent filtering. Default is 0.1. Only mobile molecules with adjusted
#' p-values equal or lower than specified are returned.
#'
#'@param threshold numeric; set a threshold level. For sRNA analysis, this
#'represents filtering by the minimum number of replicates that defined the
#' consensus dicercall which is stored in the `DicerCounts` column. While,
#' for mRNA analysis this represents the number of replicates which contained
#' reads for the mRNA molecule which is stored in the `SampleCounts` column.
#'
#'
#'
#' @return A data frame containing candidate mobile sRNAs or mRNAs, which could
#' have been further filtered based on statistical significance and the ability
#' to by-pass the thresholds which determine the number of replicates that
#' defined the consensus dicercall (sRNA) or contributed to reads counts (mRNA).
#'
#'
#' @examples
#'data("sRNA_data")
#'
#'
#' # vector of control names
#' controls <- c("selfgraft_1", "selfgraft_2" , "selfgraft_3")
#'
#' # Locate potentially mobile sRNA clusters associated to tomato, no
#' # statistical analysis
#' mobile_df1 <- RNAmobile(input = "sRNA", data =  sRNA_data,
#' controls = controls, genome.ID = "B_", task = "keep", statistical = FALSE)
#'
#'
#'
#' @export
#' @importFrom dplyr %>%
#' @importFrom dplyr filter
#' @importFrom dplyr select
#' @importFrom tidyselect starts_with
#' @importFrom dplyr case_when
RNAmobile <- function(input = c("sRNA", "mRNA"), data,
                      controls, genome.ID,
                      task = NULL,
                      statistical = FALSE,
                      alpha = 0.1,
                      threshold = NULL){
  if (base::missing(input)) {
    stop("Please specify a character vector of either `sRNA` or `mRNA`
                 to input parameter.")
  }

  if (!base::inherits(data, c("matrix", "data.frame", "DataFrame"))) {
    stop("data must be an object of class matrix, data.frame, DataFrame")
  }
  if (base::missing(controls) || !base::inherits(controls, "character")) {
    stop("Please specify a character vector storing names of control replicates")
  }
  if (base::missing(genome.ID) || genome.ID %in% "") {
    stop("Please specify a single character string which is present in
          the all the chromosomes within the genome you wish to keep or remove")
  }

    y <- data %>%
      dplyr::filter(dplyr::case_when(
        is.null(task) & base::grepl(genome.ID, chr) ~ TRUE,
        task == "remove" & !base::grepl(genome.ID, chr) ~ TRUE,
        task == "keep" & base::grepl(genome.ID, chr) ~ TRUE,
        TRUE ~ FALSE
      ))
    res <- .remove_mapping_errors(data = y, controls = controls)
    if (statistical) {
      res <- res %>% dplyr::filter(padjusted <= alpha)
    }
    if(!is.null(threshold)){
      if(input == "sRNA"){
        res <- res %>% filter(!DicerCounts < threshold)
      }
      if(input == "mRNA"){
        res <- res %>% filter(!SampleCounts < threshold)
      }
    }

    # remove zero values
    zero_count_rows <- rowSums(res[grep("^Count_", names(res))] == 0) == sum(grepl("^Count_", names(res)))

    # Subset the dataframe to remove rows with all zero values in "Count_" columns
    res_fin <- res[!zero_count_rows, ]

    return(res_fin)

}

#' Sample distance matrix 
#'
#'@description
#' Draws a simple hierarchical clustered heatmap to observe
#'sample distance.
#'
#'
#' @param data data.frame; originally generated by [mobileRNA::RNAimport()]
#' @param colours character; the colour palette. Default is 
#'` grDevices::colorRampPalette(RColorBrewer::brewer.pal(9, "GnBu"))(100)`
#' 
#' @param vst logical; to undertake variance stabilizing transformation. 
#' By default, the function uses a regularized log transformation on the data 
#' set, however, this will not suit all experimental designs.
#'
#'@param cellwidth numeric; individual cell width in points. Default is 40. 
#'
#'@param cellheight numeric; individual cell height in points. Default is 40. 
#'
#' @return A blue/green scale heatmap illustrating the sample distance.
#'
#' @details In special conditions, regularized log transformation will not suit
#' the experimental design. For example, an experimental design without
#' replicates. In this instance, it is preferable to change the default setting
#' and switch to a variance stabilizing transformation method (\code{vst=TRUE}).
#'
#'
#' @examples
#'
#' data("sRNA_data")
#' p1 <- plotSampleDistance(sRNA_data)
#'
#' @export
#' @importFrom DESeq2 rlog
#' @importFrom stats dist
#' @importFrom pheatmap pheatmap
#' @importFrom dplyr select
#' @importFrom grDevices colorRampPalette
#' @importFrom RColorBrewer brewer.pal
#' @importFrom grid unit
#' @importFrom grid gpar
plotSampleDistance <- function(data, 
                               colours = grDevices::colorRampPalette(rev(RColorBrewer::brewer.pal(9,"GnBu")))(255), 
                               vst = FALSE, cellheight = 40, cellwidth = 40){
  if (base::missing(data) || !base::inherits(data, c("data.frame"))) {
    stop("data must be an object of class data.frame containing raw count data")
  }

  data <- as.matrix(data %>% dplyr::select(tidyselect::starts_with("Count")))

  if(vst == TRUE){
    message("Transforming the count data with a variance stabilizing transformation...")
    rld <- DESeq2::varianceStabilizingTransformation(data, blind = TRUE)
    # log transform the data.
  } else
    if(vst == FALSE) {
      message("Transforming the count data to the log2 scale... \n")
      rld <- DESeq2::rlog(data, blind = TRUE) # log transform the data.
    }
  message("---Calculating distance matrix.")
  sample_names <- colnames(data)
  sample_names <- sub("Count_", "", sample_names)
  distance <- stats::dist(t(rld))
  distance_matrix <- as.matrix(distance)
  rownames(distance_matrix) <- paste(sample_names)
  colnames(distance_matrix) <- paste(sample_names)
  message("---Generating sample distance plot.")
  plot <- pheatmap::pheatmap(distance_matrix,
                             clustering_distance_rows = distance,
                             clustering_distance_cols = distance,
                             col = colours, 
                             angle_col = 45,
                             silent = TRUE,
                             cellheight=cellheight,
                             cellwidth=cellwidth) 
  
  plot$gtable$grobs[[4]]$gp <- grid::gpar(fontface = "bold") 
  plot$gtable$grobs[[5]]$gp <- grid::gpar(fontface = "bold")
  
  plot$gtable$widths[4] <-  plot$gtable$widths[4] + grid::unit(15, "bigpts")
  

  return(plot)
}

#' mobileRNA: Explore RNA mobilome & population-scale changes
#'
#' Uses small RNA or messenger RNA sequencing data in two conditions and 
#' identifies changes in the RNA population. `mobileRNA` was primarily designed
#' for the identification of a putative RNA mobilome in a chimeric system. For 
#' example, in plant graft systems. As input, `mobileRNA` takes sRNAseq or 
#' mRNAseq fastq files. Output consists of a data frame with putative 
#' differences between two conditions along with a number of plots. 
#'
#'
#' The most important functions in the \pkg{mobileRNA} are:
#' \describe{
#' \item{\code{\link{RNAmergeGenomes}}}{Merge two genome assembly files (FASTA).}
#'  \item{\code{\link{RNAmergeAnnotations}}}{Merge two genome annotation files
#'  (GFF).}
#'  \item{\code{\link{mapRNA}}}{Pre-processing of sRNAseq and mRNAseq 
#'  (alignment, raw count, cluster analysis).}
#'  \item{\code{\link{RNAimport}}}{Reads the pre-processing report files into a 
#'  dataframe for all conditions}
#'  \item{\code{\link{RNAdicercall}}}{Calculates the consensus sRNA 
#'  dicercall class.}
#'  \item{\code{\link{RNAsubset}}}{Subsets the data set based on the sRNA class.}
#'  \item{\code{\link{RNAdifferentialAnalysis}}}{Undertakes differential 
#'  analysis with either the edgeR or DESeq2 method.}
#'  \item{\code{\link{RNAmobile}}}{Identify putative RNA molecules produced by 
#'  the non-tissue sample genome}
#'  \item{\code{\link{RNApopulation}}}{Identify gained/lost RNA populations 
#'  between treatment and control conditions.}
#'  \item{\code{\link{RNAsummary}}}{Summarise the differential abundance of 
#'  RNAs.}
#'   \item{\code{\link{RNAreorder}}}{Reorder the data frame for differential 
#'   analysis, ensuring control verse treatment comparison.}
#'  \item{\code{\link{RNAsequences}}}{Extract RNA sequence from sRNA clusters.}
#'  
#'  \item{\code{\link{RNAattributes}}}{Overlap the genomic features related to 
#'  the sRNA clusters.}
#'  \item{\code{\link{RNAdistribution}}}{Plot the distribution of sRNA classes 
#'  based on nucleotide length.}
#'  \item{\code{\link{plotHeatmap}}}{Heatmap of log-transformed normalization 
#'  data.}
#'  \item{\code{\link{plotSampleDistance}}}{Plots a sample distance heatmap for
#'  quality control.}
#'  \item{\code{\link{plotSamplePCA}}}{Plots a PCA plot, customize ratio, 
#'  colours and shapes.}
#'  \item{\code{\link{RNAfeatures}}}{Summarise the distribution of sRNA clusters 
#'  across genomic features.}
#'  \item{\code{\link{RNAdf2se}}}{Convert a `mobileRNA` dataframe to a 
#'  SummarizedExperiment object. }
#' }
#'
#' @rdname mobileRNA-package
#' @name mobileRNA
#' @keywords internal
#' @aliases mobileRNA-package mobileRNA
#' @docType package
#' @author
#' Katie Jeynes-Cupper \email{kej031@@student.bham.ac.uk},
#' Marco Catoni \email{m.catoni@@bham.ac.uk}
#' Maintainer: Katie Jeynes-Cupper \email{kej031@@student.bham.ac.uk}
#' @seealso See \code{vignette("mobileRNA", package = "mobieRNA")} for an 
#' overview of the package.
"_PACKAGE"
## usethis namespace: start
## usethis namespace: end
NULL



#' @name sRNA_data
#' @title sRNA_data: simulated data for biological replicates
#' @docType data
#' @usage data(sRNA_data)
#' @description Simulated sRNAseq dataset
#' @return Dataframe in global environment 
#' @details Simulates data is taken from eggplant and tomato sRNAseq samples and
#' created to simulate to movement of sRNA molecules from an Tomato rootstock to
#' an Eggplant Scion. Three Eggplant replicates were spiked with the same 150
#' tomato sRNA clusters, and named "heterograft_" 1 to 3. The analysis compares
#' these heterografts to three Eggplant self-grafts which are the original
#'  un-spiked Eggplant replicates, called "selfgraft_" 1 to 3. 
#'  
#'  This data was imported and organised by the [RNAimport()] function. 
#' @examples
#'  data("sRNA_data")
NULL


#' @name mRNA_data
#' @title mRNA_data: simulated messenger RNA data for biological replicates
#' @docType data
#' @usage data(mRNA_data)
#' @description Simulated mRNAseq dataset
#' @return Dataframe in global environment 
#' @details Simulates data is taken from eggplant and tomato mRNAseq samples and
#' created to simulate to movement of mRNA molecules from an Tomato rootstock to
#' an Eggplant Scion. Two Eggplant replicates were spiked with the same 150
#' tomato mRNA clusters, and named "heterograft_" 1 to 2. The analysis compares
#' these heterografts to two Eggplant self-grafts which are the original
#'  un-spiked Eggplant replicates, called "selfgraft_" 1 to 2. 
#'  
#'  This data was imported and organised by the [RNAimport()] function. 
#' @examples
#'  data("mRNA_data")
NULL

#' Identify gained/lost RNA populations between treatment and control conditions
#'
#' @description Identify unique sRNA or mRNA populations within a set of 
#' samples, typically within the same condition, compared to the other samples 
#' in the analysis. This can be known as lost or gained populations due to 
#' a treatment. 
#'
#' @details
#' The function selects RNA which are unique to a given
#' condition and absent in the samples within the other condition(s). 
#' For instance, a treatment might encourage the production of unique sRNAs 
#' which are not produced in the control samples. The function can also select
#' the unique populations which show statistical significance, based on a 
#' adjusted p-value cutoff. This must have been calculated previously, see 
#' [mobileRNA::RNAdifferentialAnalysis()] function. 
#'
#' If users are working with a chimeric system, utilise the `chimeric=TRUE`
#' parameter and state `genome.ID` and `controls` parameter variables. This will
#' remove any potential mapping errors which could lead to false 
#' interpretation. 
#' 
#' 
#' @param data data.frame; generated by [mobileRNA::RNAimport()]
#'
#' @param conditions character; containing names of samples within 
#' conditions to locate unique sRNA clusters. 
#'
#' @param statistical logical; If TRUE, will undertake statistical filtering 
#' based on the adjusted p-value cutoff stated by `alpha`. 
#' Default setting `statistical=FALSE`. Requires presence of columns 
#' containing statistical data. To filter by the adjusted p-value, a 
#' column named `padjusted` must be present. See 
#' [mobileRNA::RNAdifferentialAnalysis()] to calculate statistical values.
#'
#' @param alpha numeric; user-defined numeric value to represent the adjusted 
#' p-value threshold to define statistical significance. Defaults setting 
#' `alpha=0.05`. Returns sRNA clusters or mRNA with adjusted p-values equal 
#' or lower than the threshold value.
#'
#'@param chimeric logical; state whether system is chimeric containing multiple 
#'genomes/genotypes. 
#'
#'@param controls character; vector of control condition sample names. 
#'
#'@param genome.ID character; chromosome identifier of the genome representing 
#'either the origin of mobile molecules or the other genome in the chimeric 
#'system.
#'
#'@param dual logical; works in corporation when `chimeric=TRUE` and removes 
#'sRNA clusters mapped to the genome of mobile molecules. 
#'
#' @return A subset of the supplied data and prints summary metric of 
#' results including:
#' 
#' - the total number of sRNA clusters or mRNA in the data set 
#' - the number & percentage of unique sRNA clusters or mRNA to your condition
#' - the samples in the condition
#'
#' @examples
#'
#' data("sRNA_data")
#'
#' # Select sRNA clusters only in the heterograft samples (ie. treatment)
#' 
#' heterograft_pop <- RNApopulation(data = sRNA_data, 
#'                                  conditions = c("heterograft_1", 
#'                                                 "heterograft_2", 
#'                                                 "heterograft_3"))
#' @export
#' @importFrom dplyr %>%
#' @importFrom dplyr filter
#' @importFrom dplyr select
#' @importFrom tidyselect starts_with
#' @importFrom stats na.omit
RNApopulation <- function(data,conditions,statistical = FALSE,alpha = 0.05,
                          chimeric = FALSE, controls = NULL, 
                          genome.ID = NULL, dual = TRUE){
  
  if (!base::inherits(data, c("matrix", "data.frame", "DataFrame"))) {
    stop("data must be an object of class matrix, data.frame, DataFrame")
  }
  if (base::missing(conditions) || !base::inherits(conditions, "character")) {
    stop("Please specify a character vector storing names of control
               replicates")
  }
  
  conditions_cols <-  data %>% dplyr::select(paste0("Count_", conditions))
  opposite_cols <- data %>% 
    dplyr::select(dplyr::starts_with("Count_")) %>%
    dplyr::select(!colnames(conditions_cols))
  if(chimeric){
    data <- .remove_mapping_errors_V2(data = data,controls = controls, 
                                      genome.ID = genome.ID)
    if(dual == FALSE){
      data <- data %>% dplyr::filter(!grepl(genome.ID,chr))
    }
  } 
  if(chimeric == FALSE && !is.null(genome.ID)){
    data <- data %>% dplyr::filter(!grepl(genome.ID,chr))
  }
  output <- data[0,]
  for(i in seq_len(nrow(data))){
    sum_conditions <- sum(stats::na.omit(as.numeric(data[
      i,colnames(conditions_cols)],na.rm=TRUE)))
    sum_opposite <- sum(stats::na.omit(as.numeric(data[
      i,colnames(opposite_cols)],na.rm=TRUE)))
    if(sum_opposite == 0 && sum_conditions > 0){
      output <- rbind(output, data[i,])
      }
  }
    if (statistical) {
      if (!"padjusted" %in% colnames(res)) {
        stop("Column 'padjusted' not found in the data frame.
         Please refer to the vignette.")
      }
        res <- output %>% filter(padjusted <= alpha)
        # stats
        n_up <- sum(res[, "log2FoldChange"] > 0)
        n_down <- sum(res[, "log2FoldChange"] < 0)
        percent_up <- (n_up / nrow(res)) * 100
        percent_down <- (n_down / nrow(res)) * 100
        percent <- (nrow(res) / nrow(conditions_cols)) * 100
        
        out <- c(
          paste("Comparison :" ,unique(res$comparision.order), "\n"),
          paste("out of", nrow(conditions_cols), "sRNA clusters in the dataset \n"),
          paste("adjusted p-value < ", alpha),
          paste("unique sRNA clusters :", nrow(res),",", round(percent, 1), "% \n"),
          paste("samples :", paste(conditions, collapse = ", "),"\n", "\n" ),
          paste("LFC > 0 (higher) :", n_up, ",", round(percent_up, 1), "%"),
          paste("LFC < 0 (lower)  :", n_down, ",", round(percent_down, 1), "%"))
          
    } else
      if (statistical == FALSE){
        res <- output
        # stats
        if ("log2FoldChange" %in% colnames(res)){
          n_up <- sum(res[, "log2FoldChange"] > 0)
          n_down <- sum(res[, "log2FoldChange"] < 0)
          percent_up <- (n_up / nrow(res)) * 100
          percent_down <- (n_down / nrow(res)) * 100
          percent <- (nrow(res) / nrow(conditions_cols)) * 100
          
          out <- c(
            paste("Comparison :" ,unique(res$comparision.order), "\n"),
            paste("out of", nrow(conditions_cols), "sRNA clusters in the dataset \n"),
            paste("unique sRNA clusters :", nrow(res),",", round(percent, 1), "% \n"),
            paste("samples :", paste(conditions, collapse = ", "),"\n" ),
            paste("--- No statistical cutoff was implemented.", "\n", "\n"),
            paste("LFC > 0 (higher) :", n_up, ",", round(percent_up, 1), "%"),
            paste("LFC < 0 (lower)  :", n_down, ",", round(percent_down, 1), "%"))
          
        } else 
          if (!"log2FoldChange" %in% colnames(res)){
            percent <- (nrow(res) / nrow(conditions_cols)) * 100
            
            out <- c(
              paste("Comparison :" ,unique(res$comparision.order), "\n"),
              paste("out of", nrow(conditions_cols), "sRNA clusters in the dataset \n"),
              paste("unique sRNA clusters :", nrow(res),",", round(percent, 1), "% \n"),
              paste("samples :", paste(conditions, collapse = ", "),"\n" ),
              paste("--- No statistical cutoff was implemented."))
              
          }
      }
  
  methods::show(cat(out, collapse = " "))
  return(res)
}

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  fig.align='center',
  external=TRUE,
  echo=TRUE,
  warning=FALSE,
  comment = "#>"
)


## ----echo=FALSE---------------------------------------------------------------
cap01<-"Comprehensive diagram of complete mobileRNA workflows. "

## ----fig.align="centre", echo=FALSE, fig.cap=cap01----------------------------
knitr::include_graphics("../man/figures/mobileRNA_graphic_2.png")

## ----eval=FALSE, message=FALSE------------------------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("mobileRNA")

## ----eval=FALSE, message=FALSE------------------------------------------------
# if (!require("devtools")) install.packages("devtools")
# devtools::install_github("KJeynesCupper/mobileRNA", ref = "main")

## ----message=FALSE------------------------------------------------------------
library("mobileRNA")

## ----Load, message=FALSE------------------------------------------------------
# Load small RNA data
data("sRNA_data")

# Load messenger RNA data
data("mRNA_data")

## ----message=FALSE------------------------------------------------------------
fasta_1 <- system.file("extdata","reduced_chr12_Eggplant.fa.gz", 
                       package="mobileRNA")

fasta_2 <-system.file("extdata","reduced_chr2_Tomato.fa.gz",
                      package="mobileRNA")
# define temporary output directory - replace with your directory
output_assembly_file <- file.path(tempfile("merged_assembly", 
                                           fileext = ".fa"))

# merge
merged_reference <- RNAmergeGenomes(genomeA = fasta_1,
                                    genomeB = fasta_2,
                                    output_file = output_assembly_file)

## ----message=FALSE------------------------------------------------------------
anno1 <- system.file("extdata","reduced_chr12_Eggplant.gff.gz",
                     package="mobileRNA")

anno2 <- system.file("extdata","reduced_chr2_Tomato.gff.gz", 
                     package="mobileRNA")

# define temporary output directory 
output_annotation_file <- file.path(tempfile("merged_annotation", 
                                             fileext = ".gff3"))

# merge annotation files into a single file
merged_annotation <- RNAmergeAnnotations(annotationA = anno1,
                                         annotationB = anno2,
                                         output_file = output_annotation_file)

## ----eval=FALSE---------------------------------------------------------------
# # directory containing only sRNAseq samples
# samples <- system.file("extdata/sRNAseq",package="mobileRNA")
# 
# # output location
# output_location <- tempdir()
# 
# mapRNA(input = "sRNA",
#        input_files_dir = samples,
#        output_dir = output_location,
#        genomefile = output_assembly_file,
#        condaenv = "/Users/user-name/miniconda3/envs/ShortStack4",
#        mmap = "n")

## ----eval=FALSE---------------------------------------------------------------
# # Directory containing results
# results_dir <-  file.path(output_location,"2_sRNA_results")
# 
# # Sample names and total number of reads, in the same order.
# sample_names <- c("selfgraft_demo_1", "selfgraft_demo_2",
#                   "selfgraft_demo_3", "heterograft_demo_1",
#                   "heterograft_demo_2", "heterograft_demo_3")
# 
# 
# sRNA_data_demo <- RNAimport(input = "sRNA",
#                             directory = results_dir,
#                             samples = sample_names)

## -----------------------------------------------------------------------------
data("sRNA_data")

## ----message=FALSE------------------------------------------------------------
# define control samples
controls <- c("selfgraft_1", "selfgraft_2", "selfgraft_3")

mobile_sRNA <- RNAmobile(input = "sRNA",
                         data = sRNA_data, 
                         controls = controls,
                         genome.ID = "B",
                         task = "keep")

## ----eval=FALSE---------------------------------------------------------------
# # save output as txt file
# write.table(mobile_sRNA, "./sRNA_mobile_output.txt")

## ----echo=FALSE---------------------------------------------------------------
cap1 <- "An example facet line graph to show the distribution of sRNA classes within each sample."
cap2 <- "An example facet bar graph to show the distribution of sRNA classes within each sample."

## -----------------------------------------------------------------------------
# plot each replicate as a line, separately, and facet 
sample_distribution_line <- RNAdistribution(sRNA_data,
                                            style = "line",
                                            overlap =  FALSE, 
                                            facet = TRUE,
                                            colour = "darkgreen")

                                            
 # plot each replicate as a bar, separately, and facet 
sample_distribution_bar <- RNAdistribution(sRNA_data,
                                           style = "bar",
                                           facet = TRUE,
                                           colour ="lightblue")

## ----fig.cap=cap1, fig.show="hold", fig.height=10, fig.width=15---------------
# View plot (only)
sample_distribution_line$plot

## ----fig.cap=cap2, fig.show="hold", fig.height=10, fig.width=15---------------
# View plot (only)
sample_distribution_bar$plot

## ----echo=FALSE---------------------------------------------------------------
cap4 <-"An example of a PCA, illustrating  the sRNA data set sample similarity"

## ----message=FALSE, fig.cap=cap4, fig.show="hold", fig.height=8, fig.width=15----
groups <- c("Heterograft", "Heterograft", "Heterograft",
            "Selfgraft", "Selfgraft", "Selfgraft")

 plotSamplePCA(data = sRNA_data, group = groups, size.ratio = 2)

## ----echo=FALSE---------------------------------------------------------------
cap5 <-"An example of a heatmap, illustrating the sRNA data set sample similarity"


## ----message=FALSE, fig.cap=cap5, fig.show="hold"-----------------------------
plotSampleDistance(sRNA_data)

## ----message=FALSE------------------------------------------------------------
# define consensus, store as a data summary file.
sRNA_data_dicercall <- RNAdicercall(data = sRNA_data, 
                                     chimeric = TRUE, 
                                     genome.ID = "B_", 
                                     controls = c("selfgraft_1", 
                                                  "selfgraft_2", 
                                                  "selfgraft_3"))

## ----message=FALSE------------------------------------------------------------
# Subset data for analysis: 24-nt sRNAs
sRNA_24 <- RNAsubset(sRNA_data_dicercall, class = 24)

# Subset data for analysis: 21/22-nt sRNAs
sRNA_2122 <- RNAsubset(sRNA_data_dicercall, class = c(21, 22))

## ----message=FALSE------------------------------------------------------------
consensus_plot <- RNAdistribution(data = sRNA_data_dicercall,
                                  style = "bar",
                                  data.type = "consensus")

## ----echo=FALSE---------------------------------------------------------------
cap6<-"An example of the distribution of small RNA consensus dicer classifications. "

## ----fig.cap=cap6, fig.height=10, fig.width=15--------------------------------
# view 
consensus_plot$plot

## ----message=FALSE------------------------------------------------------------
#reorder df
controls <- c("selfgraft_1", "selfgraft_2", "selfgraft_3")
reorder_df <- RNAreorder(sRNA_data_dicercall, controls)

# sample conditions in order within dataframe
groups <- c("Selfgraft", "Selfgraft", "Selfgraft", 
            "Heterograft", "Heterograft", "Heterograft")

## Differential analysis of whole dataset: DESeq2 method 
sRNA_DESeq2 <- RNAdifferentialAnalysis(data = reorder_df,
                              group = groups,
                              method = "DESeq2")

## ----results='asis'-----------------------------------------------------------
RNAsummary(sRNA_DESeq2)
 

## ----results='asis'-----------------------------------------------------------
RNAsummary(sRNA_DESeq2, alpha=0.05)


## ----eval = FALSE-------------------------------------------------------------
# write.table(sRNA_DESeq2, "./sRNA_core_dataset.txt")

## ----fig.show="hold"----------------------------------------------------------
# summary of statistical sRNA clusters
RNAsummary(sRNA_DESeq2, alpha=0.05)

# select significant 
significant_sRNAs <-  sRNA_DESeq2[sRNA_DESeq2$padjusted < 0.05, ]

## ----echo = FALSE-------------------------------------------------------------
capp1 <- "Heatmap of statistically significant sRNA clusters"

## ----fig.show="hold", message=FALSE-------------------------------------------
p1 <- plotHeatmap(significant_sRNAs, value = "RPM", row.names = FALSE,
                  title = "Heatmap of log-transformed FPKM")

## ----fig.show="hold", message=FALSE, fig.cap=capp1----------------------------
p1$plot

## ----message=FALSE------------------------------------------------------------
# select sRNA clusters only found in treatment & not in the control samples
gained_sRNA <- RNApopulation(data = sRNA_DESeq2, 
                                  conditions = c("heterograft_1", 
                                                 "heterograft_2" , 
                                                 "heterograft_3"),
                                  chimeric = TRUE, 
                                  genome.ID = "B_", 
                                  controls = c("selfgraft_1",
                                               "selfgraft_2", 
                                               "selfgraft_3"))

# look at number of sRNA cluster only found in treatment 
nrow(gained_sRNA)

## ----message=FALSE------------------------------------------------------------
# select sRNA clusters only found in control & not in the treatment samples
lost_sRNA <- RNApopulation(data = sRNA_DESeq2, 
                                conditions = c("selfgraft_1", 
                                               "selfgraft_2" , 
                                               "selfgraft_3"), 
                                  chimeric = TRUE, 
                                  genome.ID = "B_", 
                                  controls = c("selfgraft_1",
                                               "selfgraft_2", 
                                               "selfgraft_3"))
# look at number of sRNA cluster only found in control  
nrow(lost_sRNA)

## ----message=FALSE------------------------------------------------------------
gained_sRNA_sequences <- RNAsequences(gained_sRNA, method = "consensus" )

## ----message=FALSE------------------------------------------------------------
gained_sRNA_attributes <- RNAattributes(data = gained_sRNA, 
                                        match ="genes",
                            annotation = output_annotation_file)

## ----message=FALSE------------------------------------------------------------
# vector of control names
control_names <- c("selfgraft_1", "selfgraft_2", "selfgraft_3")


## Identify potential tomato mobile molecules
mobile_sRNA <- RNAmobile(input = "sRNA",
                        data = sRNA_DESeq2, 
                         controls = control_names,
                         genome.ID = "B_",
                         task = "keep", 
                         statistical = FALSE)

## ----echo=FALSE---------------------------------------------------------------
cap7 <- "An example heatmap of candidate mobile small RNAs. Where the columns represent the sample replicates and the rows represent the small RNA cluster."


## ----fig.cap=cap7, fig.show="hold" , message=FALSE----------------------------
p2 <- plotHeatmap(mobile_sRNA, row.names = FALSE)

p2$plot

## ----eval = FALSE-------------------------------------------------------------
# write.table(mobile_sRNA, "./candidate_mobile_sRNAs.txt")

## -----------------------------------------------------------------------------
annotation_file <- system.file("extdata",
                     "prefix_reduced_chr2_Tomato.gff", 
                     package="mobileRNA")

mobile_attributes <- RNAattributes(data = mobile_sRNA, 
                                      match ="genes",
                                      annotation = annotation_file)



## -----------------------------------------------------------------------------
mobile_features <- RNAfeatures(data = mobile_sRNA, 
                               annotation = annotation_file)
print(mobile_features)

# plot as stacked bar chart
features_plot <- plotRNAfeatures(data = mobile_sRNA,  
                                 annotation = annotation_file)

plot(features_plot)

## ----message=FALSE------------------------------------------------------------
mobile_sequences <- RNAsequences(mobile_sRNA, method = "consensus") 

## ----eval = FALSE-------------------------------------------------------------
# write.table(mobile_sequences, "./candidate_mobile_sRNA_sequences.txt")

## ----message=FALSE------------------------------------------------------------
# load `dplyr` package
library(dplyr)

# select the cluster and sequence columns 
sequences <- mobile_sequences %>% select(Cluster, Sequence)

# add prefix, remove row with NA
prefix <- ">"
sequences$Cluster <- paste0(prefix, sequences$Cluster)
sequences <- na.omit(sequences)

# convert to required format:
res <- do.call(rbind, lapply(seq(nrow(sequences)), 
                             function(i) t(sequences[i, ])))

## ----eval = FALSE, message=FALSE----------------------------------------------
# # save output
# write.table(res, file ="./mobile_sRNA_sequences.txt",
#             row.names = FALSE, col.names = FALSE, quote = FALSE)

## ----eval = FALSE-------------------------------------------------------------
# # load `bioseq` package
# library(bioseq)
# 
# # build a RNA vector from a character vector:
# mobileRNA_seq <- bioseq::rna(mobile_sequences$Sequence)
# 
# # Find a consensus sequence for a set of sequences:
# bioseq::seq_consensus(mobileRNA_seq)

## ----eval=FALSE---------------------------------------------------------------
# # names of samples, represented by folder names produced in previous step
# samples <- c("[sample names]")
# 
# # location of output folders from previous step
# dir <- "[output_dir]"
# 
# # merge information of the detected de novo sRNA clusters
# gff_alignment <- GenomicRanges::GRangesList()
# for (i in samples) {
#   file_path <- file.path(dir, i, "Results.gff.gz3")
#   if (file.exists(file_path)) {
#     gff_alignment[[i]] <- rtracklayer::import.gff(file_path)
#   } else{
#     Stop("File does not exist:", file_path, "\n")
#   }
# }
# 
# gff_merged <- GenomicRanges::reduce(unlist(gff_alignment),
#                                     ignore.strand = TRUE)
# 
# gff_merged <- as.data.frame(gff_merged)
# colnames(gff_merged)[1] <- "chr"
# if('*' %in% gff_merged$strand){
#     gff_merged <- gff_merged[, -match("strand", colnames(gff_merged))]
#   }
# 
# locifile_txt <- data.frame(Locus = paste0(gff_merged$chr, ":",
#                                           gff_merged$start,"-",
#                                           gff_merged$end),
#                            Cluster = paste0("cluster_",
#                                             seq_len(nrow(gff_merged))))
# 
# # save output to location
# dir_locifile <- "[output directory]"
# loci_out <- file.path(dir_locifile,"locifile.txt")
# utils::write.table(locifile_txt, file = loci_out, quote = FALSE,
#                    sep = "\t", row.names = FALSE, col.names = TRUE)
# 

## ----eval=FALSE---------------------------------------------------------------
# # names of samples, represented by folder names produced in previous step
# samples <- c("[sample names]")
# 
# # location of output folders from previous step
# dir <- "[output_dir]"
# 
# # merge information of the detected de novo sRNA clusters
# gff_alignment <- GenomicRanges::GRangesList()
# for (i in samples) {
#   file_path <- file.path(dir, i, "Results.gff.gz3")
#   if (file.exists(file_path)) {
#     gff_alignment[[i]] <- rtracklayer::import.gff(file_path)
#   } else{
#     Stop("File does not exist:", file_path, "\n")
#   }
# }
# 
# gff_merged <- GenomicRanges::reduce(unlist(gff_alignment),
#                                     ignore.strand = TRUE)
# 
# gff_merged <- as.data.frame(gff_merged)
# colnames(gff_merged)[1] <- "chr"
# if('*' %in% gff_merged$strand){
#     gff_merged <- gff_merged[, -match("strand", colnames(gff_merged))]
#   }
# 
# locifile_txt <- data.frame(Locus = paste0(gff_merged$chr, ":",
#                                           gff_merged$start,"-",
#                                           gff_merged$end),
#                            Cluster = paste0("cluster_",
#                                             seq_len(nrow(gff_merged))))
# 
# # save output to location
# dir_locifile <- "[output directory]"
# loci_out <- file.path(dir_locifile,"locifile.txt")
# utils::write.table(locifile_txt, file = loci_out, quote = FALSE,
#                    sep = "\t", row.names = FALSE, col.names = TRUE)

## -----------------------------------------------------------------------------
sessionInfo()

#' Differential Analysis using `DESeq2` or `edgeR`
#'
#' @description `RNAdifferentialAnalysis` function computes the differential 
#' analysis with `DESeq2` or `edgeR` of sRNA or mRNA data produced by the 
#' `mobileRNA` package pipeline.  
#'
#' @param data data.frame; originally generated by [mobileRNA::RNAimport()].
#'
#' @param group character; the condition of each sample in the experimental 
#' design, formatted in the order of samples shown in the `data` object from 
#' left to right.
#'
#' @param method character; method to undertaken differential analysis, choose 
#' from methods of either [DESeq2::DESeq] or [edgeR::edgeR].
#' Must be stated as either "DESeq2" or "edgeR" in the function.
#'
#' @param dispersionValue numeric; value to represent the dispersion value for
#' the [edgeR::edgeR] method. Recommended for analysis in experiments without 
#' biological replicates. 
#'
#' @return Undertakes differential analysis, based on a specified method, and
#' appends the results to the supplied data frame. This includes:
#' * Count mean 
#' * Log fold change
#' * p-value
#' * Adjusted p-value
#' * Comparison order 
#'
#' @details The user has the flexibility to choose the method that best suits
#' their data. In this function, the `DESeq2` method, calculates the 
#' differentials based on the normalized count data based on the 
#' size factors. Whereas the `edgeR` method, calculates normalization factors
#' estimates dispersion, and returns the common dispersion. After
#' normalization, the mean expression levels across samples are calculated, and 
#' differential expression analysis is performed using the exact test 
#' within groups, and the adjusted p-values are calculated using the 
#' Benjamini-Hochberg method. Note that this function is only capable of 
#' handling one replicate per condition with the `edgeR` method. This requires 
#' setting a suitable dispersion value. The dispersion value is other wise known 
#' as the common Biological squared coefficient of variation. See the 
#' User’s Guide for the `edgeR` package for more details, [edgeR::edgeR].
#'
#' @examples
#'# load data 
#' data("sRNA_data")
#' 
#' 
#'# sample conditions.
#'groups <- c("Selfgraft", "Selfgraft", "Selfgraft", "Heterograft", "Heterograft", "Heterograft")
#'
#'
#'## Differential analysis: DEseq2 method
#'sRNA_DESeq2 <- RNAdifferentialAnalysis(data = sRNA_data,
#'                              group = groups,
#'                              method = "DESeq2" )
#'
#'
#'## Differential analysis: edgeR method
#'sRNA_edgeR <- RNAdifferentialAnalysis(data = sRNA_data,
#'                             group = groups,
#'                             method = "edgeR" )
#' @export
#' @importFrom DESeq2 results
#' @importFrom DESeq2 DESeq
#' @importFrom stats relevel
#' @importFrom edgeR exactTest
#' @importFrom stats p.adjust
#' @importFrom dplyr select
#' @importFrom tidyselect starts_with
#' @importFrom dplyr mutate_at
#' @importFrom tidyr replace_na
#' @importFrom DESeq2 DESeqDataSetFromMatrix
#' @importFrom DESeq2 estimateSizeFactors
#' @importFrom edgeR DGEList
#' @importFrom edgeR calcNormFactors
#' @importFrom edgeR estimateDisp

RNAdifferentialAnalysis <- function(data, group, 
                                    method = c("edgeR", "DESeq2"),
                                    dispersionValue = NULL){
  if (base::missing(data) || !base::inherits(data,  "data.frame")) {
    stop("Please specify a data frame")
  }
  if (base::missing(method) || !method %in% c("edgeR", "DESeq2")) {
    stop("Please specify analysis method", "(\"edgeR\", or \"DESeq2\")")
  }
  if ( is.null(group) || !base::inherits(group, "character")) {
    stop("group must be an vector of characters to specify the treatment
         and control conditions for each replicate")
  }
  counts <- data %>% dplyr::select(tidyselect::starts_with("Count"))
  method <- base::match.arg(method)
  if(method == "edgeR"){
    message("Undertaking differential analysis with the edgeR method..")
    res <-  .edgeR_normalise(counts, group)
    if(is.null(dispersionValue)){
      mean <- rowMeans(res$counts)
      groupConditions <- unique(group)
      comp <- edgeR::exactTest(res, pair= groupConditions)
      comp <- base::cbind(comp$table, padj=stats::p.adjust(comp$table$PValue,
                                                           method="BH"))
      comp$CountMean <- mean
    } else {
      comp <- edgeR::exactTest(res, dispersion=dispersionValue^2)
      comp <- base::cbind(comp$table, padj=stats::p.adjust(comp$table$PValue,
                                                           method="BH"))
    }
    data$CountMean <- comp$CountMean
    data$log2FoldChange <- comp$logFC
    data$pvalue <- comp$PValue
    data$padjusted <- comp$padj
    #data$logCPM <- comp$logCPM
  } else
    if (method == "DESeq2"){
      message("Undertaking differential analysis with the DESeq2 method..")
      res <- .DESeq_normalise(counts, group)
      comp <- DESeq2::DESeq(res)
      comp <- DESeq2::results(comp)
      data$CountMean <- comp[,"baseMean"]
      data$log2FoldChange <- comp[,"log2FoldChange"]
      data$pvalue <- comp[,"pvalue"]
      data$padjusted <- comp[,"padj"]
    }
  res.df <- data %>%
    dplyr::mutate_at(c('log2FoldChange','padjusted', 'pvalue'),
                     ~tidyr::replace_na(.,0))
  comparision.order <- paste(unique(groups),  collapse = " Vs ")
  res.df$comparision.order <- comparision.order
    
  return(res.df)
}

#' Merge two genome reference assemblies (FASTA format)
#'
#' @description Merges two reference genomes (FASTA) into one single
#' reference with modified chromosome names. 
#' 
#' Typically, use genomeA as the origin tissue genome assembly, and genomeB as 
#' the genome from which mobile RNAs are produced by. 
#'
#'@param genomeA path; path to a genome reference assembly file in FASTA format.
#'
#'@param genomeB path; path to a genome reference assembly file in FASTA format.
#'
#'@param output_file path; a character string or a \code{base::connections()} 
#'open for writing. Including file output name, and file extension of `.fa` or 
#'`.fasta`. 
#'
#'@param GenomeA.ID character; string to represent prefix added to 
#'existing chromosome names in `genomeA`. Default set as "A"
#'
#'@param GenomeB.ID character; string to represent prefix added to 
#'existing chromosome names in `genomeB`. Default set as "B". 
#'
#'@param compress.output logical; state whether the output file should be in 
#'a compressed format (gzip)
#'
#'@return Returns a single FASTA format file containing both genome assemblies
#'with edited chromosome names (prefixes, and removal of periods) to the given
#'directory. 
#'
#'@details
#' The function merges two FASTA files, however, when merging genomic files it 
#' is critical that the two genomes are distinguishable by the chromosome names. 
#' As a default setting, the function extracts the chromosome names for the
#' given FASTA files and alters adds a unique prefix while retaining the 
#' identifying number. Plus, removes any periods. 
#'
#' As default, the function will rename the chromosome names in `genome_A` to 
#' "A" and separates the prefix and the existing chromosome names with an 
#' underscore ("_"). For example, A_0, A_1, A_2 etc.
#' 
#' Please note that the underscore is added automatically, hence, when setting a
#' custom prefix just includes character values. 
#' 
#'
#'**IMPORTANT:**  The genome reference and annotation of the same 
#'species/accession/variety must have chromosomes with matching names. It is 
#'critical that if you use the [mobileRNA::RNAmergeAnnotations()] function to
#' create a merged genome annotation, that you treat the input references in the 
#' same way.
#'
#'
#' @examples
#' fasta_1 <- system.file("extdata","reduced_chr12_Eggplant.fa.gz", 
#' package="mobileRNA")
#' 
#' fasta_2 <-system.file("extdata","reduced_chr2_Tomato.fa.gz",
#' package="mobileRNA")
#' 
#' 
#' output_file <- file.path(tempfile("merged_annotation", fileext = ".fa"))
#' 
#' merged_ref <- RNAmergeGenomes(genomeA = fasta_1, 
#' genomeB = fasta_2,
#' output_file = output_file)
#' 
#' 
#' @importFrom Biostrings readDNAStringSet
#' @importFrom Biostrings writeXStringSet
#' @importFrom progress progress_bar
#' @export
RNAmergeGenomes <- function(genomeA, genomeB, output_file,
                             GenomeA.ID = "A",
                             GenomeB.ID = "B", 
                            compress.output = FALSE) {
  if (missing(genomeA) || !file.exists(genomeA)) {
    stop("Please specify genomeA, a connection to a FASTA file in local")
  }
  if (missing(genomeB) || !file.exists(genomeB)) {
    stop("Please specify annotationA, a connection to a FASTA file in local")
  }
  if (missing(output_file) || !grepl("\\.(fa|fasta|fasta.gz|fa.gz|fsa|fsa.gz)$", 
                                     output_file)) {
    stop("Please specify output_file, a connection to a local directory to write 
    and save merged annotation. Ensure file name with extension (.fa or .fasta) 
         is supplied.")
  }
  
  if (compress.output == TRUE || grepl("\\.gz$", output_file)) {
    stop("If you wish to compress the output file, please ensure the file 
      extension includes '.gz' ")
  }
  message("-- Note: Please be patient, this next step may take a long time --")

  # progress bar
  pb <- progress::progress_bar$new(
    format = "[:bar] :percent :current/:total :eta",
    total = 5)
  pb$tick(0)  # start the progress bar
    # 1- load each genome into R 
  ref1 <-  Biostrings::readDNAStringSet(genomeA)

  pb$tick()
  ref2 <-  Biostrings::readDNAStringSet(genomeB)
    
  pb$tick()
  
  
  # Replace chromosome names in reference genomes
  ref1_names <- names(ref1)
  ref1_newnames <- paste0(GenomeA.ID, "_", ref1_names)
  ref1_newnames <- sub("\\.", "", ref1_newnames)
  names(ref1) <- ref1_newnames
  
  ref2_names <- names(ref2)
  ref2_newnames <- paste0(GenomeB.ID, "_", ref2_names)
  ref2_newnames <- sub("\\.", "", ref2_newnames)
  names(ref2) <- ref2_newnames
  pb$tick()
  # Merge genomes
  merged_genome <- append(ref1, ref2)
  pb$tick()
  # save merged genome
  Biostrings::writeXStringSet(merged_genome, 
                              output_file, 
                              format="fasta",
                              compress = compress.output)
  pb$tick()
  message("Output file has been saved to: ", output_file)

  return(merged_genome)
}

#' Plot the distribution of sRNA classes based on nucleotide length
#'
#' @description \code{RNAdistribution} plots the distribution of dicer-derived
#' sRNA classes across samples or the sRNA consensus determined by the
#'  [mobileRNA::RNAdicercall()] function. This can be displayed as a line or bar 
#'  plot. 
#'
#' @param data data.frame; generated originally by [mobileRNA::RNAimport()]
#'
#' @param samples character; states a subset of samples to plot. This argument 
#' is based on the sample names within the data. 
#' 
#' @param outline character; states the outline colour for a box plot. 
#' Default is "black".
#'
#' @param facet logical; forms a matrix of panels defined by row and column
#' faceting variables. It plots the results for each sample as a bar chart
#' and contains it within a single plot. The number of rows in the facet can
#' be changed using the argument \code{facet.arrange}.
#' Default \code{facet = TRUE} , plots each sample separately when
#' \code{facet = FALSE} .
#'
#' @param facet.arrange numeric; value supplied to define the number of columns
#' to include in the facet. This argument is piped into the ` ncol`  argument in
#' [ggplot2::facet_wrap()] to define the number of columns. By default, this is
#' set to 3.
#'
#' @param colour character; fill colour, Default is "#0868AC".
#'
#'@param data.type character; either plotting "samples" or the "consensus" 
#'stored in the 'DicerConsensus' column. 
#'
#' @param style character; \code{style="line"} or \code{style="bar"}. 
#' Instructs how to plot the data. Where \code{style="line"} plots a line graph 
#' and \code{style="bar"} plots a bar graph. 
#'
#' @param overlap logical; generates a single line graph, containing all 
#' sample replicate information. Default \code{overlap=TRUE}.
#'
#'@param non.classified logical; to include distribution of sRNAs which were 
#'unclassified. Default is TRUE, ie. maintain.
#'
#'
#'@param relative logical; used in conjunction with \code{data.type="consensus"}. 
#'Instructs plotting of the relative frequency of all sRNA classes across the 
#'data defined by the consensus dicer-derived sRNA column (see 
#'[mobileRNA::RNAdicercall()] function for more information). 
#'
#'@param wrap.scales character; scales be fixed ("fixed", the default), free 
#'("free"), or free in one dimension ("free_x", "free_y")
#'
#'
#'@details
#'
#'The function can be used to plot a variety of different comparisons and plots.
#'It can be used to plot the distribution of sRNA classes within each sample
#'replicate, which can be represented as a bar chart \code{style="bar"} or a
#'line graph \code{style="line"}. These plots can be represented individually or
#'in a single facet plot when \code{facet="TRUE"}. 
#'
#'Additionally, there is the option to plot the distribution of sRNA classes
#'within individual samples or to plot the distribution of the consensus 
#' dicer-derived sRNA classes determined by the [RNAdicercall()] function and 
#' stored in the column `DicerConsensus` when \code{data.type="consensus"}. 
#' When plotting samples individually, there is the option to overlap the 
#' results onto a single line graph when \code{overlap=TRUE}. This is not an
#'option for bar plots.
#'
#'
#'
#'@return The function returns a list containing the results: a data frame and 
#'the plot(s). To access an element, simply use the "$" symbol,
#'and the elements "data" and "plot" will appear. 
#'
#' @examples
#' # load data 
#' data('sRNA_data')
#'
#' p1 <- RNAdistribution(data = sRNA_data, style = "line")
#'
#' p2 <- RNAdistribution(data = sRNA_data, style = "line", overlap = FALSE)
#'
#' p3 <- RNAdistribution(data = sRNA_data, style = "bar")
#'
#' p3.2 <- RNAdistribution(data = sRNA_data, style = "bar",
#'                        samples = c("heterograft_1", "heterograft_2",
#'                        "heterograft_3"))
#'
#' p4 <- RNAdistribution(data = sRNA_data, style = "bar", facet = FALSE)
#'
#' p5 <- RNAdistribution(data = sRNA_data, style = "bar",
#'                       facet = TRUE, facet.arrange = 2 )
#'
#'
#' # Run function to define sRNA class for each cluster.
#' sRNA_data_dicercall <- mobileRNA::RNAdicercall(data = sRNA_data, tidy=TRUE)
#'
#'p6 <- RNAdistribution(data = sRNA_data_dicercall, style = "bar", data.type = "consensus")
#'
#' @export
#' @importFrom BiocGenerics grep
#' @importFrom dplyr %>%
#' @importFrom dplyr select
#' @importFrom dplyr count
#' @importFrom dplyr mutate
#' @importFrom tidyselect all_of
#' @importFrom data.table setDT
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 geom_bar
#' @importFrom ggplot2 labs
#' @importFrom ggplot2 aes
#' @importFrom ggplot2 guides
#' @importFrom ggplot2 guide_legend
#' @importFrom ggplot2 unit
#' @importFrom ggplot2 element_text
#' @importFrom ggplot2 element_blank
#' @importFrom ggplot2 element_line
#' @importFrom ggplot2 element_rect
#' @importFrom ggplot2 margin
#' @importFrom tidyr gather
#' @importFrom data.table melt
#' @importFrom ggplot2 facet_wrap
#' @importFrom ggplot2 theme_classic
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 geom_line
#' @importFrom ggplot2 xlab
#' @importFrom ggplot2 ylab
#' @importFrom ggplot2 labs
#' @importFrom ggplot2 expansion
#' @importFrom ggplot2 scale_colour_manual
#' @importFrom ggplot2 scale_fill_manual
#'
RNAdistribution  <- function (data, samples = NULL, style, 
                              data.type = "samples", 
                              facet = TRUE, 
                              facet.arrange = 3, 
                              colour = "#0868AC", 
                              outline = "black", 
                              wrap.scales = "fixed", 
                              overlap = TRUE, 
                              relative = FALSE,
                              non.classified = TRUE) 
{
  if (base::missing(data) || !base::inherits(data, c("data.frame"))) {
    stop("data must be a data frame, see ?help for more details")
  }
  if (missing(style) || !is.character(style)) {
    stop("style parameter is missing or not a character vector.")
  }
  allowed_styles <- c("line", "bar")
  if (!style %in% allowed_styles) {
    stop("style parameter must be one of 'line', 'bar', or 'consensus'.")
  }
  allowed_datatypes <- c("samples", "consensus")
  if (!data.type %in% allowed_datatypes) {
    stop("data.type parameter must be one of 'samples' or 'consensus'.")
  }
  custom_theme <- ggplot2::theme(
    plot.title = ggplot2::element_text(face = "italic", size = 17), 
    panel.grid = ggplot2::element_blank(),
    axis.text.x = ggplot2::element_text(color="black", size = 15,
                                        face = "bold", 
                                        margin = ggplot2::margin(t = 10,b = 4)),
    axis.text.y = ggplot2::element_text(color="black", size = 15,face = "bold", 
                                        margin = ggplot2::margin(r = 10)) ,
    panel.grid.major.x = ggplot2::element_line( linewidth=.1, color="grey", 
                                                linetype = 2 ),
    panel.grid.major.y = ggplot2::element_line( linewidth=.1, color="grey", 
                                                linetype = 2 ),
    legend.position = "right", 
    legend.box.margin= ggplot2::margin(20,20,20,20),
    legend.text = ggplot2::element_text(size=14,
                                        margin = ggplot2::margin(7,7,7,7)),
    legend.title = ggplot2::element_text(size = 14.5, face = "bold"),
    axis.title.y = ggplot2::element_text(margin = ggplot2::margin(r = 10),
                                         size = 17, face = "bold"),
    axis.title.x = ggplot2::element_text(margin = ggplot2::margin(t = 10), 
                                         size = 17, face = "bold"),
    strip.background = ggplot2::element_rect(fill = "lightgrey",
                                             colour = "black"), 
    strip.placement = "outside",
    strip.text.x = ggplot2::element_text(size = 14,face="italic" , 
                                         margin = ggplot2::margin(b = 6,t = 5)),
    panel.border = ggplot2::element_rect(fill = "transparent", color = "black", 
                                         linewidth = 1.5),
    plot.margin = ggplot2::unit(c(0.1, 0.1, 0.1, 0.1), "inches"))
  
  if (data.type == "consensus") {
    x <- data %>% dplyr::count(DicerConsensus)
    if (!relative == FALSE) {
      x <- x %>% dplyr::mutate(freq = n/sum(n))
      if (style == "line") {
        p1 <- ggplot2::ggplot(x, ggplot2::aes(x = DicerConsensus, 
                                              y = freq, group = 1)) + 
          ggplot2::geom_point(color = colour) + 
          ggplot2::geom_line(color = colour) + 
          ggplot2::theme_classic() + 
          ggplot2::xlab("sRNA Class") + ggplot2::ylab("Relative frequency") + 
          ggplot2::scale_y_continuous(expand = c(0, 0), 
                                      limits = c(0, 1)) + 
          ggplot2::theme_classic() + 
          custom_theme
        
      }
      else if (style == "bar") {
        
        p1 <- ggplot2::ggplot(x, ggplot2::aes(x = DicerConsensus, 
                                              y = freq, group = 1)) + 
          ggplot2::geom_bar(stat = "identity", fill = colour, color = outline) + 
          ggplot2::xlab("sRNA Class") + 
          ggplot2::ylab("Relative frequency") + 
          ggplot2::scale_y_continuous(limits = c(0, 1), expand = c(0,  0)) + 
          ggplot2::theme_classic() + 
          custom_theme
      }
    }
    else if (relative == FALSE) {
      perc_lim <- max(x$n) * 1.10
      
      if (style == "line") {
        max_lim <- max(x$n)
        
        p1 <- ggplot2::ggplot(x, ggplot2::aes(x = DicerConsensus, 
                                              y = n, group = 1)) + 
          ggplot2::geom_point(color = colour) + 
          ggplot2::geom_line(color = colour) + 
          ggplot2::xlab("sRNA Class") + ggplot2::ylab("Count") + 
          ggplot2::scale_y_continuous(expand = c(0, 0),limits = c(0, perc_lim))+ 
          ggplot2::theme_classic() + 
          custom_theme
      }
      else if (style == "bar") {
        p1 <- ggplot2::ggplot(x, ggplot2::aes(x = DicerConsensus, 
                                              y = n, group = 1)) + 
          ggplot2::geom_bar(stat = "identity", fill = colour, color = outline) + 
          ggplot2::xlab("sRNA Class") + 
          ggplot2::ylab("Count") + 
          ggplot2::scale_y_continuous(limits = c(0, perc_lim), expand = c(0,  0)) + 
          ggplot2::theme_classic() + 
          custom_theme
      }
    }
    out <- list(plot = p1, data = x)
    return(out)
  }
  else {
    if (base::missing(style) || !style %in% c("bar", "line")) {
      stop("Please specify type of plot to produce (line or bar)")
    }
    data.cols <- data %>% dplyr::select(tidyselect::starts_with("DicerCall_"))
    counts.df <- apply(data.cols, MARGIN = 2, table)
    if (base::inherits(counts.df, c("list"))) {
      class_colnames <- colnames(data)[grep("DicerCall_", 
                                            colnames(data))]
      required_columns <- unique(unlist(data[class_colnames]))
      for (i in 1:length(counts.df) ) {
        table_i <- counts.df[[i]]
        if (length(names(table_i)) < length(required_columns)) {
          missing_columns <- setdiff(required_columns, 
                                     names(table_i))
          table_i[missing_columns] <- 0
          if (!identical(names(table_i), required_columns)) {
            table_i <- table_i[match(required_columns, 
                                     names(table_i))]
          }
          counts.df[[i]] <- table_i
        }
      }
      # reorder dimensions
      counts.df <- lapply(counts.df, reorder_table, order = required_columns)
      
      counts.df <- data.frame(t(do.call(rbind, counts.df)))
    } else if (!base::inherits(counts.df, c("list"))) {
      counts.df <- data.frame(counts.df)
    }
    colnames(counts.df) <- gsub("DicerCall_", "", colnames(counts.df))
    counts.df <- data.table::setDT(counts.df, keep.rownames = "Class")[]
    if(non.classified == FALSE){
      counts.df <- counts.df[!(counts.df$Class == "N"), ]
    }
    if (style == "bar") {
      if (!is.null(samples)) {
        counts_class <- counts.df %>% select(Class)
        counts.df <- counts.df %>% select(all_of(samples))
        counts.df <- cbind(counts_class, counts.df)
      }
      plist <- list()
      
      for (col in names(counts.df)[-grep("Class", names(counts.df))]) {
        xlim_v <- max(counts.df[[col]])*1.10
        
        p <- if (!is.null(colour) && length(colour) == (nrow(counts.df) -1) ) {
          ggplot2::ggplot(counts.df, ggplot2::aes(x = .data[["Class"]],  y = .data[[col]]))+
            ggplot2::geom_bar(stat = "identity", ggplot2::aes(fill = variable), color = outline)+
            ggplot2::scale_fill_manual(values = colour )+
            ggplot2::theme_classic() + 
            ggplot2::labs(title = paste0("Sample: ", col), 
                          x = "sRNA Class", y = "Count") + 
            ggplot2::theme_bw() + 
            custom_theme
        } else if (!is.null(colour) && length(colour) == 1) {
          ggplot2::ggplot(as.data.frame(counts.df), ggplot2::aes(x = .data[["Class"]],  y = .data[[col]]))+
            ggplot2::geom_bar(stat = "identity", fill = colour, color = outline)+
            ggplot2::theme_classic() + 
            ggplot2::labs(title = paste0("Sample: ", col), 
                          x = "sRNA Class", y = "Count") + 
            ggplot2::theme_bw() + 
            custom_theme
        } else {
          ggplot2::ggplot(counts.df, ggplot2::aes(x = .data[["Class"]],  y = .data[[col]]))+
            ggplot2::geom_bar(stat = "identity",  ggplot2::aes(fill = variable), 
                              color = outline)+
            ggplot2::theme_classic() + 
            ggplot2::labs(title = paste0("Sample: ", col), 
                          x = "sRNA Class", y = "Count") + 
            ggplot2::theme_bw() + 
            custom_theme
        }
        
        
        
        plist[[col]] <- p
      }
      plist <- lapply(plist, function(p) {
        p + ggplot2::scale_y_continuous(expand = ggplot2::expansion(mult = c(0, 
                                                                             0.1)))
      })
      sn <- names(plist)
      if (facet == TRUE) {
        p <- ggplot2::ggplot(tidyr::gather(counts.df, 
                                           key, Count, -Class), ggplot2::aes(Class, Count)) + 
          ggplot2::geom_bar(stat = "identity", fill = colour, 
                            colour = outline) + ggplot2::facet_wrap(~key, 
                                                                    scales = wrap.scales, ncol = facet.arrange) + 
          ggplot2::labs(x = "sRNA Class", y = "Count") + 
          ggplot2::theme_classic()+
          ggplot2::scale_y_continuous(expand = ggplot2::expansion(mult = c(0,0.1)))+ 
          custom_theme
        
        out <- list(plot = p, data = counts.df)
      }
      else if (facet == FALSE) {
        out <- list(plot = plist, data = counts.df)
      }
      return(out)
    }
    if (style == "line") {
      if (overlap == TRUE) {
        if (is.null(samples)) {
          counts.df_melt <- data.table::melt(counts.df, 
                                             id.vars = "Class")
          p <- ggplot2::ggplot(counts.df_melt, ggplot2::aes(Class, 
                                                            value, col = variable, group = 1)) + ggplot2::geom_point() + 
            ggplot2::geom_line() + ggplot2::xlab("sRNA Class") + 
            ggplot2::ylab("Count") + ggplot2::labs(color = "Samples") + 
            ggplot2::guides(fill = ggplot2::guide_legend(override.aes = list(shape = 21,size = 8))) + 
            ggplot2::theme_bw() + 
            custom_theme
          out <- list(plot = p, data = counts.df)
        }
        else if (!is.null(samples)) {
          counts.df <- counts.df %>% select(Class, all_of(samples))
          counts.df <- data.table::melt(counts.df, id.vars = "Class")
          p <- ggplot2::ggplot(counts.df, 
                               ggplot2::aes(Class, value, col = variable, group = 1)) + 
            ggplot2::geom_point(ggplot2::aes(color = variable)) + 
            ggplot2::geom_line(ggplot2::aes(color = variable)) +
            {if(!is.null(colour) && length(colour)== length(unique(counts.df$variable)))
              ggplot2::scale_colour_manual(values = colour ) }+
            ggplot2::xlab("sRNA Class") + 
            ggplot2::ylab("Count") + ggplot2::labs(color = "Samples") + 
            ggplot2::theme_bw() + 
            custom_theme
          
          out <- list(plot = p, data = counts.df)
        }
      }
      else if (overlap == FALSE) {
        if (facet == TRUE) {
          if (is.null(samples)) {
            p <- ggplot2::ggplot(tidyr::gather(counts.df, key, Count, -Class), 
                                 ggplot2::aes(Class, Count, group = 1)) + 
              ggplot2::geom_point(colour = colour) + 
              ggplot2::geom_line(colour = colour) + 
              ggplot2::facet_wrap(~key, scales = wrap.scales, 
                                  ncol = facet.arrange) + 
              ggplot2::xlab("sRNA Class") + 
              ggplot2::ylab("Count") + 
              ggplot2::theme_bw() + 
              ggplot2::scale_y_continuous(expand = ggplot2::expansion(mult = c(0, 0.1))) + 
              custom_theme                                                                                                                                                                                                                                                                                                                                            
          }
          else if (!is.null(samples)) {
            counts_class <- counts.df %>% select(Class)
            counts.df <- counts.df %>% select(all_of(samples))
            counts.df <- cbind(counts_class, counts.df)
            p <- ggplot2::ggplot(tidyr::gather(counts.df, 
                                               key, Count, -Class), ggplot2::aes(Class, 
                                                                                 Count, group = 1)) + ggplot2::geom_point(colour = colour) + 
              ggplot2::geom_line(colour = colour) + ggplot2::theme_classic() + 
              ggplot2::facet_wrap(~key, scales = wrap.scales, 
                                  ncol = facet.arrange) + ggplot2::theme_bw() + 
              ggplot2::scale_y_continuous(expand = ggplot2::expansion(mult = c(0,0.1))) +   
              custom_theme
          }
          out <- list(plot = p, data = counts.df)
          return(out)
        }
        else if (facet == FALSE) {
          if (!is.null(samples)) {
            counts_class <- counts.df %>% select(Class)
            counts.df <- counts.df %>% select(all_of(samples))
            counts.df <- cbind(counts_class, counts.df)
          }
          plist2 <- list()
          for (col in names(counts.df)[-grep("Class",  names(counts.df))]) {
            
            xlim_v <- max(counts.df[[col]])*1.10
            
            p2 <- if (!is.null(colour) && length(colour) == (nrow(counts.df) -1) ) {
              ggplot2::ggplot(counts.df, 
                              ggplot2::aes(x = .data[["Class"]],  y = .data[[col]], group = 1))+
                ggplot2::geom_point(ggplot2::aes(color = variable))+
                ggplot2::geom_line(ggplot2::aes(color = variable)) + 
                ggplot2::scale_fill_manual(values = colour )+
                ggplot2::theme_classic() + 
                ggplot2::labs(title = paste0("Sample: ", col), 
                              x = "sRNA Class", y = "Count") + 
                ggplot2::theme_bw() + 
                custom_theme
            } else if (!is.null(colour) && length(colour) == 1) {
              ggplot2::ggplot(as.data.frame(counts.df), 
                              ggplot2::aes(x = .data[["Class"]],  y = .data[[col]], group = 1))+
                ggplot2::geom_point( color = colour)+
                ggplot2::geom_line(color = colour) + 
                ggplot2::theme_classic() + 
                ggplot2::labs(title = paste0("Sample: ", col), 
                              x = "sRNA Class", y = "Count") + 
                ggplot2::theme_bw() + 
                custom_theme
            } else {
              ggplot2::ggplot(counts.df, 
                              ggplot2::aes(x = .data[["Class"]],  y = .data[[col]], group = 1))+
                ggplot2::geom_point(ggplot2::aes(color = variable))+
                ggplot2::geom_line(ggplot2::aes(color = variable)) + 
                ggplot2::theme_classic() + 
                ggplot2::labs(title = paste0("Sample: ", col), 
                              x = "sRNA Class", y = "Count") + 
                ggplot2::theme_bw() + 
                custom_theme
            }
            
            plist2[[col]] <- p2
          }
          plist2 <- lapply(plist2, function(p2) {
            p2 + ggplot2::scale_y_continuous(expand = ggplot2::expansion(mult = c(0, 
                                                                                  0.1)))
          })
          sn <- names(plist2)
          p <- plist2
          out <- list(plot = p, data = counts.df)
        }
      }
      return(out)
    }
  }
}

#' Heatmap of log-transformed normalization data
#'
#' @description Undertakes normalisation of RPM/FPKM using a pseudocount and 
#' transforms the data using log-scale, to enable visualization of the 
#' differences and patterns in expression across samples using a heatmap. 
#'
#'
#' @param data data.frame; originally generated by [mobileRNA::RNAimport()] 
#' 
#' @param value character; state the values to plot, either `FPKM` or `RPM`. 
#'
#' @param colours character; colors. Default is 
#'` grDevices::colorRampPalette(RColorBrewer::brewer.pal(9, "GnBu"))(100) `
#'
#' @param pseudocount numeric; pseudo count, default is `1e-6`
#' 
#' @param cluster logical; include hierarchical clustering when default 
#' `cluster= TRUE`
#' 
#' @param scale character; indicating whether the values should be centered & 
#' scaled in either the row direction or the column direction, or none. 
#' Respective options are "row", "column" & "none". Default is `scale="none"`.
#' 
#' 
#' @param clustering_method character; clustering method used. Accepts the same 
#' values as hclust. Default `clustering_method= "complete"`
#' 
#' @param row.names logical; indicated whether to include rownames from column
#' 1 of data frame. Default `row.names=FALSE`
#' 
#' @param border.color character; the border colour. Default is no border (NA). 
#'
#'@param title character; states plot title, placed at the top center
#'
#'@param column.angle numeric; angle of the column labels, choose from 0, 45, 
#'90, 270 or 315. 
#'
#'
#' @details Undertakes FPKM/RPM normalisation using a pseudocount and then 
#' transforms the normalised-RPM data using log-scale. 
#' 
#' This function expects to receive a data frame containing FPKM/RPM data. 
#' This function employs the use of a pseudo count during 
#' normalisation as the function is expected to be used when identifying mobile 
#' sRNAs in a chimeric system. In such system, it is expected that control 
#' replicates will contain zero values for the candidate mobile sRNA clusters. 
#' 
#' 
#'@return Produces a list objects storing the heatmap plot and the data. 
#'
#' @examples
#'data("sRNA_data")
#'
#' # vector of control names
#' controls <- c("selfgraft_1", "selfgraft_2" , "selfgraft_3")
#'
#' # Locate potentially mobile sRNA clusters associated to tomato, no
#' # statistical analysis
#' sRNA_data_mobile <- RNAmobile(input = "sRNA", data =  sRNA_data,
#' controls = controls, genome.ID = "B_", task = "keep", statistical = FALSE)
#'
#' # plot heatmap of potential mobile sRNAs
#'  p1 <-  plotHeatmap(sRNA_data_mobile)
#'
#'
#'
#'
#' @export
#' @importFrom dplyr %>%
#' @importFrom dplyr select
#' @importFrom tidyselect starts_with
#' @importFrom pheatmap pheatmap
#' @importFrom grDevices colorRampPalette
#' @importFrom RColorBrewer brewer.pal
#' @importFrom grid gpar
plotHeatmap <- function (data, 
                         value = "RPM", 
                         pseudocount = 1e-6, 
                         colours = grDevices::colorRampPalette(RColorBrewer::brewer.pal(9, "GnBu"))(100),
                         cluster = TRUE, scale = "none", 
                         clustering_method = "complete", 
                         row.names = FALSE,
                         border.color = NA,
                         column.angle = 45, 
                         title = NA) {
  if (base::missing(data) || !base::inherits(data, c("matrix","data.frame", 
                                                     "DataFrame"))) {
    stop("data must be an object of class matrix, data.frame, DataFrame.
          See ?plotHeatmap for more information.")
  }
  
  allowed_styles <- c("RPM", "FPKM")
  if (!value %in% allowed_styles) {
    stop("value parameter must be one of 'RPM', or 'FPKM'.")
  }
  
  RPMcolumns <- any(grepl(paste0("^", "RPM_"), colnames(data)))
  if (value == "RPM" && RPMcolumns ) {
    select_data <- data %>% dplyr::select(tidyselect::starts_with("RPM_"))
    names(select_data) <- sub('^RPM_', '', names(select_data))
  } else 
    FPKMcolumns <-any(grepl(paste0("^", "FPKM_"), colnames(data)))
   if (value == "FPKM" && FPKMcolumns) {
    select_data <- data %>% dplyr::select(tidyselect::starts_with("FPKM"))
    names(select_data) <- sub('^FPKM_', '', names(select_data))
   }
    if(RPMcolumns == FALSE  && FPKMcolumns == FALSE ) {
       stop("data must contain columns containing either FPKM, or  RPM data 
          columns depending on the 'value' parameter.")
    }
   
  rownames(select_data) <- data[,1] # remove cluster with no counts 
  select_data <- select_data[rowSums(select_data[])>0,]
  total_reads_per_sample <- colSums(select_data)   # RPM normalization with pseudocount addition
  rpm_matrix <- (select_data / (total_reads_per_sample + pseudocount)) * 1e6
  log_rpm_matrix <- log2(rpm_matrix + 1)   # log transform. 
  
  if(cluster == FALSE){
    p1 <- pheatmap::pheatmap(log_rpm_matrix, 
                             scale = scale,
                             cluster_rows = FALSE, 
                             cluster_cols = FALSE, 
                             show_row_dendrogram = FALSE, 
                             show_col_dendrogram = FALSE, 
                             color = colours,
                             show_rownames = row.names, 
                             border_color = border.color,
                             fontsize_row = 10,            
                             fontsize_col = 10,
                             angle_col = column.angle, 
                             silent =TRUE, main = title)
  } else {
    p1 <- pheatmap::pheatmap(log_rpm_matrix,
                             scale = scale, 
                             color = colours,              
                             clustering_method = clustering_method,  
                             show_rownames = row.names,
                             fontsize_row = 10, 
                             fontsize_col = 10, 
                             border_color = border.color,
                             cluster_cols = FALSE, 
                             angle_col = column.angle,
                             silent =TRUE,
                             main = title)
  }
  
  p1$gtable$grobs[[4]]$gp <- grid::gpar(fontface = "bold") 
  p1$gtable$grobs[[3]]$gp <- grid::gpar(fontface = "bold")
  
  out <- list(plot = p1, data = log_rpm_matrix)
  return(out)
}

#' mobileRNA pre-processing method for sRNAseq & mRNAseq (alignment, raw count or cluster analysis)
#'
#' @description The mobileRNA workflow includes specific pre-processing 
#' guidelines. For sRNAseq, this undertakes alignment with Bowtie and sRNA 
#' cluster analysis with ShortStack. For mRNAseq, this undertakes alignment with 
#' HISAT2 and HTSeq. All OS software should be installed within a Conda 
#' environment. 
#' 
#' @details
#' Please ensure all OS software is installed within a Conda environment. 
#' See appendix of vignette for manual pipeline. Alignment statistics are 
#' reported for each analysis within log plain text files (log.txt).
#' 
#' In order to align reads, the function will check whether a genome reference
#' index has already been generated and, if not, will generate one. The method
#' varies between sRNA and mRNA analysis depending on the alignment tool. This
#' is generated in the same location as the reference file. 
#' 
#' NOTE: This function utilises the `reticulate` R package to connect to the 
#' conda environment. Hence, restart R if you wish to change the employed Conda 
#' environment during a session. 
#' 
#' 
#' **For sRNA analysis** 
#' The function invokes a number of OS commands, and is dependent 
#' on the installation of `ShortStack` (>= 4.0) with Conda. Please note that 
#' `ShortStack` is only compatible with Linux and Mac operating systems. 
#' 
#' The pipeline undertakes de novo detection of sRNA-producing loci and
#' alignment, where the output of each are stored in their respective folders in 
#' the users desired location. The de novo detection of sRNA-producing loci
#' analyses each sample to identify de novo sRNA-producing loci (ie. sRNA
#' clusters), and joins these results into a single file called "locifile.txt". 
#' The alignment step aligns and clusters each sample to the genome reference
#' along with the file containing the de novo sRNA clusters. The final reports
#' are imported into R using [RNAimport()].
#' 
#' 
#' **For mRNA analysis** 
#' 
#' The function invokes a number of OS commands, and is dependent 
#' on the installation of `HISAT2`,`HTSeq` and `SAMtools` with `Conda.` 
#' The pipeline can undertake single- or pair-end analysis, and to do so 
#' requires a data frame stating the sample information where each row 
#' represents a sample. The reads are mapped using `HISAT` and then the 
#' raw counts are estimated by `HTSeq`. The output alignment file (BAM) and 
#' raw counts file for each sample are stored within the samples own folder 
#' within the desired directory. 
#' 
#' 
#' 
#' 
#' @references 
#' ShortStack \url{https://github.com/MikeAxtell/ShortStack},
#' HISAT2 \url{https://anaconda.org/bioconda/hisat2},
#' HTSeq \url{https://htseq.readthedocs.io/en/master/install.html},
#' SAMtools \url{https://anaconda.org/bioconda/samtools}
#' 
#' @param input string; define type of Next-Generation Sequencing data set.
#'"sRNA" for sRNAseq data and "mRNA" for mRNAseq data. 
#'
#' @param input_files_dir path; directory containing only the FASTQ samples for 
#' analysis. Note that all samples in this directory will be used by this 
#' function. 
#' 
#' @param condaenv character; name or directory of the Conda environment to use
#' where OS dependencies are stored. 
#' 
#' @param output_dir path; directory to store output. 
#' @param genomefile path; path to a FASTA genome reference file. 
#' @param threads numeric; set the number of threads to use where more threads 
#' means a faster completion time. Default is 6. 
#' 
#' @param mmap character; define how to handle multi-mapped reads. Choose from 
#' "u", "f" , "r" or "n". For core sRNA analysis, use either "u", "f" or "r" 
#' options. Where "u" means only uniquely-aligned reads are used as 
#' weights for placement of multi-mapped reads. Where "f" means fractional 
#' weighting scheme for placement of multi-mapped reads and "r" mean 
#' multi-mapped read placement is random. For core mRNA analysis, to include 
#' multimapped reads, use any parameter, other than "n". While for mobile sRNA 
#' or mRNA, it is important to use "n", to not consider multi-mapped reads, 
#' only unique reads as we cannot distinguish which genome the reads mapped to 
#' multiple locations in. 
#' 
#' @param dicermin integer; the minimum size in nucleotides of a valid small 
#' RNA. This option sets the bounds to discriminate dicer-derived small RNA loci 
#' from other loci. Default is 20. For sRNA analysis only. 
#' @param dicermax integer; the maximum size in nucleotides of a valid small 
#' RNA. This option sets the bounds to discriminate dicer-derived small RNA loci 
#' from other loci. Default is 24. For sRNA analysis only. 
#' 
#' @param mincov numeric; minimum alignment depth, in units of reads per 
#' million, required to nucleate a small RNA cluster during de novo cluster 
#' search. Must be a number > 0. Default is 2. For sRNA analysis only. 
#' 
#' @param pad integer; initial peaks are merged if they are this distance or 
#' less from each other. Must >= 1, default is 75. For sRNA analysis only. 
#' 
#' @param tidy logical; removes unnecessary extra output files when set to TRUE. 
#' 
#' @param sampleData dataframe; stores mRNA sample data where rows represent 
#' each sample in the analysis. Column one stores the sample names, while column
#' two stores the the name(s) of the fastq file(s) for mate 1 (e.g. flyA_1.fq,
#' flyB_1.fq) and column three stores the the name(s) of the fastq file(s) for 
#' mate 2 (e.g. flyA_2.fq,flyB_2.fq). If data is single ended, column three 
#' will not hold any values. Only for mRNA analysis.  
#' 
#'  
#' @param annotationfile path; path to a GFF file. For mRNA analysis only. 
#'  
#' @param order character; either "name" or "pos" to indicate how the input data
#' has been sorted. For paired-end data only, this sorts the data either by 
#' read name or by alignment position. Default is "pos", to sort by position. 
#' For mRNA analysis only. 
#' 
#' @param stranded whether the data is from a strand-specific assay, either 
#' "yes"/"no"/"reverse". Default is "no".  For mRNA analysis only. 
#'
#' @param mode character; states mode to handle reads overlapping more than one 
#' feature. Either "union", "intersection-strict" and "intersection-nonempty".
#' Default is "union". For mRNA analysis only. 
#' 
#' @param type character; feature type (3rd column in GFF file) to be used, 
#' all features of other type are ignored. Default is "mRNA". 
#' For mRNA analysis only. 
#' 
#' @param idattr character; GFF attribute to be used as feature ID. Several GFF 
#' lines with the same feature ID will be considered as parts of the same 
#' feature. The feature ID is used to identity the counts in the output table. 
#' Default is "Name". For mRNA analysis only. 
#' 
#' @param nonunique character; states the mode to handle reads that align to or
#'  are assigned to more than one feature in the overlap. Either "none" and 
#'  "all". Default is "none". For mobile mRNA, ensure the default is utilized to 
#'  exclude multimapped reads. For mRNA analysis only. 
#'  
#' @param a numeric; skip all reads with alignment quality lower than the given 
#' minimum value (default: 10). For mRNA analysis only. 
#'  
#' @param python character; phython version. default is python but could be 
#' python3 etc. This is for defining HTseq. 
#' 
#' 
#' @return
#' 
#' ** For sRNA analysis**
#' The OS commands generate output into the users desired location, generating
#' two folders:
#' 
#' * 1_de_novo_detection: Stores output from the detection of de novo sRNA-producing loci
#' * 2_sRNA_results: Stores results 
#' 
#' 
#' The first folder stores the alignment (BAM) and the de novo sRNA-producing 
#' loci for each sample (.txt) within the samples respective folder. The
#' analyses joins the de novo sRNA clusters across the experimental design which
#' is stored in "locifile.txt". The second folder stores the final clustering 
#' results for each sample, and as before the results of each sample are stored 
#' within it's respective folder. These results (.txt) are imported into R for 
#' downstream analysis by utilizing the [mobileRNA::RNAimport()] function. 
#' 
#' The function generates a number of extra files for each sample and are not 
#' required for the downstream analysis. These are generated by `ShortStack`, 
#' see documentation for more information 
#' (\url{https://github.com/MikeAxtell/ShortStack}). As default
#' these files are deleted. This is determined by the `tidy` argument. 
#' 
#' ** For mRNA analysis**
#' For mRNA analysis, generate a new folder which stores the results in the 
#' users desired output location, known as "1_mRNA_preprocessing". Within this
#' folder, there will contain one folder per sample storing it's sorted 
#' alignment file (BAM) and raw counts file ("Result.txt"). Note, that the 
#' function excludes multi-mapped mRNAs. 
#' 
#' 
#' @examples 
#' \dontrun{
#' 
#' ## EXAMPLE 1 - sRNAseq
#' samples <- file.path(system.file("extdata/sRNAseq",package="mobileRNA"))
#' GenomeRef <- system.file("extdata","reduced_chr12_Eggplant.fa.gz", package="mobileRNA")
#' output_location <- tempdir()
#' 
#' mapRNA(input = "sRNA", 
#' input_files_dir = samples, 
#' output_dir = output_location, 
#' genomefile = GenomeRef,
#' condaenv = "ShortStack4", 
#' mmap = "n")
#' 
#' 
#' ## EXAMPLE 2 - mRNAseq
#' GenomeRef <- system.file("extdata","reduced_chr12_Eggplant.fa.gz", package="mobileRNA")
#' GenomeGFF <- system.file("extdata","reduced_chr12_Eggplant.gff.gz", package="mobileRNA")
#' # create sample data including name, and file mates: 
#'sampleData <- data.frame(sample = c("selfgraft_1", "selfgraft_2", 
#'                                    "heterograft_1", "heterograft_2"),
#'                         mate1 = c("selfgraft_mRNAdemo_1.fq.gz", "selfgraft_mRNAdemo_2.fq.gz", 
#'                                   "heterograft_mRNAdemo_1.fq.gz", "heterograft_mRNAdemo_2.fq.gz"))
#'# location of samples:                                 
#'samples <- system.file("extdata/mRNAseq", package="mobileRNA")
#'
#'# location to store output
#'output_location <- tempdir()
#'
#'# run alignment
#'mapRNA(input = "mRNA",
#'       input_files_dir = samples, 
#'       output_dir = output_location, 
#'       genomefile = output_assembly_file,
#'       annotationfile = output_annotation_file,
#'       sampleData = sampleData, 
#'       condaenv = "/Users/user-name/miniconda3")
#' }
#' 
#' @importFrom reticulate use_condaenv 
#' @importFrom GenomicRanges GRangesList
#' @importFrom rtracklayer import.gff
#' @importFrom GenomicRanges reduce
#' @importFrom utils write.table
#' 
#' @export
mapRNA <- function(input = c("mRNA", "sRNA"), sampleData = NULL, tidy = TRUE,
                   input_files_dir, output_dir, genomefile, annotationfile=NULL,
                   condaenv, threads = 6, mmap = "n", dicermin = 20,
                   dicermax = 24, mincov = 0.5, pad = 200, 
                   order = "pos",stranded = "no", a = 10, 
                   mode = "union", nonunique = "none", 
                   type = "mRNA", idattr = "Name",
                   python="python"){
  # check inputs 
  if (base::missing(input) || !input %in% c("sRNA", "mRNA")){
    stop("Please state the data-type to the `input` paramter.")
  }
  if (base::missing(input_files_dir)){
    stop("Please specify an accessible directory where sequencing files are stored")
  }
  # check it only contains fq 
  files <- list.files(input_files_dir)
  fastq_files <- files[grep("\\.(fq|fastq|fastq.gz|fq.gz|fsa|fsa.gz)$", files)]
  other_files <- files[!grepl("\\.(fq|fastq|fastq.gz|fq.gz|fsa|fsa.gz)$", files)]
  if (!length(other_files) == 0) {
    stop("input_files_dir location either does not store any fastq files or it 
 contain additional file types. This location must only contain fastq files.")
  }

  if (missing(genomefile) || !file.exists(genomefile) || 
      !grepl("\\.(fa|fasta|fasta.gz|fa.gz|fsa|fsa.gz)$", genomefile)){
    stop("Please specify genomefile, a connection to a FASTA file in local")
  }
  
  if (missing(output_dir) || !file.exists(output_dir)) {
    stop("Please specify a location to save output")
  }
  
  
  # 1 - Verify that the OS is either Linux or macOS
  os <- tolower(Sys.info()[['sysname']])
  if (os != "linux" && os != "darwin"){
    stop("ShortStack can only run on Linux or macOS.")
  }
  # set conda envrioment of shortstack
  reticulate::use_condaenv(condaenv, required = TRUE)   
  t <- reticulate::py_config()
  exists_res <- t$prefix
  if(exists_res != condaenv){
    stop("R has not connected to the conda environment")
  }
  
  if(input == "sRNA"){
    ### temperamental 
    # exists_res2 <- shortstack_exists()
    # if(exists_res2 < 4 | is.null(exists_res2)){
    #   stop("ShortStack application :
    # --- ShortStack is either not installed or installed incorrectly
    # --- Or the version is too old, please ensure most updated version is installed.")
    # }
    if(mmap != "n"){
      core_map(input_files_dir, 
               output_dir,
               genomefile, 
               condaenv, 
               threads,
               mmap,
               dicermin,
               dicermax,
               mincov,
               pad,
               tidy)
    } else {
      mobile_map(input_files_dir, 
                 output_dir,
                 genomefile, 
                 condaenv, 
                 threads,
                 mmap,
                 dicermin,
                 dicermax,
                 mincov,
                 pad,
                 tidy)
    }
  } else 
    if(input == "mRNA"){
      if (base::missing(sampleData) || !base::inherits(sampleData,
                                                       c("matrix","data.frame", 
                                                         "DataFrame"))) {
    stop("sampleData must be an object of class matrix, data.frame, DataFrame.")
      }
      
      if (missing(annotationfile) || !file.exists(annotationfile) || 
          !grepl("\\.(gff|gff1|gff2|gff3|gff.gz|gff1.gz|gff2.gz|gff3.gz)$", 
                 annotationfile)) {
        stop("Please specify genomefile, a connection to a FASTA file in local")
      }
      
      ### removed as temperamental 
    #   exists_res_hisat <- exists_conda("hisat2")
    #   if(exists_res_hisat == FALSE){
    #     stop("HISAT2 application :
    # --- HISAT2 is not installed within conda environment.")
    #   }
    #   
    #   exists_res_htseq <- exists_conda("htseq")
    #   if(exists_res_htseq == FALSE){
    #     stop("HTSeq application :
    # --- HTSeq is not installed within conda environment.")
    #   }
    #   
    #   exists_res_samtools <- exists_conda("samtools")
    #   if(exists_res_samtools == FALSE){
    #     stop("SAMtools application :
    # --- SAMtools is not installed within conda environment.")
    #   }
  
      mRNA_map(sampleData,
               input_files_dir, 
               output_dir,
               genomefile, 
               condaenv,
               annotationfile,
               threads,  
               order ,
               a, 
               mmap,
               stranded,
               mode,
               nonunique,
               type,
               idattr)

    }
}

#------------------------------------------------------------#
# Title:  Invisible functions                                #
# Author: Katie Jeynes-Cupper (kej031@student.bham.ac.uk) #
# Date:   01.02.23                                           #
#------------------------------------------------------------#
################ remove mapping errors (RNAmobile function) ####################
.remove_mapping_errors <- function(data, controls) {
  class_colnames  <- data %>% dplyr::select(paste0("Count_", controls))
  x <- c()
  if (length(colnames(class_colnames)) > 1){
    for (j in seq_len(nrow(data))){
      if(rowSums(class_colnames[j,])>0){
        x <- c(x,j)
      }else
        x <- c(x)
    }
  } else
    if(length(colnames(class_colnames)) == 1){
      x <- c()
      for (k in seq_len(nrow(data)) ){
        if(stats::na.omit(as.numeric(data[k,colnames(class_colnames)],
                                     na.rm=TRUE))!= 0){
          x <- c(x,k)
        }
      }
    }
  if(is.null(x)){
    data <- data
  } else
    data <- data[-x,]
  return(data)
}
################ Remove mapping errors  #########################
.remove_mapping_errors_V2 <- function(data,  controls, genome.ID) {
  if (base::missing(controls) || !base::inherits(controls, "character")) {
    stop("Please specify a character vector storing names of control
          replicates")
  }
  if (base::missing(genome.ID) || genome.ID %in% "") {
    stop("Please specify a single character string which is present in the all
           the chromosomes within the foriegn genome")
  }
  data_native <- data %>% dplyr::filter(!grepl(genome.ID,chr))
  # subset data to find all rows of forign genome
  data_select <- data %>% dplyr::filter(grepl(genome.ID,chr))
  class_colnames  <- data_select %>% dplyr::select(paste0("Count_", controls))
  if (length(colnames(class_colnames)) > 1){
    x <- c()
    for (j in seq_len(nrow(data_select)) ){
      if(sum(stats::na.omit(as.numeric(data_select[j,colnames(class_colnames)],
                                       na.rm=TRUE)))>0){
        x <- c(x,j)
      }
    }
  } else
    if (length(colnames(class_colnames)) == 1){
      x <- c()
      for (k in seq_len(nrow(data_select)) ){
        if(stats::na.omit(as.numeric(data_select[k,colnames(class_colnames)],
                                     na.rm=TRUE))!= 0){
          x <- c(x,k)
        }
      }
    }
  if(is.null(x)){
    data_id <- data_select
  } else
    if(!is.null(x)){
      data_id <- data_select[-x,]
    }
  data <- rbind(data_native,data_id)
}

################ DESE2 function (RNAdifferentialAnalysis function) #############
.DESeq_normalise <- function(data, conditions){
  column.data <- data.frame(conditions=as.factor(conditions))
  base::rownames(column.data) <- base::colnames(data)
  count.data.set <- DESeq2::DESeqDataSetFromMatrix(countData=data,
                                                   colData=column.data,
                                                   design= ~ conditions)
  count.data.set$conditions <- stats::relevel(count.data.set$conditions,
                                              conditions[1])
  out <- DESeq2::estimateSizeFactors(count.data.set)
  return(out)
}
################ EDGER function (RNAdifferentialAnalysis function) #############
.edgeR_normalise <- function(data, conditions){
  d <- edgeR::DGEList(counts = data, group = factor(conditions))
  result <- edgeR::calcNormFactors(d)
  result$samples
  result<- edgeR::estimateDisp(result)
  result$common.dispersion
  return(result)
}

################ Find RNA complementary sequence (RNAsequence function) ########
find_complementary_sequenceRNA <- function(seq) {
  # conversions
  conversion_nucleotides <- c(A = "U", U = "A", C = "G", G = "C")

  # calculate complementary nt for each
  complementary_calc <- lapply(strsplit(seq, ""), function(nucleotide) {
    conversion_nucleotides[nucleotide]
  })

  output <- sapply(complementary_calc, function(x) paste(x, collapse = ""))

  # Combine into string
  return(output)
}

################ Find DNA complementary sequence (RNAsequence function) #######
find_complementary_sequenceDNA <- function(seq) {
  # conversions
  conversion_nucleotides <- c(A = "T", U = "A", C = "G", G = "C")

  # calc complementary nt for each in string
  complementary_calc <- lapply(strsplit(seq, ""), function(nucleotide) {
    conversion_nucleotides[nucleotide]
  })

  # Combine into string
  output <- sapply(complementary_calc, function(x) paste(x, collapse = ""))
  return(output)
}

##################shortstack exists #####################################

shortstack_exists <- function(){
  # Replace "your_package_name" with the name of the package you want to check
  package_name <- "shortstack"
  cmd <- c(shQuote(package_name),  "--version")
  cmd_a <- paste(cmd,collapse = " ")
  cmd_b <- gsub("^ *| *$", "", cmd_a)
  out <- system(cmd_b, intern=TRUE )
  version <- gsub(".*?([0-9.]+).*", "\\1", out)
  return(version)
}

################## import gff #####################################

gff_import <- function(gff_file, nrows = -1) {
  # Read the GFF file into a dataframe
  gff <- utils::read.table(
    gff_file,
    sep = "\t",
    as.is = TRUE,
    quote = "",
    header = FALSE,
    comment.char = "#",
    nrows = nrows,
    colClasses = c("character", "character", "factor", "integer",
                   "integer", "character", "character", "character","character")
  )
  # convert problematic symbol error
  gff$V9 <- gsub('%', '=',gff$V9)
  colnames(gff) <- c("seqname", "source", "type", "start", "end",
                     "score", "strand", "phase", "attributes")

  if (any(is.na(gff$start)) || any(is.na(gff$end))) {
    stop("The 'start' or 'end' columns contain missing values.")
  }
  return(gff)
}



################### convert character to factor in gramges #####
convertChar2Factor <- function(gr) {
  charCols <- vapply(S4Vectors::elementMetadata(gr), is.character, FUN.VALUE = logical(1))

  if (any(charCols)) {
    gr_metadata <- S4Vectors::elementMetadata(gr)
    gr_metadata[charCols] <- lapply(gr_metadata[charCols], as.factor)
    S4Vectors::elementMetadata(gr) <- gr_metadata
  }
  metadata_cols <- S4Vectors::elementMetadata(gr)
  charlist_cols <- vapply(metadata_cols@listData, function(col)
    inherits(col, "CompressedCharacterList"), FUN.VALUE = logical(1))

  if (any(charlist_cols)) {
    metadata_cols <- metadata_cols[!charlist_cols]
    S4Vectors::elementMetadata(gr) <- metadata_cols
  }
  return(gr)
}






################## core map #####################################
core_map <- function(input_files_dir, output_dir, genomefile, condaenv,
                     threads,mmap, dicermin,dicermax, mincov, pad, tidy){


  # 3 - generate output folders (check if they exist )
  path_1 <- file.path(output_dir, "1_de_novo_detection")
  path_2 <- file.path(output_dir, "2_sRNA_results")
  if (!dir.exists(path_1)) {
    dir.create(path_1)
  }
  if (!dir.exists(path_2)) {
    dir.create(path_2)
  }

  # run command
  names_input_files_dir <- list.files(input_files_dir)
  message("mapping with ShortStack ...")
  stats <- file.path(path_1, "log.txt")
  system(paste0(">> ", stats))

  # 1 - bowtie - build
  # check is alread y done
  index_extension <- "ebwt"
  base_genomefile <- sub('\\.(fasta|fasta.gz|fa|fa.gz|fsa|fsa.gz)$', '',basename(genomefile))
  base_genomefile_path <- sub('\\.(fasta|fasta.gz|fa|fa.gz|fsa|fsa.gz)$', '',(genomefile))

  dir_genomfile <- dirname(genomefile)
  files_dir <- c("ls", dir_genomfile)
  files_dir <- paste(files_dir,collapse = " ")
  files_dir <- gsub("^ *| *$", "", files_dir)
  files_dir_res <- system(files_dir, intern=TRUE)

  index_found <- grep(paste("^", base_genomefile, ".*\\.", index_extension,
                            "$", sep = ""), files_dir_res)
  if (length(index_found) > 0) {
    message("Genome index already built.")
    nline <- paste("echo Genome index already built. >> ",  shQuote(stats))
    system(nline, intern=FALSE)
    nline <- paste("echo '' >> ",  shQuote(stats))
    system(nline, intern=FALSE)
  } else {
    message("Genome index not already built. Building with Bowtie.")
    nline <- paste("echo Genome index not already built. Building with Bowtie: >> ",  shQuote(stats))
    system(nline, intern=FALSE)
    nline <- paste("echo '' >> ",  shQuote(stats))
    system(nline, intern=FALSE)

    if (grepl("\\.(fasta.gz|fa.gz|fsa.gz)$", genomefile)){
      gunzip_cmd <- c("gunzip", genomefile)
      gunzip_cmd <- paste(gunzip_cmd,collapse = " ")
      gunzip_cmd <- gsub("^ *| *$", "", gunzip_cmd)
      system(gunzip_cmd, intern=FALSE)
      genomefile <- tools::file_path_sans_ext(genomefile)
    }

    bowtie_build_cmd <- c("bowtie-build --threads", threads,
                          genomefile, base_genomefile_path, ">>",
                          shQuote(stats), "2>&1")
    bowtie_build_cmd <- paste(bowtie_build_cmd,collapse = " ")
    bowtie_build_cmd <- gsub("^ *| *$", "", bowtie_build_cmd)
    system(bowtie_build_cmd, intern=FALSE) ## -- get it to print to summarydoc.

    message("\nGenome index build. ")
    nline <- paste("echo Genome index complete! >> ",  shQuote(stats))
    system(nline, intern=FALSE)
    nline <- paste("echo '' >> ",  shQuote(stats))
    system(nline, intern=FALSE)
  }

  for (i in seq_along(names_input_files_dir)){
    # file name:
    readfile_name <- sub("\\.(fq|fq.gz|fastq|fastq.gz)$", "", names_input_files_dir[i])
    # step 1 - map as per
    # file out put:
    file_outdir <- file.path(path_1, readfile_name)
    writeLines("\n", con = stats)
    time_cmd <- paste(c("echo", shQuote(as.character(Sys.time())),
                        "Working with sample:",
                        shQuote(readfile_name),
                        ">>", shQuote(stats)), collapse = " ")
    time_cmd <- gsub("^ *| *$", "", time_cmd)
    system(time_cmd, intern=FALSE)

    shortstack_cmd_1 <- c(
      shQuote(Sys.which("shortstack")),
      "--readfile", shQuote(file.path(input_files_dir,
                                      names_input_files_dir[i])),
      "--genomefile", shQuote(genomefile),
      "--threads", shQuote(threads),
      "--mmap", shQuote(mmap),
      "--dicermin", shQuote(dicermin),
      "--dicermax", shQuote(dicermax),
      "--nohp",
      "--mincov 0.5",
      "--pad", shQuote(pad),
      "--outdir", shQuote(file_outdir),">>", shQuote(stats), "2>&1"
    )

    shortstack_cmd_1 <- paste(shortstack_cmd_1,collapse = " ")
    shortstack_cmd_1 <- gsub("^ *| *$", "", shortstack_cmd_1)

    # Run ShortStack using system command
    system(shortstack_cmd_1, intern=FALSE)
  }

  # 5 - merge loci into file
  map_1_files_loci <- list.dirs(path_1, full.names = TRUE, recursive = TRUE)
  map_1_files_loci <- map_1_files_loci[!map_1_files_loci == path_1]
  samples <- basename(map_1_files_loci)

  gff_alignment <- GenomicRanges::GRangesList()
  for (i in samples) {
    file_path <- file.path(path_1, i, "Results.gff3")
    if (file.exists(file_path)) {
      gff_alignment[[i]] <- rtracklayer::import.gff(file_path)
    } else{
      stop("File does not exist:", file_path, "\n")
    }
  }
  gff_merged <- GenomicRanges::reduce(unlist(gff_alignment),
                                      ignore.strand = TRUE)
  gff_merged <- as.data.frame(gff_merged)
  colnames(gff_merged)[1] <- "chr"
  if('*' %in% gff_merged$strand){
    gff_merged <- gff_merged[, -match("strand", colnames(gff_merged))]
  }

  locifile_txt <- data.frame(Locus = paste0(gff_merged$chr, ":",
                                            gff_merged$start,"-",
                                            gff_merged$end),
                             Cluster = paste0("cluster_",
                                              seq_len(nrow(gff_merged))))

  loci_out <- file.path(path_1,"locifile.txt")
  utils::write.table(locifile_txt, file = loci_out, quote = FALSE,
                     sep = "\t", row.names = FALSE, col.names = FALSE)

  # 6 - mapping 2
  stats_2 <- file.path(path_2, "log.txt")
  system(paste0(">> ", stats_2))
  ###################.  check bam location ull is correct
  for (i in seq_along(names_input_files_dir)){
    # file name:
    readfile_name <- sub("\\.(fq|fq.gz|fastq|fastq.gz)$", "", names_input_files_dir[i])
    # step 1 - map as per
    # file out put:
    file_outdir <- file.path(path_2, readfile_name)
    writeLines("\n", con = stats_2)
    time_cmd <- paste(c("echo", shQuote(as.character(Sys.time())),
                        "Working with sample:",
                        shQuote(readfile_name),
                        ">>", shQuote(stats_2)), collapse = " ")
    time_cmd <- gsub("^ *| *$", "", time_cmd)
    system(time_cmd, intern=FALSE)
    shortstack_cmd_2 <- c(
      shQuote(Sys.which("shortstack")),
      "--bamfile", shQuote(file.path(path_1,readfile_name,
                                     paste0(readfile_name,".bam"))),
      "--locifile", shQuote(loci_out),
      "--genomefile", shQuote(genomefile),
      "--threads", shQuote(threads),
      "--mmap", shQuote(mmap),
      "--dicermin", shQuote(dicermin),
      "--dicermax", shQuote(dicermax),
      "--nohp",
      "--mincov",shQuote(mincov),
      "--pad", shQuote(pad),
      "--outdir", shQuote(file_outdir),">>", shQuote(stats_2), "2>&1"
    )

    shortstack_cmd_2 <- paste(shortstack_cmd_2,collapse = " ")
    shortstack_cmd_2 <- gsub("^ *| *$", "", shortstack_cmd_2)

    # Run ShortStack using system command
    system(shortstack_cmd_2, intern=FALSE)
  }

  # remove excess files
  if (tidy) {
    # List all directories in path_1 and exclude path_1 itself
    map_1_files <- list.dirs(path_1, full.names = TRUE, recursive = TRUE)
    map_1_files <- map_1_files[!map_1_files == path_1]

    # Iterate over each directory and remove files that don't match the
    # conditions
    for (j in seq_along(map_1_files)) {
      rm_cmd_1 <- paste0("find '", map_1_files[j],
                         "' -type f ! -name '*.bam' -exec rm {} \\;")
      system(rm_cmd_1, intern=FALSE)
    }

    # List all directories in path_2 and exclude path_2 itself
    map_2_files <- list.dirs(path_2, full.names = TRUE, recursive = TRUE)
    map_2_files <- map_2_files[!map_2_files == path_2]

    # Iterate over each directory and remove files that don't match the
    # conditions
    for (k in seq_along(map_2_files)) {
      rm_cmd_2 <- paste0("find '", map_2_files[k],
                         "' -type f ! \\( -name '*.bam' -o -name 'Results.txt' \\) -exec rm {} \\;")
      system(rm_cmd_2, intern=FALSE)
    }
  }

  message("\n\n --- Mapping of sRNAseq samples is complete --- ")
  message("Results saved to: ", path_1, " & ", path_2)
  message("Loci file saved to: ", loci_out)

}



################## mobile map  #####################################
mobile_map <- function(input_files_dir, output_dir, genomefile, condaenv,
                       threads,mmap, dicermin,dicermax, mincov, pad, tidy){

  # 3 - generate output folders (check if they exist )
  path_1 <- file.path(output_dir, "1_de_novo_detection")
  path_2 <- file.path(output_dir, "2_sRNA_results")

  if (!dir.exists(path_1)) {
    dir.create(path_1)
  }
  if (!dir.exists(path_2)) {
    dir.create(path_2)
  }
  message("Begining pre-processing for mobile sRNAseq ...")

  stats <- file.path(path_1, "log.txt")
  system(paste0(">> ", stats))

  # 1 - bowtie - build
  # check is alread y done
  index_extension <- "ebwt"
  base_genomefile <- sub('\\.(fasta|fasta.gz|fa|fa.gz|fsa|fsa.gz)$', '',basename(genomefile))
  base_genomefile_path <- sub('\\.(fasta|fasta.gz|fa|fa.gz|fsa|fsa.gz)$', '',(genomefile))

  dir_genomfile <- dirname(genomefile)
  files_dir <- c("ls", dir_genomfile)
  files_dir <- paste(files_dir,collapse = " ")
  files_dir <- gsub("^ *| *$", "", files_dir)
  files_dir_res <- system(files_dir, intern=TRUE)

  index_found <- grep(paste("^", base_genomefile, ".*\\.", index_extension,
                            "$", sep = ""), files_dir_res)


  if (length(index_found) > 0) {
    message("Genome index already built.")
    nline <- paste("echo Genome index already built. >> ",  shQuote(stats))
    system(nline, intern=FALSE)
    nline <- paste("echo '' >> ",  shQuote(stats))
    system(nline, intern=FALSE)

  } else {

    message("Genome index not already built. Building with Bowtie...")
    nline <- paste("echo Genome index not already built. Building with Bowtie: >> ",  shQuote(stats))
    system(nline, intern=FALSE)
    nline <- paste("echo '' >> ",  shQuote(stats))
    system(nline, intern=FALSE)

    if (grepl("\\.(fasta.gz|fa.gz|fsa.gz)$", genomefile)){
      gunzip_cmd <- c("gunzip", genomefile)
      gunzip_cmd <- paste(gunzip_cmd,collapse = " ")
      gunzip_cmd <- gsub("^ *| *$", "", gunzip_cmd)
      system(gunzip_cmd, intern=FALSE)
      genomefile <- tools::file_path_sans_ext(genomefile)
    }
    bowtie_build_cmd <- c("bowtie-build --threads", threads,
                          genomefile, base_genomefile_path, ">>",
                          shQuote(stats), "2>&1")
    bowtie_build_cmd <- paste(bowtie_build_cmd,collapse = " ")
    bowtie_build_cmd <- gsub("^ *| *$", "", bowtie_build_cmd)
    system(bowtie_build_cmd, intern=FALSE) ## -- get it to print to summarydoc.

    message("\nGenome index build. ")
    nline <- paste("echo Genome index complete! >> ",  shQuote(stats))
    system(nline, intern=FALSE)
    nline <- paste("echo '' >> ",  shQuote(stats))
    system(nline, intern=FALSE)
  }

  # 2-  run bowtie mappling ## -- get it to print to a summary doc.
  names_input_files_dir <- list.files(input_files_dir)
  message("mapping with Bowtie ...")

  p1_path <- file.path(path_1,"Alignment")
  p1_dir <- dir.create(p1_path)

  #bw message
  bowtie_cmd_message <-c("Mapping with Bowtie, Running Command:
  bowtie -p", threads,
                         "-v 0 -a -m 1 --sam -x [genomefile] [fastqfile] | samtools view -bS",
                         "| samtools sort -o [outputfile]")
  bowtie_cmd_message <- paste(bowtie_cmd_message,collapse = " ")
  bowtie_cmd_message <- gsub("^ *| *$", "", bowtie_cmd_message)
  writeLines(bowtie_cmd_message, con = stats)
  writeLines("\n", con = stats)

  for (i in seq_along(names_input_files_dir)){
    # file name:
    writeLines("\n", con = stats)
    readfile_name <- sub("\\.(fq|fq.gz|fastq|fastq.gz)$", "", names_input_files_dir[i])
    # step 1 - map as per
    # file output folder:
    op <- paste0(readfile_name,".bam")
    output_file <- file.path(path_1,"Alignment",op)
    time_cmd <- paste(c("echo", shQuote(as.character(Sys.time())),
                        "Alignment with Bowtie for sample:",
                        shQuote(readfile_name),  ">>",
                        shQuote(stats)), collapse = " ")
    time_cmd <- gsub("^ *| *$", "", time_cmd)
    system(time_cmd, intern=FALSE)

    bowtie_cmd_1 <- c("( bowtie",
                      "-p", shQuote(threads),
                      "-v 0 -a -m 1 --sam -x",
                      shQuote(base_genomefile_path),
                      shQuote(file.path(input_files_dir,
                                        names_input_files_dir[i])),
                      "| samtools view -bS",
                      "| samtools sort -o",shQuote(output_file), ")",
                      "2>>", shQuote(stats))

    bowtie_cmd_1 <- paste(bowtie_cmd_1,collapse = " ")
    bowtie_cmd_1 <- gsub("^ *| *$", "", bowtie_cmd_1)
    system(bowtie_cmd_1, intern=FALSE)

  }

  #bw message
  writeLines("\n", con = stats)
  clustering_cmd_message <-c("echo Running sRNA De Novo Detection: >>",
                             shQuote(stats))

  clustering_cmd_message <- paste(clustering_cmd_message,collapse = " ")
  clustering_cmd_message <- gsub("^ *| *$", "", clustering_cmd_message)
  system(clustering_cmd_message, intern=FALSE)


  mapped_file_names <- list.files(p1_path)
  p2_path <- file.path(path_1,"Cluster")
  p2_dir <- dir.create(p2_path)

  # 3 - shorstack clustering
  for (i in seq_along(mapped_file_names)){
    # file name:
    readfile_name <- sub("\\.\\w+$", "", mapped_file_names[i])
    # file out put:
    file_outdir <- file.path(p2_path, readfile_name)
    writeLines("\n", con = stats)
    time_cmd <- paste(c("echo", shQuote(as.character(Sys.time())),
                        "De novo sRNA detection for sample:",
                        shQuote(readfile_name),
                        ">>", shQuote(stats)), collapse = " ")
    time_cmd <- gsub("^ *| *$", "", time_cmd)
    system(time_cmd, intern=FALSE)

    shortstack_cmd_1 <- c(
      shQuote(Sys.which("shortstack")),
      "--bamfile", shQuote(file.path(p1_path,mapped_file_names[i])),
      "--genomefile", shQuote(genomefile),
      "--threads", shQuote(threads),
      "--dicermin", shQuote(dicermin),
      "--dicermax", shQuote(dicermax),
      "--nohp",
      "--mincov",shQuote(mincov),
      "--pad", shQuote(pad),
      "--outdir", shQuote(file_outdir),">>", shQuote(stats), "2>&1"
    )

    shortstack_cmd_1 <- paste(shortstack_cmd_1,collapse = " ")
    shortstack_cmd_1 <- gsub("^ *| *$", "", shortstack_cmd_1)

    # Run ShortStack using system command
    system(shortstack_cmd_1, intern=FALSE)
  }

  # 5 - merge loci into file. clustered_files
  clustered_files <- list.dirs(p2_path, full.names = TRUE, recursive = TRUE)
  clustered_files <- clustered_files[!clustered_files == p2_path]
  samples <- basename(clustered_files)

  gff_alignment <- GenomicRanges::GRangesList()
  for (i in samples) {
    file_path <- file.path(p2_path, i, "Results.gff3")
    if (file.exists(file_path)) {
      gff_alignment[[i]] <- rtracklayer::import.gff(file_path)
    } else{
      stop("File does not exist:", file_path, "\n")
    }
  }
  gff_merged <- GenomicRanges::reduce(unlist(gff_alignment),
                                      ignore.strand = TRUE)
  gff_merged <- as.data.frame(gff_merged)
  colnames(gff_merged)[1] <- "chr"
  if('*' %in% gff_merged$strand){
    gff_merged <- gff_merged[, -match("strand", colnames(gff_merged))]
  }
  locifile_txt <- data.frame(Locus = paste0(gff_merged$chr, ":",
                                            gff_merged$start,"-",
                                            gff_merged$end),
                             Cluster = paste0("cluster_",
                                              seq_len(nrow(gff_merged))))

  loci_out <- file.path(path_1,"locifile.txt")
  utils::write.table(locifile_txt, file = loci_out, quote = FALSE,
                     sep = "\t", row.names = FALSE, col.names = FALSE)

  # move bam files into respecitve dir.
  for(i in seq_along(mapped_file_names)){
    bam_path <- file.path(p1_path,mapped_file_names[i])
    file_name_without_ext <- tools::file_path_sans_ext(mapped_file_names[i])
    saveloc <- file.path(p2_path, file_name_without_ext)

    organise_cmd <- c("mv", bam_path, paste0(saveloc, "/"))
    organise_cmd <- paste(organise_cmd,collapse = " ")
    organise_cmd <- gsub("^ *| *$", "", organise_cmd)
    system(organise_cmd, intern=FALSE)
  }

  ###### move and remove cluster dir.
  move_clusters_cmd <- c("mv", paste0(p2_path, "/*"), paste0(path_1, "/"))
  move_clusters_cmd <- paste(move_clusters_cmd,collapse = " ")
  move_clusters_cmd <- gsub("^ *| *$", "", move_clusters_cmd)
  system(move_clusters_cmd, intern=FALSE)

  # delete the alignment & cluster folder folder:
  delete_align <- c("rm -r", p1_path, p2_path)
  delete_align <- paste(delete_align,collapse = " ")
  delete_align <- gsub("^ *| *$", "", delete_align)
  system(delete_align, intern=FALSE)

  ####### final clustering
  stats_2 <- file.path(path_2, "log.txt")
  system(paste0(">> ", stats_2))

  clustering_cmd_message<-c("echo Running sRNA Clustering with loci information >>",
                            shQuote(stats_2))

  clustering_cmd_message <- paste(clustering_cmd_message,collapse = " ")
  clustering_cmd_message <- gsub("^ *| *$", "", clustering_cmd_message)
  system(clustering_cmd_message, intern=FALSE)

  for (i in seq_along(mapped_file_names)){
    # file name:
    readfile_name <- sub("\\.\\w+$", "", mapped_file_names[i])
    # step 1 - map as per
    # file out put:
    file_outdir <- file.path(path_2, readfile_name)
    writeLines("\n", con = stats_2)
    time_cmd <- paste(c("echo", shQuote(as.character(Sys.time())),
                        "Working on sample:",
                        shQuote(readfile_name),
                        ">>", shQuote(stats_2)), collapse = " ")
    time_cmd <- gsub("^ *| *$", "", time_cmd)
    system(time_cmd, intern=FALSE)

    shortstack_cmd_2 <- c(
      shQuote(Sys.which("shortstack")),
      "--bamfile", shQuote(file.path(path_1,readfile_name,
                                     mapped_file_names[i])),
      "--locifile", shQuote(loci_out),
      "--genomefile", shQuote(genomefile),
      "--threads", shQuote(threads),
      "--dicermin", shQuote(dicermin),
      "--dicermax", shQuote(dicermax),
      "--mincov",shQuote(mincov),
      "--pad", shQuote(pad),
      "--outdir", shQuote(file_outdir),">>", shQuote(stats_2), "2>&1"
    )

    shortstack_cmd_2 <- paste(shortstack_cmd_2,collapse = " ")
    shortstack_cmd_2 <- gsub("^ *| *$", "", shortstack_cmd_2)

    # Run ShortStack using system command
    system(shortstack_cmd_2, intern=FALSE)
  }

  #####  clean up
  if (tidy) {
    # List all directories in path_2 and exclude path_2 itself
    map_2_files <- list.dirs(path_2, full.names = TRUE, recursive = TRUE)
    map_2_files <- map_2_files[!map_2_files == path_2]

    # Iterate over each directory and remove files that don't match the conditions
    for (k in seq_along(map_2_files)) {
      rm_cmd_2 <- paste0("find '", map_2_files[k],
                         "' -type f ! \\( -name '*.bam' -o -name 'Results.txt' \\) -exec rm {} \\;")
      system(rm_cmd_2, intern=FALSE)
    }
  }

  message("\n \n --- Mapping of sRNAseq samples is complete --- ")
  message("Results saved to: ", path_1, " & ", path_2)
  message("Loci file saved to: ", loci_out)
}







################## mRNA map  #####################################

mRNA_map <- function(sampleData,
                     input_files_dir,
                     output_dir,
                     genomefile,
                     condaenv,
                     annotationfile,
                     threads,
                     mmap,
                     order ,
                     a,
                     stranded,
                     mode,
                     nonunique,
                     type,
                     idattr,
                     python){
  # generate output folders (check if they exist )
  path_1 <- file.path(output_dir, "1_mRNA_preprocessing")
  if (!dir.exists(path_1)) {
    dir.create(path_1)
  }

  # check for genome index - genomefile
  stats <- file.path(path_1, "alignment_stats.txt")
  system(paste0(">> ", stats))

  # 1 - bowtie - build
  index_extension <- "ht2"
  if (grepl("\\.(fasta.gz|fa.gz|fsa.gz)$", genomefile)){
    base_genomefile_1 <- tools::file_path_sans_ext(basename(genomefile))
    base_genomefile <- tools::file_path_sans_ext(base_genomefile_1)
    base_genomefile_path_1 <- tools::file_path_sans_ext(genomefile)
    base_genomefile_path <- tools::file_path_sans_ext(base_genomefile_path_1)

  } else {
    base_genomefile_path <- tools::file_path_sans_ext(genomefile)
    base_genomefile <- tools::file_path_sans_ext(basename(genomefile))
  }

  dir_genomfile <- dirname(genomefile)
  files_dir <- c("ls", dir_genomfile)
  files_dir <- paste(files_dir,collapse = " ")
  files_dir <- gsub("^ *| *$", "", files_dir)
  files_dir_res <- system(files_dir, intern=TRUE)

  index_found <- grep(paste("^", base_genomefile, ".*\\.", index_extension,
                            "$", sep = ""), files_dir_res)

  if (length(index_found) > 0) {
    message("Genome index already built.")
  } else {
    message("Genome index not already built. Building with Bowtie... ")
    if (grepl("\\.(fasta.gz|fa.gz|fsa.gz)$", genomefile)){
      gunzip_cmd <- c("gunzip", genomefile)
      gunzip_cmd <- paste(gunzip_cmd,collapse = " ")
      gunzip_cmd <- gsub("^ *| *$", "", gunzip_cmd)
      system(gunzip_cmd, intern=FALSE)
      genomefile <- tools::file_path_sans_ext(genomefile)
    }
    hisat_build_cmd <- c("hisat2-build --threads", threads,
                         genomefile, base_genomefile_path, ">>",
                         shQuote(stats), "2>&1")
    hisat_build_cmd <- paste(hisat_build_cmd,collapse = " ")
    hisat_build_cmd <- gsub("^ *| *$", "", hisat_build_cmd)
    system(hisat_build_cmd, intern=FALSE) ## -- get it to print to summary doc.
    message("\nGenome index build. ")
  }
  nline <- paste("echo '' >> ",  shQuote(stats))
  system(nline, intern=FALSE)

  # paired end
  if(ncol(sampleData)>2){
    pairend_cmd_message <-paste("echo Running HISAT2.. >>",shQuote(stats))

    pairend_cmd_message <- paste(pairend_cmd_message,collapse = " ")
    pairend_cmd_message <- gsub("^ *| *$", "", pairend_cmd_message)
    system(pairend_cmd_message, intern=FALSE)
    nline <- paste("echo '' >> ",  shQuote(stats))
    system(nline, intern=FALSE)

    pairend_cmd_2_message <-paste("echo Running HTSeq... >>", shQuote(stats))
    pairend_cmd_2_message <- paste(pairend_cmd_2_message,collapse = " ")
    pairend_cmd_2_message <- gsub("^ *| *$", "", pairend_cmd_2_message)
    system(pairend_cmd_2_message, intern=FALSE)
    nline <- paste("echo '' >> ",  shQuote(stats))
    system(nline, intern=FALSE)

    for(i in seq_len(nrow(sampleData))){
      pair_files <- as.character(sampleData[i,])
      sample_name <- pair_files[1]
      fastq_1 <- pair_files[2]
      fastq_2 <- pair_files[3]
      unqiuefolder <- file.path(output_dir,sample_name)
      unqiuefolder_mkdir <- dir.create(unqiuefolder, recursive = TRUE)
      bam_name <- paste0(sample_name,".bam")
      bam <-file.path(unqiuefolder, bam_name)
      time_cmd <- paste(c("echo", shQuote(as.character(Sys.time())), ">>",
                          shQuote(stats)), collapse = " ")
      time_cmd <- gsub("^ *| *$", "", time_cmd)
      system(time_cmd, intern=FALSE)
      sample_cmd <- paste(c("echo Working with sample:",
                            shQuote(sample_name), ">>", shQuote(stats)),
                          collapse = " ")
      sample_cmd <- gsub("^ *| *$", "", sample_cmd)
      system(sample_cmd, intern=FALSE)
      stateline <- paste("echo 1.Alignment: >> ",  shQuote(stats))
      system(stateline, intern=FALSE)

      pairEndmap_cmd <- c("hisat2 -p", threads,
                          "-x", shQuote(base_genomefile_path),"-1",
                          shQuote(file.path(input_files_dir, fastq_1)),
                          "-2",shQuote(file.path(input_files_dir, fastq_2)),
                          "| samtools view -bS | samtools sort -o",
                          shQuote(bam), "2>>", shQuote(stats))
      pairEndmap_cmd <- paste(pairEndmap_cmd,collapse = " ")
      pairEndmap_cmd <- gsub("^ *| *$", "", pairEndmap_cmd)
      system(pairEndmap_cmd, intern=FALSE)
      stateline <- paste("echo 2.Raw count: >> ",  shQuote(stats))
      system(stateline, intern=FALSE)
      # if unique only:
      if(mmap == "n"){
        out_filename <- paste0(sample_name,"_uniqueReads1.bam")
        out <- file.path(unqiuefolder,out_filename )
        unique_reads <- c("samtools view", shQuote(bam), "| grep",
                          c("NH:i:1"),">", shQuote(out))
        unique_reads <- paste(unique_reads,collapse = " ")
        unique_reads <- gsub("^ *| *$", "", unique_reads)
        system(unique_reads, intern=FALSE)

        # reheader
        header_filename <-  paste0(sample_name,"_header.txt")
        header <- file.path(unqiuefolder,header_filename)
        reheader1 <- c("samtools view -H", shQuote(bam), ">", shQuote(header))
        reheader1 <- paste(reheader1,collapse = " ")
        reheader1 <- gsub("^ *| *$", "", reheader1)
        system(reheader1, intern=FALSE)

        bam_rce_filename <- paste0(sample_name,"_unique.bam")
        bam_rce <- file.path(unqiuefolder, bam_rce_filename)
        reheader2 <- c("cat", shQuote(header), shQuote(out), ">",  shQuote(bam_rce))
        reheader2 <- paste(reheader2,collapse = " ")
        reheader2 <- gsub("^ *| *$", "", reheader2)
        system(reheader2, intern=FALSE)

        # remove truncated:
        rmtrunc <- c("rm", shQuote(out), shQuote(header), shQuote(bam))
        rmtrunc <- paste(rmtrunc,collapse = " ")
        rmtrunc <- gsub("^ *| *$", "", rmtrunc)
        system(rmtrunc, intern=FALSE)

      } else
        if (mmap != "n"){
          bam_rce <- bam
        }
      # counts ---
      count_file <-file.path(unqiuefolder, "Results.txt")
      HTseq_cmd <- c(shQuote(python)," ",
                     "-m HTSeq.scripts.count", " ",
                     "--format=bam", " ",
                     "--order=",shQuote(order), " ",
                     "--a=", shQuote(a)," ",
                     "--stranded=",shQuote(stranded)," ",
                     "--mode=",shQuote(mode), " ",
                     "--nonunique=",shQuote(nonunique)," ",
                     "--type=",shQuote(type)," ",
                     "--idattr=", shQuote(idattr), " ",
                     shQuote(bam_rce), " ",
                     shQuote(annotationfile), " ",
                     " > ", shQuote(count_file),
                     " 2>> ", shQuote(stats))
      HTseq_cmd <- paste(HTseq_cmd,collapse = "")
      HTseq_cmd <- gsub("^ *| *$", "", HTseq_cmd)
      system(HTseq_cmd, intern=FALSE)

      complete_cmd <- paste(c("echo Complete.", ">>", shQuote(stats)),
                            collapse = " ")
      complete_cmd <- gsub("^ *| *$", "", complete_cmd)
      system(complete_cmd, intern=FALSE)
      nline <- paste("echo '' >> ",  shQuote(stats))
      system(nline, intern=FALSE)
    }
  } else {
    singleend_cmd_message <- paste("echo Running HISAT2.. >>", shQuote(stats))

    singleend_cmd_message <- paste(singleend_cmd_message,collapse = " ")
    singleend_cmd_message <- gsub("^ *| *$", "", singleend_cmd_message)
    system(singleend_cmd_message, intern=FALSE)
    nline <- paste("echo '' >> ",  shQuote(stats))
    system(nline, intern=FALSE)

    singleend_cmd_2_message <- paste(
      "echo Running HTSeq... >> ", shQuote(stats))

    singleend_cmd_2_message <- paste(singleend_cmd_2_message, collapse = "")
    singleend_cmd_2_message <- gsub("^ *| *$", "", singleend_cmd_2_message)
    system(singleend_cmd_2_message, intern=FALSE)

    nline <- paste("echo '' >> ",  shQuote(stats))
    system(nline, intern=FALSE)

    for(k in seq_len(nrow(sampleData))) {
      pair_files <- as.character(sampleData[k,])
      sample_name <- pair_files[1]
      fastq_1 <- pair_files[2]
      unqiuefolder <- file.path(path_1,sample_name)
      unqiuefolder_mkdir <- dir.create(unqiuefolder, recursive = TRUE)
      bam_name <- paste0(sample_name,".bam")
      bam <-file.path(unqiuefolder, bam_name)
      time_cmd <- paste(c("echo", shQuote(as.character(Sys.time())), ">>",
                          shQuote(stats)), collapse = " ")
      time_cmd <- gsub("^ *| *$", "", time_cmd)
      system(time_cmd, intern=FALSE)
      sample_cmd <- paste(c("echo Working with sample:",
                            shQuote(sample_name), ">>", shQuote(stats)),
                          collapse = " ")
      sample_cmd <- gsub("^ *| *$", "", sample_cmd)
      system(sample_cmd, intern=FALSE)
      stateline <- paste("echo 1.Alignment: >> ",  shQuote(stats))
      system(stateline, intern=FALSE)
      singleEndmap <- c("(hisat2 -p", threads,
                        "-x", shQuote(base_genomefile_path),"-U",
                        shQuote(file.path(input_files_dir,fastq_1)),
                        "| samtools view -bS | samtools sort -o",
                        shQuote(bam),") 2>>", shQuote(stats))
      singleEndmap <- paste(singleEndmap,collapse = " ")
      singleEndmap <- gsub("^ *| *$", "", singleEndmap)
      system(singleEndmap, intern=FALSE)
      stateline <- paste("echo 2.Raw count: >> ",  shQuote(stats))
      system(stateline, intern=FALSE)

      if(mmap == "n"){
        out_filename <-paste0(sample_name,"_uniqueReads1.bam")
        out <- file.path(unqiuefolder, out_filename)
        unique_reads <- c("samtools view", shQuote(bam), "| grep",
                          c("NH:i:1"),">", shQuote(out))
        unique_reads <- paste(unique_reads,collapse = " ")
        unique_reads <- gsub("^ *| *$", "", unique_reads)
        system(unique_reads, intern=FALSE)

        # reheader
        header_filename <- paste0(sample_name,"_header.txt")
        header <- file.path(unqiuefolder, header_filename)
        reheader1 <- c("samtools view -H", shQuote(bam), ">", shQuote(header))
        reheader1 <- paste(reheader1,collapse = " ")
        reheader1 <- gsub("^ *| *$", "", reheader1)
        system(reheader1, intern=FALSE)

        bam_rce_filename <- paste0(sample_name,"_unique.bam")
        bam_rce <- file.path(unqiuefolder, bam_rce_filename)
        reheader2 <- c("cat", shQuote(header), shQuote(out), ">",  shQuote(bam_rce))
        reheader2 <- paste(reheader2,collapse = " ")
        reheader2 <- gsub("^ *| *$", "", reheader2)
        system(reheader2, intern=FALSE)

        # remove truncated:
        rmtrunc <- c("rm", shQuote(out), shQuote(header), shQuote(bam))
        rmtrunc <- paste(rmtrunc,collapse = " ")
        rmtrunc <- gsub("^ *| *$", "", rmtrunc)
        system(rmtrunc, intern=FALSE)

      } else
        if (mmap != "n"){
          bam_rce <- bam
        }
      # counts ---
      count_file <-file.path(unqiuefolder, "Results.txt")
      HTseq_cmd <- c(shQuote(python), " ",
                      "-m HTSeq.scripts.count"," ",
                     "--format=bam", " ",
                     "--stranded=",shQuote(stranded), " ",
                     "-a=", shQuote(a), " ",
                     "--mode=",shQuote(mode), " ",
                     "--nonunique=",shQuote(nonunique), " ",
                     "--type=",shQuote(type)," ",
                     "--idattr=", shQuote(idattr)," ",
                     shQuote(bam_rce), " ",  shQuote(annotationfile)," ",
                     " > ", shQuote(count_file),  " 2>> ", shQuote(stats))
      HTseq_cmd <- paste(HTseq_cmd,collapse = "")
      HTseq_cmd <- gsub("^ *| *$", "", HTseq_cmd)
      system(HTseq_cmd, intern=FALSE)

      complete_cmd <- paste(c("echo Complete.", ">>", shQuote(stats)),
                            collapse = " ")
      complete_cmd <- gsub("^ *| *$", "", complete_cmd)
      system(complete_cmd, intern=FALSE)
      nline <- paste("echo '' >> ",  shQuote(stats))
      system(nline, intern=FALSE)
    }
  }

  message("\n\n --- Mapping of mRNAseq samples is complete --- ")
  message("Results saved to: ", path_1)
}



################## mRNA map extras  #####################################

exists_conda <- function(package_name){
  # Replace "your_package_name" with the name of the package you want to check
  cmd <- paste(c("conda list | grep", shQuote(package_name)), collapse = " ")
  cmd_b <- gsub("^ *| *$", "", cmd)
  out <- system(cmd_b, intern=TRUE )

  if (length(out) == 0) {
    res <- FALSE
  } else {
    res <- TRUE
  }
  return(res)
}

exists_htseq <- function(package_name){
  # Replace "your_package_name" with the name of the package you want to check
  cmd <- paste("htseq-count --version", collapse = " ")
  cmd_b <- gsub("^ *| *$", "", cmd)
  out <- system(cmd_b, intern=TRUE )

  if (length(out) == 0) {
    res <- FALSE
  } else {
    res <- TRUE
  }
  return(res)
}

################## RNAdistribution extra #####################################

reorder_table <- function(tbl, order) {
  if (is.null(names(tbl))) {
    tbl[match(order, dimnames(tbl)[[1]])]
  } else {
    tbl[order]
  }
}




################## baymobil exists #####################################
# check if software is installed bcftools + snpEFF

snpEFF_exists <- function(){
  out <- system(paste("conda list -n", envname), intern = TRUE)
  found <- grep("snpEff", out, ignore.case = TRUE, value = TRUE)
  return(found)
}

bcftools_exists <- function(){
  out <- system(paste("conda list -n", envname), intern = TRUE)
  found <- grep("bcftools", out, ignore.case = TRUE, value = TRUE)
  return(found)
}







################## global variable storage #####################################
utils::globalVariables(c("ID", "DicerConsensus", "nt_20", "nt_21", "nt_22",
                         "nt_23", "nt_24", "group", "qc", "score", "phase",
                         "type", "V1", "V10", "V11", "V12", "V13", "V14", "V15",
                         "V16", "V17", "V2", "V3", "V4", "V5", "V6", "V7", "V8",
                         "V9", "padj",".", "nt_N", "n", "FPKM_mean", "chr",
                         "key", "Count", "Class", "padjusted", "pvalue", "freq",
                         "value" , "variable" , "repeats_info" , "Genome" ,
                         "Dataset" ,"setNames" , "DicerCall" , "Reads" , "RPM" ,
                         "MajorRNA", "i", "other", "report", "DicerCounts",
                         "Sequence", "new_df",  "PC1", "PC2", "Conditions",
                         "name", "Length", "Locus", "Name", "SampleCounts",
                         "UniqueReads", "groups", "is", "log2FoldChange","mRNA",
                         "no", "none", "pos", "significance", "tidy", "a",
                         "data", "complete.cases", ".data", "width", "Origin",
                         "percentage" ))

#' Summarise the distribution of sRNA clusters across genomic features
#'
#' @description Calculates the number/proportion of genomic features within the
#' supplied annotations and calculates the number/proportion of sRNA clusters
#' which overlap with these genomic features.
#'
#' @details
#' `RNAfeatures` calculates the number/percentage of sRNA clusters which
#' overlap with genomic features based on their genomic coordinates.
#'
#'
#' @seealso [mobileRNA::RNAmergeAnnotations()] to merge 2 GFF files into 1.
#'
#' @param data data.frame; generated by [mobileRNA::RNAimport()]
#'
#' @param annotation path; URL or connection to a GFFFile object. A genome
#' reference annotation file (.gff/.gff1/.gff2/.gff3). Can be in compressed
#' format (gzip).
#'
#' @param repeats path; URL or connection to a GFFFile object. A genome
#' reference annotation file, which only contains information on repeat
#' sequences in the genome (.gff/.gff1/.gff2/.gff3). By default, this is not
#' required, however if there is a specific repeats annotation file for the
#' genome it is suggested to supply it. Can be in compressed format (gzip).
#'
#' @param promoterRegions numeric; defines the upstream promoter region of
#' genes. Default is 1000, which refers to promoters set at 1Kb upstream of
#' genes
#'
#'@param repeat.type character; features type in `annotation` file to represent
#'repeats when `repeats` not supplied.
#'
#'
#'@param rmFeatures vector; type of genomic features to not consider such as
#'"gene" or "exon" etc.
#'
#' @return Returns a table containing the number and percentage of overlaps in
#' the supplied sRNA data set with genomic features within supplied annotation
#' and/or with repeats.
#'
#' @examples
#' data("sRNA_data")
#' features <- RNAfeatures(data = sRNA_data,
#'                        annotation = system.file("extdata",
#'                        "reduced_chr2_Tomato.gff.gz", package="mobileRNA"))
#'
#'@importFrom rtracklayer import
#'@importFrom GenomicRanges findOverlaps
#'@importFrom dplyr select
#'@importFrom dplyr mutate
#'@importFrom dplyr filter
#'@importFrom GenomicRanges makeGRangesFromDataFrame
#'@importFrom GenomicRanges GRangesList
#'@importFrom dplyr %>%
#'@importFrom GenomicRanges promoters
#'@importFrom dplyr inner_join
#'@importFrom GenomicRanges mcols
#'@importFrom S4Vectors queryHits
#'@importFrom dplyr rename
#'@export
RNAfeatures <- function(data, annotation,
                        repeats = NULL,
                        repeat.type = NULL,
                        promoterRegions = 1000,
                        rmFeatures =NULL) {
  if (base::missing(data)) {
    stop("data is missing. data must be an object of class matrix, data.frame,
         DataFrame. ")
  }
  if (!base::inherits(data, c("matrix", "data.frame", "DataFrame"))) {
    stop("data must be an object of class matrix, data.frame, DataFrame.")
  }
  if (missing(annotation) || is.null(annotation) || annotation == "" ||
      !file.exists(annotation)) {
    stop("annotation parameter is missing or empty.")
  }

  annotation_info <-rtracklayer::import(annotation)

  # extract types of genomic features
  if(is.null(rmFeatures) == FALSE){
    annotation_info <- annotation_info[annotation_info$type != rmFeatures, ]
  }

  #make promoter regions
  # if genes presents, then make promorer
  features_genes <- as.character(annotation_info$type)
  if("gene" %in% features_genes){
  promoters <- annotation_info[annotation_info$type %in% "gene", ]
  promoters <- GenomicRanges::promoters(promoters,
                                        upstream = promoterRegions, downstream = 0)
  promoters$type <- "upstream promoter"

  dw_reg <- annotation_info[annotation_info$type %in% "gene", ]
  dw_reg <- GenomicRanges::promoters(dw_reg, upstream = 0,
                                     downstream = promoterRegions)
  dw_reg$type <- "downstream promoter"
  }


  # if repeats present then add to store
  if(!is.null(repeats)){
    repeats <- rtracklayer::import(repeats)
    repeats$type <- "repeats"
  } else
    if(is.null(repeats) && !is.null(repeat.type)){
      repeats <-subset(annotation_info, type==repeat.type)
      repeats$type <- "repeats"
    }

  # combine
  allfeatures <- c(annotation_info,promoters, dw_reg, repeats )

  # convert to grange
  data_gr <- GenomicRanges::makeGRangesFromDataFrame(data,
                                                     keep.extra.columns = T)

  # find overlaps
  overlaps <- suppressWarnings(GenomicRanges::findOverlaps(allfeatures, data_gr))

  # Subset the 'features' GRanges to get only overlapping regions
  overlapping_features <- allfeatures[S4Vectors::queryHits(overlaps)]

  # Extract the 'type' column from the metadata
  feature_types <- GenomicRanges::mcols(overlapping_features)$type


  # Count the occurrences of each feature type
  type_counts <- as.data.frame(table(feature_types))%>%
    dplyr::mutate(`Dataset Proportion (%)` = (Freq / sum(Freq))*100 )%>%
    dplyr::rename("Genomic feature" = feature_types)%>%
    dplyr::mutate("Genomic feature" = gsub("[-_.]", " ", `Genomic feature`))%>%
    dplyr::rename(Dataset = Freq)


  feature_counts <- as.data.frame(table(allfeatures$type))%>%
    dplyr::mutate(`Genome Proportion (%)` = (Freq / sum(Freq))*100 )%>%
    dplyr::rename("Genomic feature" = Var1)%>%
    dplyr::mutate("Genomic feature" = gsub("[-_.]", " ", `Genomic feature`))%>%
    dplyr::rename(Genome = Freq)


  res <- dplyr::inner_join(feature_counts, type_counts, by = "Genomic feature")

    return(res)

}

#' Import and organise sRNAseq & mRNAseq data sets
#'
#' @description Load and organise either sRNAseq or mRNAseq pre-processing
#' results into a single dataframe containing all experimental replicates 
#' specified where rows represent either a sRNA cluster
#' (ie. sRNA producing-locus) or gene, respectively. Based on using the 
#' mobileRNA pre-processing method (See [mobileRNA::mapRNA()]). 
#'
#'
#' @details
#' The `RNAimport()` function requires the user to supply a directory path and 
#' a character vector. The path must be to the pre-processing output. 
#'
#' Following the `mobileRNA` method, for sRNA analysis, the path will be to the 
#' `2_alignment_results` folder. While for mRNA analysis, the path will be to 
#' the `2_raw_counts` folder. Both folders are generated by the 
#' [mobileRNA::mapRNA()] function. The vector should contain strings 
#' that represent and mirror the names of the sample replicate folders in the 
#' above directory. 
#'  
#'  Together this information allows the function to extract the information 
#'  stored in "Result.txt" files of each sample. 
#'  
#'@references 
#' ShortStack \url{https://github.com/MikeAxtell/ShortStack},
#' HISAT2 \url{https://anaconda.org/bioconda/hisat2},
#' HTSeq \url{https://htseq.readthedocs.io/en/master/install.html},
#' SAMtools \url{https://anaconda.org/bioconda/samtools}
#' 
#'@param input string; define type of dataset.
#'"sRNA" for sRNAseq data and "mRNA" for mRNAseq data. 
#'
#' @param directory path; directory containing of sample folders generated by 
#' `ShortStack`
#'
#' @param samples character; vector naming samples correlating
#' to outputted folders within the `directory` path.
#' 
#' @param featuretype character; type of feature. Default is "mRNA", 
#' only for mRNA data. 
#'@param FPKM logical; calculate the FPKM for each sample. Default is FALSE. 
#'
#'@param analysisType character; either "core" or "mobile" to represent the sRNA
#'analysis workflow. Where the "core" sRNA analysis imports all reads (unique
#'& multi-map), while "mobile" sRNA analysis imports only uniquely aligned read
#'counts. Only for sRNA data, default is "mobile". 
#'
#'@param annotation path; directory to genome annotation (GFF) file used for 
#'pre-processing. Only for mRNA data.
#'
#'@param idattr character; GFF attribute to be used as feature ID containing 
#'mRNA names. Several GFF lines with the same feature ID will be considered as 
#'parts of the same  feature. The feature ID is used to identity the counts in 
#'the output table. Default is "Name". Only for mRNA data.
#'
#'@return 
#'**For sRNAseq:**
#'A dataframe where rows represent sRNA clusters and columns represent
#'replicate information extracted from the ShortStack output. Replicate 
#'information includes Dicercall, Counts, and MajorRNA sequence. Each replicate 
#'information is distinguishable as the replicate name is joined as a suffix to 
#'each column name. For example, for a sample called "Sample1", the columns will 
#'include DicerCall_Sample1, Count_Sample1, MajorRNA_Sample1 and RPM_Sample1. 
#'
#'The breakdown of each column:
#'
#'* `Locus` : sRNA cluster locus
#'* `chr` : Chromosome 
#'* `start` : start coordinate of cluster
#'* `end` : end coordinate of cluster
#'* `Cluster` : name of cluster 
#'* `DicerCall_` : the size in nucleotides of most abundant sRNA in the cluster
#'* `Count_` :  number of uniquely aligned sRNA-seq reads that overlap the locus
#'* `MajorRNA_` : RNA sequence of the most abundant sRNA in the cluster
#'* `RPM_` : reads per million
#'* `FPKM_` : Fragments Per Kilobase of transcript per Million mapped reads (only if option activated)
#'
#'  
#'**For mRNAseq:**
#'A dataframe where rows represent genes and columns represent replicate 
#'information extracted from HTseq result. Replicate information includes Counts 
#'and FPKM.  For example, for a sample called "Sample1", the columns will 
#'include Count_Sample1, and FPKM_Sample1. 
#'
#'The breakdown of each column:
#'* `mRNA` : Name of mRNA  
#'* `Locus`: Genomic loci of mRNA
#'* `chr` : Chromosome 
#'* `start` : start coordinate
#'* `end` : end coordinate
#'* `width`: width in nucleotides of regions
#'* `Count_` : number of uniquely aligned mRNA-seq reads that overlap the locus
#'* `FPKM_` : Fragments Per Kilobase of transcript per Million mapped reads 
#'
#'
#' @examples
#' \dontrun{
#' # import sRNAseq data
#' df_sRNA <- RNAimport(input = "sRNA",
#'                      directory = "./analysis/sRNA_mapping_results",
#'                      samples = c("heterograft_1", "heterograft_2",
#'                      "heterograft_3","selfgraft_1" , "selfgraft_2" ,
#'                      "selfgraft_3"))
#'
#'
#'# The output of this function can be explored in the data object sRNA_data
#' data("sRNA_data")
#' head(sRNA_data)
#'
#'
#' # import sRNAseq data
#' df_mRNA <- RNAimport(input = "mRNA",
#'                      directory = "./analysis/mRNA_mapping_results",
#'                      samples = c("heterograft_1", "heterograft_2",
#'                      "heterograft_3","selfgraft_1" , "selfgraft_2" ,
#'                      "selfgraft_3"), 
#'                      annotation = "./merged_annotation.gff3")
#'
#'
#'}
#'
#' @export
#' @importFrom data.table data.table
#' @importFrom data.table setnames
#' @importFrom utils read.table
#' @importFrom data.table fread
#' @importFrom dplyr mutate
#' @importFrom dplyr across
#' @importFrom dplyr contains
#' @importFrom dplyr rename
#' @importFrom tidyr replace_na
#' @importFrom data.table :=
#' @importFrom dplyr %>%
#' @importFrom dplyr filter
#' @importFrom dplyr if_any
#' @importFrom dplyr where
#' @importFrom stats setNames
#' @importFrom utils flush.console
RNAimport <- function(input = c("sRNA", "mRNA"), 
                      directory, 
                      samples, 
                      analysisType = "mobile",
                      annotation,
                      idattr = "Name", 
                      FPKM = FALSE, 
                      featuretype = "mRNA") {
  if (base::missing(input) || !input %in% c("sRNA", "mRNA")) {
    stop("Please state the data-type to the `input` paramter.")
  }
  
  if (base::missing(directory)) {
    stop("Please specify an accessable directory where files are stored")
  }
  if (base::missing(samples)) {
    stop("Please specify a vector storing sample names matching files")
  }
  if(input=="sRNA"){
    if (is.null(analysisType) || !analysisType %in% c("core", "mobile")) {
      stop("Please state the sRNA analysis type; whether it is the 'core' or 'mobile'.") 
    }
    # LOad sample data as list of data frames, with index as file name.
    dt_list <- list()
    total_files <- length(samples)
    file_n <- 0
    message("Importing sRNA data into R...")
    for (file in samples) {
      options(datatable.showProgress = FALSE)
      dt_list[[file]] <- data.table::fread(file.path(directory, file,
                                                  "Results.txt"),header = TRUE)
      Sys.sleep(0.01)
      file_n <- file_n + 1
      message('\r', "---Importing file ", file_n, " of ", total_files,  appendLF = FALSE)
      
    }
    # remove any hashtags from header - added by shortstack
    dt_list <- lapply(dt_list, function(x) setNames(x, gsub("#", "", names(x))))
    # Check each data frame in the list for the required columns
    message(" \nChecking data content...")
    required_cols <- c("Locus", "DicerCall", "Reads", "MajorRNA")
    for (df in dt_list) {
      if (!all(required_cols %in% colnames(df))) {
        stop("Sample data frame does not contain all required columns: ",
             paste(setdiff(required_cols, colnames(df)), ".", collapse = ", ",
                   "Make sure there is not a hashtag or similar in the header
                   line of the input file(s)"))
      }
    }
    message("---Data content is correct.")
    # merge first columns to create list of loci across all samples
    loci <- lapply(dt_list, "[", , "Locus")
    combined_data <- do.call(rbind, loci)
    loci_all <- data.table::data.table(Locus=unique(combined_data$Locus))
    
    # Define a function to update the loci with the matching values from a
    # single input dataframe
    if(analysisType=="core"){
      message("---Core sRNA analysis selected, Counts represent all counts")
    } else {
      message("---Mobile sRNA analysis selected, Counts represent unique mappers")
    }
    update_locus_df <- function(dt, i) {
      # Join loci and the current input df on chromosome and coordinate range
      join_cols <- c("Locus")
      dt_match <- loci_all[dt, on = join_cols, nomatch = 0]
      # Aggregate the matching rows by chromosome, start coordinate, & end coor,
      # and compute the sum of DicerCall, Reads, and RPM values for each group
      if(analysisType == "core"){
        dt_agg <- dt_match[, .(Width=sum(Length),
                               Count=sum(Reads),
                               DicerCall = as.character(DicerCall),
                               MajorRNA = as.character(MajorRNA)),
                           by = join_cols]
      }else
        if(analysisType == "mobile"){
        dt_agg <- dt_match[, .(Width=sum(Length),
                               Count=sum(UniqueReads),
                               DicerCall = as.character(DicerCall),
                               MajorRNA = as.character(MajorRNA)),
                           by = join_cols]
      }
        # Rename the aggregated columns
        total_counts <- sum(dt_agg$Count)
        RPM_cal <- (dt_agg$Count / total_counts) * 1e6
        dt_agg$RPM <- RPM_cal
        if(FPKM){
      dt_agg$FPKM <- (dt_agg$RPM / (dt_agg$Width / 1000)) / sum(dt_agg$RPM)* 1e6
          col_names <- paste0(c("Count_", "DicerCall_","MajorRNA_", "RPM_", 
                                "FPKM_"),  i)
          data.table::setnames(dt_agg, c("Locus","Width", col_names))
        }else {
          col_names <- paste0(c("Count_", "DicerCall_", "MajorRNA_", "RPM_"), 
                              i)
          data.table::setnames(dt_agg, c("Locus","Width", col_names))
        }
      
     
     
      # Merge the aggregated values back into df1
      loci_all[dt_agg, on = join_cols, (col_names) := mget(col_names)]

    }
    # Update loci with the matching values from each input dataframe
    for (i in seq_len(length(dt_list))) {
      update_locus_df(dt_list[[i]], names(dt_list)[i])
    }
    # Fill in missing values with 0 or N
    ## Dicer call needs to character/factor
    loci_all <- loci_all %>%
      dplyr::mutate(dplyr::across(dplyr::contains('Count_'),
                                  ~tidyr::replace_na(.,0))) %>%
      dplyr::mutate(dplyr::across(dplyr::contains('RPM_'),
                                  ~tidyr::replace_na(.,0))) %>%
      dplyr::mutate(dplyr::across(dplyr::contains('DicerCall_'),
                                  ~tidyr::replace_na(.,"N")))%>%
      dplyr::mutate(dplyr::across(dplyr::contains('MajorRNA_'),
                                  ~tidyr::replace_na(.,"N"))) %>%
      dplyr::mutate_all(~ ifelse(. == "*", "N", .)) # remove any astriks to "N"
    
    if(FPKM){
      loci_all <- loci_all %>%
        dplyr::mutate(dplyr::across(dplyr::contains('Count_'),
                                    ~tidyr::replace_na(.,0))) %>%
        dplyr::mutate(dplyr::across(dplyr::contains('RPM_'),
                                    ~tidyr::replace_na(.,0))) %>%
        dplyr::mutate(dplyr::across(dplyr::contains('FPKM_'),
                                    ~tidyr::replace_na(.,0))) %>%
        dplyr::mutate(dplyr::across(dplyr::contains('DicerCall_'),
                                    ~tidyr::replace_na(.,"N")))%>%
        dplyr::mutate(dplyr::across(dplyr::contains('MajorRNA_'),
                                    ~tidyr::replace_na(.,"N"))) %>%
        dplyr::mutate_all(~ ifelse(. == "*", "N", .)) # remove any astriks to "N"
    }
    # Convert loci_all back to a data.frame and return it
    res_data <- as.data.frame(loci_all)
    # Split the Locus column into three new columns
    locus_cols <- data.frame(
      chr = vapply(strsplit(res_data$Locus, split = ":"), "[[", character(1), 1),
      start = vapply(strsplit(vapply(strsplit(res_data$Locus, split = ":"),
                                     "[[", character(1), 2), split = "-"), "[[", 
                     character(1), 1),
      end = vapply(strsplit(vapply(strsplit(res_data$Locus, split = ":"),
                                   "[[", character(1), 2), split = "-"), "[[", 
                   character(1), 2)
    )
    df_final <- cbind(res_data[,1], locus_cols, res_data[, 2:ncol(res_data)])
    names(df_final)[1] <- "Locus"
    # order by chr
    df_final <- df_final[order(df_final$chr),]
    # insert cluster name
    cluster_names <-  paste0("cluster_", seq_len(nrow(df_final)) )
    df_final <- as.data.frame(append(df_final, list(Cluster = cluster_names),
                                     after = 4))
    # Remove rows with no counts 
    count_columns <- grep("Count", names(df_final), value = TRUE)
    condition <- rowSums(df_final[count_columns])
    filtered_data <-  df_final[rowSums(df_final[count_columns])>0,] 
    # return values
    message("\n---Complete!")
    return(filtered_data)
  } 
  if(input == "mRNA"){
    if (base::missing(annotation)) {
      stop("Please specify a accessable path to a GFF file")
    }
    message("Importing mRNA data into R:")
    # load data as list
    sample_data <- list()
    file_n  <- 0
    total_files <- length(samples)
    for (file in samples) {
      sample_data[[file]] <- data.table::fread(file.path(directory, file,
                                                         "Results.txt"),header = TRUE)
              colnames(sample_data[[file]])[1] <- "mRNA"
      colnames(sample_data[[file]])[2] <- "Count"
      
      Sys.sleep(0.01)
      file_n <- file_n + 1
      message('\r', "---Importing file ", file_n, " of ", total_files,  appendLF = FALSE, "\n")
      
    }
    # remove rows with extra info 
    sample_data <- lapply(sample_data, function(x) {
      x[!grepl("__", x$mRNA),]
    })
    
    
    # check each file has two columns
    for (df in sample_data) {
      if (!all(ncol(df) == 2)) {
        stop("mRNA dataset(s) does not contain required columns")
      }
    }
    # merge first columns to create list of genes across all samples
    genes <- lapply(sample_data, "[", , "mRNA")
    genes_all <- unique(Reduce(merge,genes))
    
    # add mRNA locus and width etc
    annotation_file <- rtracklayer::import(annotation)
    genes_info <- as.data.frame(subset(annotation_file, type == featuretype))
    Locus <- paste0(genes_info$seqname, ":",genes_info$start,"-",
                    genes_info$end)
    genes_info <- cbind(Locus, genes_info)
    colnames(genes_info)[colnames(genes_info) %in% idattr] <- "mRNA"
    # merge gene list with annotation info. 
    merged_gene_info <- merge(genes_all, genes_info, by = "mRNA", all.x = TRUE) %>%
      dplyr::select(mRNA, Locus, seqnames, start, end, width, strand, type)%>% 
      dplyr::rename(chr = seqnames)
    gene_widths <- merged_gene_info$width
    
    # ADDs sample information to the genes_all object
    for (i in seq_along(sample_data)){
      matches <- merged_gene_info[sample_data[[i]], on = "mRNA", nomatch = 0]
      matches_values <- matches[, .(Count=sum(Count)),by = "mRNA"]
      
      # Rename the aggregated columns
      col_name <- paste0("Count_", names(sample_data)[i])
      data.table::setnames(matches_values, c("mRNA", col_name))
      # Merge the aggregated values back into df1
      merged_gene_info[matches_values, on = "mRNA", (col_name) := mget(col_name)]
      # Print progress
      
    }
    
    # Fill in missing values with 0 or N
    mRNA_information <- merged_gene_info %>%
      dplyr::mutate(dplyr::across(dplyr::contains('Count_'),
                                  ~tidyr::replace_na(.,0)))
    # set genes as rownames 
    fpkm <- apply(X = subset(mRNA_information, 
                             select = c(-Locus, -mRNA, -chr, -start, -end, -width, -strand, -type)),
                  MARGIN = 2, 
                  FUN = function(x) {
                    sum_x <- sum(as.numeric(x))
                    if (sum_x == 0) {
                      t <- 0
                    } else {
                      t <- 10^9 * x / as.numeric(gene_widths) / sum_x
                    }
                    t
                  })
    
    
    
    # add prefix to all columns 
    fpkm <- data.frame(fpkm)
    names_col <- sub("^Count_", "", colnames(fpkm))
    colnames(fpkm) <- paste0("FPKM_", names_col)
    
    
    # add result to df to output
    mRNA_information <- cbind(mRNA_information, fpkm)
    
    # add thresholding values - number of replicates with counts 
    t <- names(mRNA_information)[grep("^Count_", names(mRNA_information))]
    SampleCounts_vals <- apply(X = subset(mRNA_information, 
                                          select = c(t)),
                               MARGIN = 1, 
                               FUN = function(x) {
                                 length(x[x > 0])
                               })
    
    mRNA_information$SampleCounts <- SampleCounts_vals
    # remove rows with
      mRNA_information <- mRNA_information %>%
        dplyr::filter(SampleCounts != 0)
    message("---Complete!")
    return(as.data.frame(mRNA_information))
    
  }
}

#'Extract RNA sequence from sRNA clusters
#'
#'@description `RNAsequences` extrapolates the RNA sequence for sRNA clusters
#' through two different methods utilising the RNA sequence of the most abundant 
#' transcript identified within each replicate. This can either be determined 
#' by extracting the consensus sequence across replicates or by comparing the
#' sequences across replicates and selecting the most abundant. In this second
#' method ties between sequences can be seen, hence, the user must decide 
#' whether a sequence is then chosen at random from the most abundant or 
#' will exclude any sequence determination. 
#'
#' The function also calculates the RNA & DNA complementary sequences, as well
#' as stating the length/width of the sequence.
#'
#'
#'@param data data.frame; generated by [mobileRNA::RNAimport()]
#'
#'@param original logical; output results to working date as additional
#'columns (`original=TRUE`), or output as new data frame (`original=FALSE`).
#'by default, FALSE
#'
#'@param match.threshold numeric; the minimum number of replicates 
#' required to share the sRNA sequence to count as a match. Default is 1. Only
#' applicable to the "set" method.  
#'
#'@param duplicates character; string to define how to deal with a tie,
#'"random" as default. Options include "random" and "exclude". Only
#' applicable to the "set" method.  
#'
#'
#'@param method character; string to define method. Either "consensus" or "set". 
#'The "consensus" method identifies the consensus sequences across replicated
#'based on the `bioseq` package method. Whereas the "set" is based on the fixed
#'sequences calculated for each replicate and whether they are exact matches or 
#'not. 
#'
#'
#'@param tidy logical; tidy-up data set by removing sRNA clusters with a 
#'unknown or unclassified consensus sRNA sequence result. By default,
#'  \code{tidy=FALSE}, while \code{tidy=TRUE} removes sRNA clusters with 
#' an undetermined consensus RNA sequence. 
#'
#'@details 
#'
#' The set method checks whether each sample in the data set shares
#' the same major sRNA sequence for a given sRNA cluster. If at least two 
#' replicates share the same sRNA sequence, the sequence is pulled and the 
#' complementary DNA and RNA sequences are calculated. Using the 
#' `match.threshold` parameter, we can alter the minimum number of replicates 
#' required to share the RNA sequence to count as a match. For example, if set 
#' as `match.threshold=3`, at least 3 replicates must contain the same sequence. 
#' As a general rule, if only one replicate has determined a sRNA sequence it is 
#' noted that there is no match, but the sequence is pulled and the 
#' complementary sequences calculated.  
#' 
#' The match column can either return "Yes", "No" or "Duplicate". If a match 
#' between replicates is found, "Yes" is supplied, if not, "No". While if 
#' there is a tie between sequences "Duplicate" is supplied. For examples, 
#' if an equal number of replicates have sequence "x" and sequence "y". 
#' 
#' In the situation where duplicates are identified, as default, at random
#' a consensus sRNA sequence is selected. This parameter can be changed to 
#' "exclude", and under this parameter no consensus sequence is pulled. 
#' 
#' Whereas with the consensus method, the consensus sequence is pulled from 
#' all replicates. 
#' 
#'@return The results can be added as additional columns to the working 
#'data frame supplied to the function or stored as a new data frame containing 
#'only the results from the function. The results includes:
#' 
#' - Match: whether the RNA sequence is consistent across replicates
#' - Sequence:  character; sequence of the most abundant sRNA within a cluster
#' - Complementary_RNA: character; complementary RNA nucleotide sequence
#' - Complementary_DNA: character; complementary DNA nucleotide sequence
#' - Width: numeric; length of nucleotide sequence
#'
#'
#'
#'@examples
#'
#'data("sRNA_data")
#'
#' # vector of control names
#' controls <- c("selfgraft_1", "selfgraft_2" , "selfgraft_3")
#'
#' # Locate potentially mobile sRNA clusters associated to tomato, no
#' # statistical analysis
#' sRNA_data_mobile <- RNAmobile(input = "sRNA", data =  sRNA_data,
#' controls = controls, genome.ID = "B_", task = "keep", statistical = FALSE)
#'
#'
#'mobile_sequences <- RNAsequences(sRNA_data_mobile, method = "consensus") 
#'
#'@importFrom dplyr select
#'@importFrom dplyr starts_with
#'@importFrom dplyr where
#'@importFrom dplyr mutate
#'@importFrom bioseq rna
#'@importFrom bioseq seq_consensus
#'@export
RNAsequences <- function(data, original = FALSE, method = c("consensus", "set"),
                         match.threshold = 1, 
                         duplicates  = "random", 
                         tidy = FALSE){
  if (base::missing(data)) {
    stop("data is missing. data must be an object of class matrix, data.frame, 
          DataFrame")
  }
  if (base::missing(method) || !method %in% c("consensus", "set")) {
    stop("Please specify the method parameter, must be either `consensus` or`set`. ")
  }
  df <- data %>% # select only columns with RNA seqs, remove columns with only NA values
    dplyr::select(dplyr::starts_with("MajorRNA")) %>%
    dplyr::select(-dplyr::where(~all(. == "N")))
    if(method == "set"){
      message("The minimum number of matches required to form a consensus sRNA sequence is... ", match.threshold)
      
      if(duplicates == "random"){
        message("---Tie method: random")
      } else 
        if(duplicates == "exclude"){
          message("---Tie method: exclude") 
        }
      match_res <- vector("character", nrow(df))  # Initialize result vector
      sequence_res <- vector("character", nrow(df))
      width_res <- vector("character", nrow(df))
      for (i in seq_len(nrow(df))) {
        row_values <- df[i, ]
        row_sequence <- row_values[row_values != "N"]
        any_match <- any(duplicated(row_sequence))
        if (length(row_sequence) == 0) {
          match <- FALSE # only one "N" elements
          sequence <- NA
        } else 
          if(length(row_sequence) == 1){
            match <- FALSE
            sequence <- row_sequence
          } else
            if(any_match){ # FIND ANY MATCH 
              seq_table <- table(row_sequence) # check how many matches 
              max_value <- max(seq_table)
              # Check if the maximum value is duplicated
              if (!is.na(seq_table[max_value]) && seq_table[max_value] > 1) {
                #if there is duplicate sets of matches 
                # 1 pick at random:
                if(duplicates == "random"){
                  match <- "Duplicate"
                  sequence <- sample(row_sequence, 1)
                } else 
                  if (duplicates == "exclude"){
                    match <- "Duplicate"
                    sequence <- NA
                  }
              } else 
                # match threshold
                if(max(max_value) >= match.threshold){
                  match <- "Yes"
                  sequence <- names(seq_table)[which.max(seq_table)]
                } else 
                  if( (max(max_value) >= match.threshold) == FALSE){
                    match <- "No"
                    sequence <- NA
                  }
            }
        else 
          if(any_match == FALSE){
            match <- "No"
            sequence <- NA
          }
        match_res[i] <- match
        sequence_res[i] <- sequence
        width_res[i] <- nchar(sequence)
      }
      # add column to df
      df$Match <- match_res
      df$Sequence <- sequence_res
      df$Width <- width_res
      # calculate complementary sequences
        df$Complementary_RNA <- vapply(df$Sequence, find_complementary_sequenceRNA, character(1))
        df$Complementary_DNA <- vapply(df$Sequence, find_complementary_sequenceDNA, character(1)) 

      # add as col
      Cluster <-  data[,c(1,5)]
      df <- cbind(Cluster, df )
      # add columns to og data
      if (original){
        data_output <- data %>%
          dplyr::mutate(Match = df$Match,
                        Sequence = df$Sequence,
                        Width = df$Width,
                        Complementary_RNA = df$Complementary_RNA,
                        Complementary_DNA = df$Complementary_DNA)
      } else # made new df
        if(original == FALSE){
          data_output <- df %>%
            dplyr::select(!dplyr::starts_with("MajorRNA"))
        }
      if(tidy){
        message("---Removing sRNA clusters with no consensus sRNA sequence")
        data_output <-  data_output %>%  dplyr::filter(Sequence != "NA")
      }
    }
   if(method == "consensus"){
     # Assuming your dataframe is called df and each column contains sequences
     consensus_sequences <- apply(df, 1, function(row) {
       # Convert the row to a bioseq object
       row_sequences <- bioseq::rna(row)
       # Find the consensus sequence for the row
       consensus_seq <- bioseq::seq_consensus(row_sequences)
       return(consensus_seq)
     })
     consensus_seq_df <- data.frame(Locus = data$Locus, 
                                    Cluster = data$Cluster, 
                                      Sequence = as.vector(consensus_sequences))
     consensus_seq_df$Width <- nchar(consensus_seq_df$Sequence)
     consensus_seq_df$Complementary_RNA <- vapply(consensus_seq_df$Sequence, find_complementary_sequenceRNA, character(1))
     consensus_seq_df$Complementary_DNA <- vapply(consensus_seq_df$Sequence, find_complementary_sequenceDNA, character(1)) 
     
  
     
     # add columns to og data
     if (original){
       data_output <- data %>%
         dplyr::mutate(Sequence = consensus_seq_df$Sequence,
                       Width = consensus_seq_df$Width,
                       Complementary_RNA = consensus_seq_df$Complementary_RNA,
                       Complementary_DNA = consensus_seq_df$Complementary_DNA)
     } else # made new df
       if(original == FALSE){
         data_output <- consensus_seq_df
       }
     
     if(tidy){
       message("---Removing sRNA clusters with no consensus sRNA sequence")
       data_output <- data_output[!grepl("[^AGCU]", data_output$Sequence), ]
     }
   }
 
  return(data_output)
}

#' Subset sRNA data based on dicercall size 
#'
#' @description Subset the existing dataframe to contain only the desired sRNA
#' class(s) based on the consensus dicercall determination and statistical 
#' significance. 
#' 
#' @details
#' See [mobileRNA::RNAdicercall()] for information on defining the consensus 
#' sRNA dicercall class for each cluster. The function allows the choice to 
#' filtered the data by statistical significance based on differential expression 
#' analysis, see [mobileRNA::RNAdifferentialAnalysis()]. Set 
#' \code{statistical=TRUE} to filtered by statistical significance (p-adjusted). 
#' 
#' 
#' It is important to consider what point in your analysis the data is subset 
#' as it will drastically reduce your sample size, altering the output of 
#' statistical analyse. 
#'
#' @param data data.frame; generated by [mobileRNA::RNAimport()], containing 
#' the additional information generated by [mobileRNA::RNAdicercall()] which 
#' defines the consensus sRNA class for each sRNA dicer-derived clusters
#'
#' @param class numeric; sRNA dicercall class(es) to select. Based on size in 
#' nucleotides. 
#' 
#' @param statistical logical; filter and select statistically significant sRNA. 
#' If \code{statistical=TRUE}, sRNA clusters are selected based on 
#' p-adjusted alpha threshold.
#' 
#' @param alpha numeric; user-defined numeric value to represent the adjusted 
#' p-value threshold to define statistical significance. Defaults setting 
#' `alpha=0.05`. 
#'
#' @return A data frame containing only sRNA clusters defined with a specific 
#' sRNA dicer-derived consensus size.
#' 
#' @examples
#' # load data 
#'  data("sRNA_data")
#'
#' # define consensus sRNA classes.
#' conditions <- c("heterograft_1", "heterograft_2", "heterograft_3")
#'
#' # Run function to define sRNA class for each cluster.
#' sRNA_data_dicercall <- RNAdicercall(data = sRNA_data,
#'                                   conditions = conditions,
#'                                   tidy=TRUE)
#'
#' # Subset data for  24-nt sRNAs
#' sRNA_24 <- RNAsubset(sRNA_data_dicercall, class = 24)
#'
#'
#'# Subset data for 21/22-nt sRNAs
#'sRNA_2122 <- RNAsubset(sRNA_data_dicercall, class = c(21, 22))
#'
#' @export
#' @importFrom dplyr %>%
#' @importFrom dplyr filter

RNAsubset <- function(data, class,  statistical=FALSE, alpha = 0.05){
  if (!base::inherits(data, c("matrix", "data.frame", "DataFrame"))) {
    stop("data must be an object of class matrix, data.frame, DataFrame")
  }
  if (base::missing(class) || !base::inherits(class, "numeric")) {
    stop("Please specify a numeric vector stating the class of sRNAs to select")
  }
    x <- data %>% dplyr::filter(DicerConsensus %in% class)
    if(statistical){
      x<- x %>%
        dplyr::filter(padj < alpha)
    }
    return(x)
  }

#' Reorder the data frame for differential analysis, ensuring control verse 
#' treatment comparison
#' 
#' 
#' @description Re-organise the working data frame, placing control samples 
#' before treatment samples. This ensures differential analysis comparison 
#' between controls and treatment are in the correct arrangement. 
#'
#' @param data data.frame; generated by [mobileRNA::RNAimport()]  
#'
#'
#'@param controls character; vector of control condition sample names. 
#'
#' 
#' @return A re-ordered/re-organised working data frame with control samples 
#' after the 5 cluster information columns, and treatment sample columns after
#' the control sample columns. 
#' @examples
#' # load data 
#' data("sRNA_data")
#' 
#' controlReps <- c("selfgraft_1", "selfgraft_2", "selfgraft_3")
#' 
#' reorder_df <- RNAreorder(data = sRNA_data, controls = controlReps)
#' 
#' @export
RNAreorder <- function(data, controls) {
  if (!is.data.frame(data)) {
    stop("Input 'data' must be a data frame.")
  }
  if ( is.null(controls) || !base::inherits(controls, "character")) {
    stop("group must be an vector of characters to specify the sample 
         replicates within the control condition. ")
  }
  # Identify the column indices that contain keywords from the 'controls' vector
  control_indices <- vapply(controls, function(keyword) grep(keyword, 
                                                             colnames(data)),
                            FUN.VALUE = integer(length(controls)+1))
  # Remove NA indices
  control_indices <- control_indices[!is.na(control_indices)]
  # to place columns after the first 5
  control_indices <- control_indices[control_indices > 5]
  # Reorder the columns
  range <- seq_len(ncol(data) - 5) + 5
  new_order <- c(seq_len(5), control_indices, base::setdiff(range, control_indices))
  data <- data[, new_order]
  return(data)
}

#' Plots the distribution of genomic features in the genome and those that
#' overlap with sRNA clusters
#'
#' @description Using the RNAfeatures() function, this function plots the
#' percentage distribution of genomic features in the provided genome annotation
#' and percentage the distibution of genomic features which overlap sRNA
#' clusters. This is illustrated as a stacked bar plot.
#'
#'
#' @details
#' `RNAfeatures` calculates the number or percentage of sRNA clusters which
#' overlap with genomic features based on their genomic coordinates.
#'
#'
#' @seealso [mobileRNA::RNAmergeAnnotations()] to merge 2 GFF files into 1.
#'
#' @param data data.frame; generated by [mobileRNA::RNAimport()]
#'
#' @param annotation path; URL or connection to a GFFFile object. A genome
#' reference annotation file (.gff/.gff1/.gff2/.gff3). Can be in compressed
#' format (gzip).
#'
#' @param repeats path; URL or connection to a GFFFile object. A genome
#' reference annotation file, which only contains information on repeat
#' sequences in the genome (.gff/.gff1/.gff2/.gff3). By default, this is not
#' required, however if there is a specific repeats annotation file for the
#' genome it is suggested to supply it. Can be in compressed format (gzip).
#'
#' @param promoterRegions numeric; defines the upstream promoter region of
#' genes. Default is 1000, which refers to promoters set at 1Kb upstream of
#' genes
#'
#'
#'@param repeat.type character; features type in `annotation` file to represent
#'repeats when `repeats` not supplied.
#'
#'@param colors vector; colours for each feature.
#'
#'
#'@param rmFeatures vector; type of genomic features to not consider such as
#'"gene" or "exon" etc.
#'
#'@param legend.position character; position of legend. Either "none", "left",
#'"right", "bottom", "top", "inside".
#'
#' @return Returns a table containing the number or percentage of overlaps in
#' the supplied sRNA data set with specific regions in the genome annotation
#' such as genes, repeats, introns, exons.
#'
#' @examples
#' data("sRNA_data")
#' features_plot <- plotRNAfeatures(data = sRNA_data,
#'                        annotation = system.file("extdata",
#'                        "reduced_chr2_Tomato.gff.gz", package="mobileRNA"))
#'
#'@importFrom dplyr select
#'@importFrom dplyr mutate
#'@importFrom scales label_percent
#'@importFrom dplyr %>%
#'@importFrom IRanges overlapsAny
#'@importFrom ggplot2 ggplot
#'@importFrom ggplot2 geom_bar
#'@importFrom ggplot2 labs
#'@importFrom ggplot2 guides
#'@importFrom ggplot2 theme
#'@importFrom ggplot2 element_blank
#'@importFrom ggplot2 element_text
#'@importFrom ggplot2 element_line
#'@importFrom ggplot2 margin
#'@importFrom grid unit
#'@export

plotRNAfeatures <- function(data, annotation,
                            repeats = NULL,
                            promoterRegions = 1000,
                            repeat.type = NULL,
                            colors = c( "#EEB05AFF", "#E35E28FF", "#4DA284FF",
                                        "#4692B0FF", "#134B73FF", "#B5361CFF"),
                            legend.position = "bottom" ,
                            rmFeatures =NULL){

  data_res <-RNAfeatures(data = data,
                           annotation = annotation,
                           repeats = repeats,
                           rmFeatures = rmFeatures,
                           promoterRegions = promoterRegions)

  reformated_v1 <- data_res %>%
    dplyr::select(variable = "Genomic feature",
                  percentage ="Genome Proportion (%)")%>%
    dplyr::mutate(Origin = "Genome")

  reformated_v2 <- data_res %>%
    dplyr::select(variable = "Genomic feature",
                  percentage ="Dataset Proportion (%)")%>%
    dplyr::mutate(Origin = "Dataset")

  reformated_df <- rbind(reformated_v1, reformated_v2)
  reformated_df$Origin <- factor(reformated_df$Origin,
                                 levels = c("Genome","Dataset"))

  p <- ggplot2::ggplot(reformated_df,
                       ggplot2::aes(x = Origin,
                                    y = percentage, fill = variable)) +
    ggplot2::geom_bar(stat = "identity", alpha = 0.9, color = "black") +
    ggplot2::labs(x = "", y = "Percentage (%)", fill = "Genomic Feature") +
    ggplot2::theme_bw()+
    ggplot2::scale_fill_manual(values = colors)+
    ggplot2::scale_y_continuous(limits = c(0,105), expand = c(0,0))+
    ggplot2::guides(fill = ggplot2::guide_legend(override.aes =
                                                 list(shape = 20, size = 4)))+
    ggplot2::theme(
      strip.background = ggplot2::element_blank(),
      strip.placement = "outside",
      panel.grid = ggplot2::element_blank(),
      axis.text.x = ggplot2::element_text(color="black",
                                          size = 16,
                                          margin = ggplot2::margin(t = 5,
                                                                   b = 4)),
      axis.text.y = ggplot2::element_text(color="black", size = 16,
                                          margin = ggplot2::margin(r = 5)) ,
      panel.grid.major.x = ggplot2::element_line( linewidth=.1, color="grey",
                                                  linetype = 2 ),
      panel.grid.major.y = ggplot2::element_line( linewidth=.1, color="grey",
                                                  linetype = 2 ),
      legend.position = "right",
      legend.text = ggplot2::element_text(size=14,
                                          margin = ggplot2::margin(2,2,2,2)),
      legend.title = ggplot2::element_text(size = 14.5, face = "bold"),
      axis.title.y = ggplot2::element_text(margin = ggplot2::margin(r = 5), size = 20,
                                           face = "bold"),
      axis.title.x = ggplot2::element_text(size = 20, face = "bold"),
      strip.text.x = ggplot2::element_text(size = 16,face="italic" ,
                                           margin = ggplot2::margin(b = 10)),
      strip.text.y = ggplot2::element_text(size = 16,face="italic" ,
                                           margin = ggplot2::margin(l = 10)),
      plot.margin = grid::unit(c(1,1,1,1), units = "cm"))+
    ggplot2::scale_x_discrete(labels=function(x) sub(" "," \n",x,fixed=TRUE))

  return(p)

}

#' Summarise differential analysis results 
#' 
#' @description Print a summary of the statistical analysis of sRNA clusters 
#' (sRNAseq) or mRNAs (mRNAseq) from a mobileRNA analysis
#'
#' @param data data.frame; generated by [mobileRNA::RNAdifferentialAnalysis()]  
#'
#' 
#' @param alpha numeric; user-defined numeric value to represent the adjusted 
#' p-value threshold to define statistical significance. Defaults setting 
#' `alpha=0.1`. 
#'
#'@param chimeric logical; state whether system is chimeric: contains multiple 
#'genomes/genotypes. 
#'
#'@param controls character; vector of control condition sample names. 
#'
#'
#'@param genome.ID character; chromosome identifier of the genome representing 
#'either the origin of mobile molecules or the other genome in the chimeric 
#'system.  
#'@details 
#' To look only at the differential abundance from RNAs in the mobilome, use the 
#' `chimeric=TRUE` parameter and supply the chromosome identifier of the genome 
#' from which mobile molecules originate from to the `genome.ID` parameter & 
#' the control condition samples names to the `controls` parameter. 
#' 
#' @return Prints a summary of the RNAs which align with the 
#' adjusted p-value cutoff and states the number which has a positive and 
#' negative log-fold change. Where a positive log-fold change represents an 
#' increase in abundance and a negative value represents a decrease in abundance
#' between the conditions. 
#'  
#' @examples
#' 
#' # load data 
#' data("sRNA_data")
#' 
#' 
#'# sample conditions.
#'groups <- c("Selfgraft", "Selfgraft", "Selfgraft", "Heterograft", "Heterograft", "Heterograft")
#'
#'
#'## Differential analysis: DEseq2 method
#'sRNA_DESeq2 <- RNAdifferentialAnalysis(data = sRNA_data,
#'                              group = groups,
#'                              method = "DESeq2" )
#'                           
#'                    
#' res <- RNAsummary(sRNA_DESeq2)
#'                                  
#' @export
#' @importFrom stats complete.cases
RNAsummary <- function(data, alpha = 0.1, chimeric = FALSE,
                                  controls = NULL, genome.ID = NULL) {
  # Check if 'data' is a data frame
  if (!is.data.frame(data)) {
    stop("Input 'data' must be a data frame.")
  }
  
  # Check if 'log2FoldChange' column exists in the data frame
  if (!"log2FoldChange" %in% colnames(data)) {
    stop("Column 'log2FoldChange' not found in the data frame.
         Please refer to the vignette.")
  }
  # Check if 'padjusted' column exists in the data frame
  if (!"padjusted" %in% colnames(data)) {
    stop("Column 'padjusted' not found in the data frame.
         Please refer to the vignette.")
  }
  if(chimeric){
    data <- .remove_mapping_errors_V2(data = data,
                                      controls = controls, 
                                      genome.ID = genome.ID)
  } 
  # calculate number of non-zero rows
  total_rows <- nrow(data)
  # Filter the data based on the padjusted value
  filtered_data <- data[data$padjusted < alpha, ]
# remove any NA values 
  filtered_data <- filtered_data[stats::complete.cases(filtered_data$padjusted), ]

  # number of rows with positive and negative log2FC
  n_up <- sum(filtered_data[, "log2FoldChange"] > 0)
  n_down <- sum(filtered_data[, "log2FoldChange"] < 0)
  total_rows2 <- nrow(filtered_data)
  # Calculate percentages
  percent_up <- (n_up / total_rows2) * 100
  percent_down <- (n_down / total_rows2) * 100
  
  result_text <- c(
    paste("Comparison :" ,unique(filtered_data$comparision.order), "\n"),
    paste("out of", total_rows, "with nonzero read count \n"),
    paste("adjusted p-value <", alpha, "\n"),
    paste(total_rows2, "sRNA clusters met the adjusted p-value cutoff \n"),
    paste("LFC > 0 (higher) :", n_up, ",", round(percent_up, 1), "%", "\n"),
    paste("LFC < 0 (lower)  :", n_down, ",", round(percent_down, 1), "%", "\n"))
  
  cat(result_text, collapse = " ")
  #return()
}

#' Merge two genome annotation files (GFF Format)
#'
#' @description Merges two genomes annotation files (GFF) into one
#' single GFF format file saved to the desired directory. This function adds a
#' unique prefix to the chromosome names in each genome annotation to ensure
#' each is distinguishable within the merged file.
#'
#' @details
#' As default, the function removes periods and adds a prefix to the existing
#' chromosome names. The prefix is separated from the original chromosome name
#' by an underscore. For example, based on the default settings, it will add the
#' prefix "A_" to the chromosome names in `annotationA`, for instance,
#'  A_0, A_1, A_2 etc.
#'
#' The merged genome is saved to the specified output directory, and requires
#' the user to set the name with a GFF format.
#'
#'
#'
#'**IMPORTANT:** The genome reference and annotation of a species
#'must have chromosomes with matching names. It is critical that if you used
#'the [mobileRNA::RNAmergeGenomes()] function to create a merged reference
#'genome,that you treat the input annotations in the same way.
#'
#'@return
#'A GFF format file containing the annotations of two genomes distinguishable by
#'the appended prefixes.
#'
#'
#'@param annotationA path; path to a genome annotation assembly file in GFF format.
#'
#'@param annotationB path; path to a genome annotation assembly file in GFF format.
#'
#'@param output_file path; a character string or a \code{base::connections()}
#'open for writing. Including file output name, and must have a GFF file
#'extension.
#'
#'@param AnnoA.ID character; string to represent prefix added to
#'existing chromosome names in `annotationA`. Default set as "A".
#'
#'@param AnnoB.ID character; string to represent prefix added to
#'existing chromosome names in `annotationB`. Default set as "B".
#'
#'@param format format of GFF output, either "gff", "gff1", "gff2", "gff3."
#'  Default is "gff3".
#'
#'
#' @examples
#'
#' anno1 <- system.file("extdata", "reduced_chr12_Eggplant.gff.gz",
#' package="mobileRNA")
#'
#' anno2 <- system.file("extdata","reduced_chr2_Tomato.gff.gz",
#' package="mobileRNA")
#'
#' output_file <- tempfile("merged_annotation", fileext = ".gff3")
#'
#' merged_anno <- RNAmergeAnnotations(annotationA = anno1, annotationB = anno2,
#'                                    output_file = output_file)
#'
#' @importFrom rtracklayer import
#' @importFrom rtracklayer export
#' @importFrom GenomicRanges GRangesList
#' @importFrom progress progress_bar
#' @importFrom S4Vectors elementMetadata
#' @importFrom GenomeInfoDb seqlevels
#' @export
#'
RNAmergeAnnotations <- function(annotationA, annotationB,
                               output_file,
                               AnnoA.ID = "A",
                               AnnoB.ID = "B",
                               format = "gff3"){

  if (base::missing(annotationA) || !base::inherits(annotationA, "character") ||
      !file.exists(annotationA)) {
    stop("Please specify annotationA object; path to GFF file.")
  }
  if (base::missing(annotationB) || !base::inherits(annotationB, "character") ||
      !file.exists(annotationB)){
    stop("Please specify annotationA; path to GFF file.")
  }
  if (base::missing(output_file) ||
      !grepl("\\.(gff)$|\\.(gff1)$|\\.(gff2)$|\\.(gff3)$|\\.(gff.gz)$|
             \\.(gff1.gz)$|\\.(gff2.gz)$|\\.(gff3.gz)$",output_file)) {
    stop("Please specify output_file, a connection to a local directory to write
          and save merged annotation.
          Ensure file contains suitable GFF extension.")
  }
  # start the progress bar
  pb <- progress::progress_bar$new(
    format = "[:bar] :percent :current/:total :eta",
    total = 4)
  pb$tick(0)

  # import gff
  annotationA <- rtracklayer::import(annotationA)
  annotationB <- rtracklayer::import(annotationB)
  pb$tick()

  # remove full-stop
  annotationA_seqnames <- gsub("\\.", "", paste0(AnnoA.ID, "_",
                                                 GenomeInfoDb::seqlevels(annotationA)))
  annotationB_seqnames <- gsub("\\.", "", paste0(AnnoB.ID, "_",
                                                 GenomeInfoDb::seqlevels(annotationB)))

  # change seqnames
  GenomeInfoDb::seqlevels(annotationA) <- annotationA_seqnames
  GenomeInfoDb::seqlevels(annotationB) <- annotationB_seqnames

  pb$tick()
 # change classes
  annotationA_gff <- convertChar2Factor(annotationA)
  annotationB_gff <- convertChar2Factor(annotationB)

  pb$tick()
  # join
  gr_list <- GenomicRanges::GRangesList(annotationA_gff, annotationB_gff)
  concatenated_gff <- unlist(gr_list)
  # export merged
  rtracklayer::export(concatenated_gff, output_file, format=format)
  pb$tick()
  message("\nOutput file has been saved to: ", output_file)

  return(concatenated_gff)
}

#' PCA plot of PC1 and PC2
#'
#' @description Draws a principal component analysis (PCA) plot of PC1 and PC2. 
#' The function undertakes rlog transformation of the data in an unbiased manner
#'  (\code{blind=TRUE}).
#'
#' @param data data.frame; originally generated by [mobileRNA::RNAimport()] 
#' 
#' @param group character; contains experimental conditions for each
#' replicate. 
#' 
#' *IMPORTANT*: Ensure this is in the same order as the replicates are
#' found in the data frame supplied to the `data` argument (from left to right).
#'
#' @param vst logical; variance stabilizing transformation. By default, the
#' function uses a regularized log transformation on the data set, however, this
#' will not suit all experimental designs.
#' 
#' @param labels logical; include sample name labels on PCA. Default 
#' `labels=TRUE`
#' 
#' @param boxed logical; add a box around each sample name label. Default 
#' `boxed=TRUE`
#' 
#' @param legend.title character; title for legend key. Default
#' `legend.title = "Conditions"`
#' 
#' @param title character; title for plot. 
#' 
#' @param size.ratio numeric; set plot ratio, broadens axis dimensions by ratio.
#' Default `size.ratio=2`, double the plot dimension. 
#'
#'@param colours character; vector of HEX colour codes. Must match the number of 
#'conditions. 
#'
#'@param point.shape logical; set whether the point shapes should be different
#'for each condition. 
#'
#'@param ggplot.theme character; state the `ggplot2` theme (without () 
#'brackets). For example, `ggplot.theme=ggplot2::theme_classic`.
#' 
#'@param legend.position character; the position of legends 
#'("none", "left", "right", "bottom", "top", or two-element numeric vector)
#'
#' @param legend.direction character; layout of items in legends
#' ("horizontal" or "vertical")
#' 
#' @param label.box.padding numeric; Amount of padding around bounding box,
#'  as a unit or number. Defaults to 1. 
#'  
#' @return A PCA plot to show sample distance.
#'
#' @details This function uses the `DESeq2` package to organise and plot the
#' data. It organises the data into a DESeqDataSet which undergoes 
#' log-transformation where the results are used to undertake the PCA analysis. 
#' The results are plotted against the principal  components 1 and 2.
#'
#' In special conditions, regularized log transformation will not suit
#' the experimental design. For example, an experimental design without
#' replicates. In this instance, it is preferable to change the default setting
#' and switch to a variance stabilizing transformation method
#' (\code{`vst=TRUE`}).
#'
#'
#' @examples
#' data("sRNA_data")
#'
#' groups <- c("Heterograft", "Heterograft", "Heterograft",
#'             "Selfgraft", "Selfgraft", "Selfgraft")
#'             
#'             
#' p <-  plotSamplePCA(data = sRNA_data, group = groups)
#'
#' plot(p)
#'
#'
#' @export
#' @importFrom dplyr select
#' @importFrom DESeq2 DESeqDataSetFromMatrix
#' @importFrom SimDesign quiet
#' @importFrom stats relevel
#' @importFrom DESeq2 estimateSizeFactors
#' @importFrom DESeq2 rlog
#' @importFrom DESeq2 plotPCA
#' @importFrom ggrepel geom_label_repel
#' @importFrom ggplot2 aes
#' @importFrom ggplot2 labs
#' @importFrom ggplot2 xlab
#' @importFrom ggplot2 ylab
#' @importFrom ggplot2 coord_fixed
#' @importFrom ggrepel geom_text_repel
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 scale_color_manual
plotSamplePCA <- function(data, group, vst = FALSE, labels = TRUE, boxed = TRUE,
                          legend.title = "Conditions", size.ratio = 2, 
                          colours = NULL, point.shape = TRUE, 
                          ggplot.theme = NULL, label.box.padding = 1, 
                          title = "PCA plot", 
                          legend.position = "top", 
                          legend.direction = "horizontal"){
  if (base::missing(data) || !base::inherits(data, c("data.frame"))) {
    stop("data must be an object of class data.frame containing raw count data")
  }
  if (base::missing(group) || !base::inherits(group, c("character"))) {
    stop("group must be an object of class character vector containing the 
          experimental condition (Treatment vs. Control)")
  }
  data <- data %>% dplyr::select(tidyselect::starts_with("Count_"))
  # use DESeq to organise the data.
  column.data <- data.frame(conditions=as.factor(group))
  base::rownames(column.data) <- base::colnames(data)
  count.data.set <- SimDesign::quiet(DESeq2::DESeqDataSetFromMatrix(
    countData=data,colData=column.data,design= ~conditions))
  count.data.set$conditions <- stats::relevel(count.data.set$conditions,
                                              group[1])
  
  dds <- DESeq2::estimateSizeFactors(count.data.set)
  
  # log transform the data.
  
  if(vst ==TRUE){
    message("Transforming the count data with a variance stabilizing 
transformation...")
    rld1 <- DESeq2::varianceStabilizingTransformation(dds, blind = TRUE)
    # log transform the data.
  } else
    if(vst == FALSE) {
      message("Transforming the count data to the log2 scale...")
      rld1 <- DESeq2::rlog(dds, blind = TRUE) # log transform the data.
    }
  
  # use the DEseq plot pca function, store in an object.
  pca <- DESeq2::plotPCA(rld1, returnData = TRUE, intgroup = "conditions")
  colnames(pca)[colnames(pca) == 'conditions'] <- 'Conditions'
  rownames(pca) <- gsub("^Count_", "", rownames(pca))
  pca$name <- gsub("^Count_", "",  pca$name)
  percentVar <- round(100 * attr(pca, "percentVar"))
  
  message("---Organising principal component analysis")
  if(labels == TRUE){
    if(boxed == TRUE){
      X <- ggplot2::ggplot(pca, ggplot2::aes(PC1, PC2, color=Conditions)) +
        {if(point.shape) ggplot2::geom_point(size=3, ggplot2::aes(
          shape = Conditions))}+
        {if(point.shape == FALSE) ggplot2::geom_point(size=3)}+
        ggplot2::xlab(paste0("PC1: ",percentVar[1],"% variance")) +
        ggplot2::ylab(paste0("PC2: ",percentVar[2],"% variance")) + 
        {if(!is.null(colours)) ggplot2::scale_color_manual(values=colours)}+ 
        ggplot2::coord_fixed()+
        ggrepel::geom_label_repel(data = pca, ggplot2::aes(label = name), 
                                  show.legend = FALSE, box.padding = label.box.padding)+
        ggplot2::labs(color = legend.title, title = title) + 
        ggplot2::coord_fixed(ratio = size.ratio)+
        {if(!is.null(ggplot.theme)) ggplot.theme() }+
        ggplot2::theme(legend.position = legend.position,
              legend.justification='left',
              legend.direction=legend.direction,
              legend.text = ggplot2::element_text(size=12),
              legend.title = ggplot2::element_text(size = 11, face = "bold"),
              axis.text.x = ggplot2::element_text(colour = "black", size = 13,face = "bold", margin = ggplot2::margin(t = 10, b = 4)),
              axis.text.y = ggplot2::element_text(colour = "black", size = 13,face = "bold", margin = ggplot2::margin(r = 3)),
              axis.title.y = ggplot2::element_text( size = 16, face = "bold", margin = ggplot2::margin(r =8)),
              axis.title.x = ggplot2::element_text(size = 16, face = "bold"),
              plot.title = ggplot2::element_text(face="bold", size = 18),
              plot.subtitle = ggplot2::element_text(size = 14))
      
    } else
      X <- ggplot2::ggplot(pca, ggplot2::aes(PC1, PC2, color=Conditions)) +
        {if(point.shape) ggplot2::geom_point(size=3, ggplot2::aes(
          shape =Conditions))}+
        {if(point.shape == FALSE) ggplot2::geom_point(size=3)}+
        ggplot2::xlab(paste0("PC1: ",percentVar[1],"% variance")) +
        ggplot2::ylab(paste0("PC2: ",percentVar[2],"% variance")) + 
        {if(!is.null(colours)) ggplot2::scale_color_manual(values=colours)}+ 
        ggrepel::geom_label_repel(data = pca, ggplot2::aes(label = name), 
                                  show.legend = FALSE, box.padding = label.box.padding)+
        ggplot2::labs(color = legend.title, title = title) + 
        suppressMessages(ggplot2::coord_fixed(ratio = size.ratio))+
        {if(!is.null(ggplot.theme)) ggplot.theme() }+
        ggplot2::theme(legend.position = legend.position,
              legend.justification='left',
              legend.direction=legend.direction,
              legend.text = ggplot2::element_text(size=12),
              legend.title = ggplot2::element_text(size = 11, face = "bold"),
              axis.text.x = ggplot2::element_text(colour = "black", size = 13,face = "bold", margin = ggplot2::margin(t = 10, b = 4)),
              axis.text.y = ggplot2::element_text(colour = "black", size = 13,face = "bold", margin = ggplot2::margin(r = 3)),
              axis.title.y = ggplot2::element_text( size = 16, face = "bold", margin = ggplot2::margin(r =8)),
              axis.title.x = ggplot2::element_text(size = 16, face = "bold"),
              plot.title = ggplot2::element_text(face="bold", size = 18),
              plot.subtitle = ggplot2::element_text(size = 14))
    
    
  } else {
    X <- ggplot2::ggplot(pca, ggplot2::aes(PC1, PC2, color=Conditions)) +
      {if(point.shape) ggplot2::geom_point(size=3, ggplot2::aes(
        shape = Conditions))}+
      {if(point.shape == FALSE) ggplot2::geom_point(size=3)}+
      ggplot2::xlab(paste0("PC1: ",percentVar[1],"% variance")) +
      ggplot2::ylab(paste0("PC2: ",percentVar[2],"% variance")) + 
      {if(!is.null(colours)) ggplot2::scale_color_manual(values=colours)}+ 
      ggplot2::labs(color = legend.title, title = title) + 
      ggplot2::coord_fixed(ratio = size.ratio)+
      {if(!is.null(ggplot.theme)) ggplot.theme() }+
      ggplot2::theme(legend.position = legend.position,
            legend.justification='left',
            legend.direction=legend.direction,
            legend.text = ggplot2::element_text(size=12),
            legend.title = ggplot2::element_text(size = 11, face = "bold"),
            axis.text.x = ggplot2::element_text(colour = "black", size = 13,face = "bold", margin = ggplot2::margin(t = 10, b = 4)),
            axis.text.y = ggplot2::element_text(colour = "black", size = 13,face = "bold", margin = ggplot2::margin(r = 3)),
            axis.title.y = ggplot2::element_text( size = 16, face = "bold", margin = ggplot2::margin(r =8)),
            axis.title.x = ggplot2::element_text(size = 16, face = "bold"),
            plot.title = ggplot2::element_text(face="bold", size = 18),
            plot.subtitle = ggplot2::element_text(size = 14))
  }
  return(X)
}

#' Overlap the genomic features related to the sRNA clusters
#'
#' @details
#' Based on genomic coordinates, assign sRNA clusters with matching annotation
#' information. This function can be used to find the genomic features from
#' which the sRNA clusters originate from. This includes genes or repetitive
#' regions. An additional buffer region at the start/end of the gene is added
#' to improve hits, and align with the assumptions about promoter regions.
#'
#' It is important that any alteration which were made to the genome reference
#' (FASTA) used for aligment/clustering,  such as alterations to the chromosome
#' name, must be carried forth to the genome annotation file. See
#' [mobileRNA::RNAmergeGenomes()] and [mobileRNA::RNAmergeAnnotations()] for
#' more information.
#'
#' @param data data.frame; originally generated by [mobileRNA::RNAimport()] or
#' containing `chr`, `start` and `end` columns.
#'
#' @param annotation path; URL, connection or GFFFile object. A genome
#' reference annotation file (.gff/.gff1/.gff2/.gff3).
#'
#' @param match character; must be either  "within" or "genes". Where
#' "within" will return matches where the clusters can be found within any
#' annotation, while "genes" will return matches where the clusters can be found
#' within only genes.
#'
#' @param bufferRegion numeric; a buffer region in base-pairs to extend the
#' start and end coordinates upstream and downstream respectively.
#'
#'
#'@return
#'Appends the attribute columns from the GFF file to the supplied data based on
#'overlapping genomic regions.
#'
#'
#'
#' @export
#' @importFrom rtracklayer import
#' @importFrom GenomicRanges GRanges
#' @importFrom GenomicRanges findOverlaps
#' @importFrom S4Vectors queryHits
#' @importFrom S4Vectors subjectHits
#' @importFrom dplyr mutate
#' @importFrom rlang sym
#' @importFrom dplyr select_if
#' @importFrom IRanges IRanges
#' @importFrom S4Vectors mcols
#' @importFrom IRanges ranges
#' @importFrom S4Vectors elementMetadata
#' @importFrom GenomicRanges seqnames
#' @examples
#'  # load data
#' data("sRNA_data")
#'
#' attributes_df <- RNAattributes(data = sRNA_data,
#'                     annotation = system.file("extdata",
#'                     "prefix_reduced_chr2_Tomato.gff", package="mobileRNA"),
#'                     match = "genes")
#'
RNAattributes <- function(data, annotation, match = c("within", "genes"),
                          bufferRegion = 1000){
  if (base::missing(data) || nrow(data) == 0) {
    stop("data is missing. data must be an object of class matrix, data.frame,
           DataFrame")
  }

  if (missing(annotation) || is.null(annotation) ) {
    stop("annotation parameter is missing or empty.")
  }

  if (is.character(annotation) || file.exists(annotation)) {
    annotation <- suppressMessages(rtracklayer::import(annotation))
  } else
    if(!methods::is(annotation, "GRanges")){
      stop("The annotation does not exist, must either be a path or GRange object.")
    }

  if(match == "within"){
    features_gr <-  annotation
    # convert data to granges
    data_gr <- GenomicRanges::GRanges(data$chr,
                  ranges = IRanges::IRanges(start = as.numeric(data$start), end = as.numeric(data$end))
    )
    # Find overlaps between genomic loci and adjusted GRanges
    overlaps <- suppressWarnings(GenomicRanges::findOverlaps(data_gr, features_gr))

    # Get the indices of overlapping genomic loci ie row number
    queryHits_ot <- S4Vectors::queryHits(overlaps)
    subjectHits_ot <- S4Vectors::subjectHits(overlaps)


    # convert to dataframe
    features_gr_df <- as.data.frame(features_gr)
    # add columns to data
    add_cols <- colnames(features_gr_df)
    col_diff <- setdiff(add_cols, colnames(data))
    rm_extra <- c("seqnames", "width","strand","source", "score", "phase")
    col_diff <- col_diff[!col_diff %in% rm_extra]

    data[,col_diff] <- NA
    if(length(subjectHits_ot) == 0 ){
      stop("No genomic features matched the sRNA clusters")
    }
    for (i in seq_along(subjectHits_ot)) {
      row_index <- subjectHits_ot[i]
      row_vals <- features_gr_df[row_index, ]
      row_vals<- row_vals[,col_diff] # only extra columns.
      for (j in names(row_vals)) {
        if (j %in% names(data[queryHits_ot[i],])) {
          data[queryHits_ot[i],] <- data[queryHits_ot[i],] %>%
            dplyr::mutate(!!j := ifelse(is.na(!!rlang::sym(j)), row_vals[[j]],
                                        !!rlang::sym(j)))
        }
      }
    }

    # remove columsn with only NAs
    data <- data  %>% dplyr::select_if(~sum(!is.na(.)) > 0)
  }

  if(match == "genes"){
    # find clumn with
    meta <- as.data.frame(S4Vectors::mcols(annotation))
    # select column with cells contain "gene", but if they contain "gene" then nothing else.
    gene_columns <- which(vapply(meta, function(x) any(grepl("^gene$", x)), FUN.VALUE = logical(1)))
    gene_col_name <- names(meta)[gene_columns]
    # select genes
    genes <- annotation[S4Vectors::elementMetadata(annotation)[,gene_col_name] == "gene"]
    # amend ranges
    adjusted_ranges <- IRanges::IRanges(
      start = as.data.frame(IRanges::ranges(genes))$start - bufferRegion,
      end = as.data.frame(IRanges::ranges(genes))$end + bufferRegion
    )

    #add ranges to genes info
    adjusted_grange <- GenomicRanges::GRanges(
      GenomicRanges::seqnames(genes),
      ranges = adjusted_ranges,
      metadata = S4Vectors::mcols(genes)
    )

    # convert data to granges
    data_gr <- GenomicRanges::GRanges(
      seqnames = data$chr,
      ranges = IRanges::IRanges(start = as.numeric(data$start), end = as.numeric(data$end))
    )

    # Find overlaps between genomic loci and adjusted GRanges
    overlaps <- suppressWarnings(GenomicRanges::findOverlaps(data_gr, adjusted_grange))

    # Get the indices of overlapping genomic loci ie row number
    queryHits_ot <- S4Vectors::queryHits(overlaps)
    subjectHits_ot <- S4Vectors::subjectHits(overlaps)


    # convert to dataframe
    adjusted_grange_df <- as.data.frame(adjusted_grange)
    # converion adds metadeta to metadatcols
    names(adjusted_grange_df) <- sub('^metadata.', '',names(adjusted_grange_df))
    # add columns to data
    add_cols <- colnames(adjusted_grange_df)
    col_diff <- setdiff(add_cols, colnames(data))
    rm_extra <- c("seqnames", "width","strand","source", "score", "phase")
    col_diff <- col_diff[!col_diff %in% rm_extra]
    data[,col_diff] <- NA
    if(length(subjectHits_ot) == 0 ){
      stop("No genomic features matched the sRNA clusters")
    }

    for (i in seq_along(subjectHits_ot)) {
      row_index <- subjectHits_ot[i]
      row_vals <- adjusted_grange_df[row_index, ]
      row_vals<- row_vals[,col_diff] # only extra columns.

      for (j in names(row_vals)) {
        if (j %in% names(data[queryHits_ot[i],])) {
          data[queryHits_ot[i],] <- data[queryHits_ot[i],] %>%
            dplyr::mutate(!!j := ifelse(is.na(!!rlang::sym(j)), row_vals[[j]],
                                        !!rlang::sym(j)))
        }
      }
    }

    # remove columns with na
    data <- data[,colSums(is.na(data))<nrow(data)]

  }
  return(data)
}

## Here is listed the scripts used to generate the data files

#### reduced_chr12_Eggplant.gff ####
wget https://solgenomics.net/ftp/genomes/Solanum_melongena_V4.1/Eggplant_V4.1_function_IPR_final.gff
grep '^12\s' Eggplant_V4.1_function_IPR_final.gff | head -n 8 > reduced_chr12_Eggplant.gff

#### reduced_chr12_Eggplant.fa ####
wget https://solgenomics.net/ftp/genomes/Solanum_melongena_V4.1/Eggplant_V4.1.fa
grep -A 49 '>12' Eggplant_V4.1.fa > reduced_chr12_Eggplant.fa # select chromosome 12, and 50 lines

#### reduced_chr2_Tomato.gff ####
wget https://solgenomics.net/ftp/tomato_genome/Heinz1706/annotation/ITAG4.1_release/ITAG4.1_gene_models.gff
grep -E 'ID=gene:Solyc02g063520\.4|ID=gene:Solyc02g078570\.3|ID=gene:Solyc02g089300\.3' ITAG4.1_gene_models.gff > reduced_chr2_Tomato.gff


#### reduced_chr2_Tomato.fa ####
wget https://solgenomics.net/ftp/tomato_genome/Heinz1706/assembly/build_4.00/S_lycopersicum_chromosomes.4.00.fa
sed -i '' 's/\.//g' S_lycopersicum_chromosomes.4.00.fa && grep -A 49 'SL40ch02' S_lycopersicum_chromosomes.4.00.fa > reduced_chr2_Tomato.fa

---
title: "mobileRNA: Investigate the RNA mobilome & population-scale changes." 
author: "Katie Jeynes-Cupper, Marco Catoni"
date: "`r format(Sys.Date(), '%m/%d/%Y')`"
abstract: >
  Genomic analysis can be utilised to identify differences between RNA 
  populations in two conditions, both in production and abundance. This includes 
  the identification of RNAs produced by multiple genomes within a biological 
  system. For example, RNA produced by pathogens within a host. Or for our 
  purposes, RNAs moving between the roots and shoots across a plant graft 
  junction of partners with distinct genotypes. To locate and identify these 
  RNAs genomic pipelines typically align reads consequential to each genome in 
  the system. This comes with benefits and disadvantages. Here, we address the 
  main disadvantages, the high levels of data noise and false positives. The 
  mobileRNA package provides methods to pre-process, analyse and visualise the 
  sRNA and mRNA populations based on the premise of mapping reads to all 
  genotypes at the same time. This vignette explains the use of the package and 
  demonstrates quick or advanced workflows.
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 3
    number_sections: true
    theme: united
    highlight: tango
fig_width: 5
bibliography: library.bib
vignette: >
 %\VignetteIndexEntry{mobileRNA}
 %\VignetteEngine{knitr::rmarkdown}
 %\VignetteEncoding{UTF-8}
 %\VignetteDepends{mobileRNA}
 %\VignetteDepends{bioseq}
 %\VignetteDepends{dplyr}
 %\VignetteDepends{magick}
 %\usepackage[utf8]{inputenc}
---


```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  fig.align='center',
  external=TRUE,
  echo=TRUE,
  warning=FALSE,
  comment = "#>"
)

```

# Introduction

In plants, systemic signalling is an elaborated molecular system which 
coordinates plant development, integrating and transmitting the information 
perceived from the environment to distant organs. An important role in 
long-distance signalling is played by small RNA molecules (sRNAs). The 
nucleotide length of a sRNA helps researchers identify the class of sRNA and 
predict its functionality. Micro-RNAs (miRNAs) are involved in directing 
translational repression and/or the cleavage of messenger RNAs (mRNAs). Whereas 
small interfering RNAs (siRNAs) are involved in the maintenance and de novo DNA 
methylation and account for the majority of sRNAs in plants. These endogenous 
sRNAs can be produced in a tissue and then transported systemically across the 
vascular system into recipient organs, where they can induce a molecular 
response and coordinate physiological changes. Similarly, messenger RNAs (mRNAs) 
can move across distances, and it’s thought they may translate into proteins 
which act as transcription factors in the recipient tissues.

Plant grafting can be utilised to create chimeric plant systems composed of two 
genotypes, such as different species like tomato and eggplant, or plant 
varieties or accessions. Grafting has been used as a method to study RNA 
mobilomes and their impact on the phenotype. Yet, it is clear that there is no 
standardised genomic approach for the analysis of sequencing data to identify an 
RNA mobilome. Here we introduce the R package, mobileRNA, a recommended pipeline 
and analysis workflow for the identification of a sRNAs/mRNA mobilome. In 
addition, the flexibility supports standard RNA analysis between treatment and 
control conditions. For example, to identify sRNA population changes due to the 
application of a treatment such as cold/heat stress or exposure to a pest. 
`mobileRNA` ultimately assists in pre-processing and analysis including the 
characterization of different populations, visualization of the results, and 
supporting output for functional analysis.

As stated, this was developed for applications for plant grafting experimental 
analysis, however, we believe it could have further applications including the 
analysis of dual-host systems.

<br>

# Approach

In grafted plants, when different genotypes are used as rootstock and scions, 
the sequence variation between the two genomes involved can be used to 
discriminate the origin of a sequenced RNA molecule. Therefore, if an RNA 
molecule sequenced from one of the grafted partners (scion or rootstock) has 
been found to match the genome of the other grafting partner, this could 
empirically demonstrate its movement across the graft junction.

Most available genomics approaches to implement this analysis are based on RNA 
sequencing, followed by alignment on a genotype of reference and post-alignment 
screening of genetic variants to identify molecules which have a better match 
for the genotype of the grafted partner. These methods have many limitations, 
which might include:

*	High dependency on arbitrary thresholds to determined mapped and unmapped RNAseq reads.
*	Use of additional statistical tests to discriminate genetic variations from sequencing noise in the post-alignment analysis.
*	High false positive rates. 

Here, to circumvent such problems we propose a method inspired by the RNAseq 
analysis of plant hybrids (Lopez-Gomollon 2022), including an alignment step 
performed simultaneously on both genomes involved. The rationale of this 
approach considers that alignment tools already implement an algorithm ideal 
for the identification of the best matches (according to set parameters) in a 
given genome reference, but they do not account for potential matches to DNA 
sequences which are not provided as reference. Therefore, the two genomes from 
all partners involved in the system are merged in a single FASTA file and used 
as a reference for the unique alignment. Ultimately, in a bid to supply the 
algorithm with as much information as possible to make the best possible 
predictions and placement of sequencing reads to each genome.

The summarised workflow is shown below (Figure 1) where it contains a core 
RNA analysis and a mobile sRNA/mRNA analysis. The core 
analysis represents the standard workflow for the identification of RNA 
populations which have been gained, lost or changed in abundance, for example, 
the sRNA population difference between treatment and condition samples, or 
similarly in a chimeric system, such as plant grafting, we might want to explore 
the native sRNA population from the sample tissue origin (i.e. leaf) which have 
been lost or gained or changes in sRNA abundance. While the mobile analysis 
represents the workflow for the identification of putative mobile sRNAs or mRNA 
in a plant graft system.

As input, the pipeline requires cleaned sRNA or mRNA sequencing reads in FASTQ 
format, along with the genome assemblies which represent the genotypes in the 
system. The diagram below illustrates the complete workflow using `mobileRNA`, 
including essential, optional, and plotting functions. 

<br><br>
```{r, echo=FALSE}
cap01<-"Comprehensive diagram of complete mobileRNA workflows. "
```
```{r, fig.align="centre", echo=FALSE, fig.cap=cap01 }
knitr::include_graphics("../man/figures/mobileRNA_graphic_2.png")
```
<br>


The analysis approach includes several underlying features to be aware of which 
can alter the final output. When working with a chimeric system, the core steps 
offer the ability to remove mapping errors by comparing control samples to 
treatment samples. If the genotypes in the chimeric system are fairly distantly 
related, it is unexpected that unique reads aligned to the mobile genotype will 
be found in the control samples. With that in mind, we can assume RNAs with 
reads mapped to the mobile genotype from the control samples could be artifacts 
or mapping errors. Hence, these RNAs are removed from the analysis when the 
parameters are utilized. Note that, if the chimeric system is expected to share 
some or a high level of similarity it might be insightful to the analysis to not 
remove these sRNA clusters.

At the end of the analysis, the user will have generated a dataframe where rows 
represent either sRNA clusters or mRNAs and the columns include information on 
the sRNA clusters or mRNAs, individual sample replicates, and more:


#### sRNA Analysis

##### Information on the sRNA cluster:

- `Locus`: Genomic location
- `chr`: Chromosome or scaffold name
- `start` : Start position of the cluster
- `end` : End position of the cluster
- `Cluster`: Cluster Name 
- `DicerConsensus` : Consensus dicercall (Calculated by `RNAdicercall()`)
- `DicerCounts` : Number of replicates which contributed to the consensus dicercall (Calculated by `RNAdicercall()`)
- `CountMean` :  Count mean (Calculated by `RNAdifferentialAnalysis()`)
- `log2FoldChange` : Log fold change (Calculated by `RNAdifferentialAnalysis()`)
- `pvalue` : p-value (Calculated by `RNAdifferentialAnalysis()`)
- `padjusted` : Adjusted p-value (Calculated by `RNAdifferentialAnalysis()`)
- `logCPM` : Log counts per million (CPM/RPM) (Calculated by `RNAdifferentialAnalysis()`)

##### Information on each sample replicate:

- `DicerCall_` : The nucleotide length of most abundant sRNA 
- `Count_` : Number of aligned sRNA reads. As default, these are uniquely aligned (*e.g.* not multi-mapping).
- `RPM_` : Reads per Million 
- `FPKM_` : Fragments Per Kilobase of transcript per Million 
- `MajorRNA_` : RNA sequence of most abundant sRNA in the cluster

#### For mRNA Analysis

##### Information on the mRNA:
- `Feature`: mRNA name
- `SampleCounts` : Consensus dicercall (Calculated by `RNAdicercall()`)
- `CountMean` :  Count mean (Calculated by `RNAdifferentialAnalysis()`)
- `log2FoldChange` : Log fold change (Calculated by `RNAdifferentialAnalysis()`)
- `pvalue` : p-value (Calculated by `RNAdifferentialAnalysis()`)
- `padjusted` : Adjusted p-value (Calculated by `RNAdifferentialAnalysis()`)
- `logCPM` : Log counts per million (CPM/RPM) (Calculated by `RNAdifferentialAnalysis()`)

##### Information on each sample replicate:

- `Count_` : Number of aligned mRNA reads. As default, these are uniquely aligned (*e.g.* not multi-mapping).
- `FPKM_` : Fragments Per Kilobase of transcript per Million 

In addition, the user can utilise additional functions to plot a PCA, 
distance matrix, sRNA class distribution and heatmaps. Plus, **mobileRNA** 
offers functions to assist functional analysis to support the determination 
of the biological implications. For instance, within sRNA analysis, the user can 
extract the consensus RNA sequence for each sRNA cluster for target prediction 
analysis, as well as identifying genomic features associates with each sRNA 
clusters, such as genes or repeat regions. This can be utilised, for example, 
to explore the RNA expression of sRNA-producing genes in parallel analysis.


# Installation

The latest version of `mobileRNA` can be installed via Bioconductor:

```{r,  eval=FALSE, message=FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("mobileRNA")
```

It is also available on GitHub:
```{r,  eval=FALSE, message=FALSE}
if (!require("devtools")) install.packages("devtools")
devtools::install_github("KJeynesCupper/mobileRNA", ref = "main")
```

Load into R library:
```{r, message=FALSE}
library("mobileRNA")
```


## Installing OS Dependencies 

`mobileRNA` works on systems with `R`, and depending on the type of sequencing
data different OS dependencies installed via Conda [@Anaconda] are required for 
the alignment step. 

For sRNA data, `ShortStack` (>= 4.0) [@Axtell2013] and the dependencies are
required. Please consider that `ShortStack` is not available for Windows, hence, 
Windows users will either need to opt to use a virtual machine or 
[Windows Subsystem for Linux](https://docs.microsoft.com/en-us/windows/wsl/install-win10)
In either case, both `R` and `ShortStack` will need to be installed and used on 
the Linux side. Please head to [ShortStack](https://github.com/MikeAxtell/ShortStack#install-using-conda-recommended) 
to see the recommended installation instructions with Conda [@Anaconda].
This will ensure all dependencies are available within the same environment. 

For mRNA data, [HISAT2](https://anaconda.org/bioconda/hisat2) [@Kim2015], 
[HTSeq](https://anaconda.org/bioconda/htseq) [@Anders2014], 
[SAMtools](https://anaconda.org/bioconda/samtools) [@Danecek2021] are required 
within the same Conda environment [@Anaconda].


## Example Data

The package includes a simulated data set to replicate the grafting
between eggplant-tomato (*Solanum melongena* - *Solanum lycopersicon*) where 
eggplant represents the scion and tomato represents the rootstock. The FASTQ 
files represent data extracted from the eggplant leaf tissue. Here we 
will locate mobile RNAs produced by tomato roots which have travelled into the 
eggplant leaves. In the example data set, there are heterograft replicate,
where each is an individual tomato replicate spiked with the same random set of 
tomato sRNA clusters. There are two sets of each for mRNA analysis and three 
sets for sRNA analysis. These are known as:

* `heterograft_1`
* `heterograft_2`
* `heterograft_3`  (sRNA analysis only)

There are self-graft replicates, where each is an individual tomato 
replicate without the spiked tomato sRNA clusters. These are:

* `selfgraft_1`
* `selfgraft_2` 
* `selfgraft_3` (sRNA analysis only)

The replicates mirror each other where, for instance, `heterograft_1` 
and `selfgraft_1` are the same replicate, either with or without the spiked 
clusters. 

Hence, we also provide more comprehensive data sets, for small RNA it is called
`sRNA_data` and for messenger RNA it is called `mRNA_data`. Each stores an 
example dataframe produced by the importation step with  `RNAimport()`. This can 
be loaded in the R environment by using the following command:


```{r Load, message=FALSE}
# Load small RNA data
data("sRNA_data")

# Load messenger RNA data
data("mRNA_data")
```

For sRNAseq & mRNAseq alignment step, we provide demo FASTQ files; these have a 
reduced number of reads and do not cluster as expected, so should not be used 
for downstream analysis. These are stored within `inst/extdata`. Tomato and 
Eggplant reduced genome assemblies and annotations have been provided
based on those generated by Hosmani et al., 2019 [@Hosmani2019] and Barchi 
et al., 2021 [@Barchi2021].

The simulated data was generated from the data published 
[@Li2022, @Qing2022, @Villanueva2023, @TomatoGenomeConsortium2012].

# Example Workflow: Locating the sRNA Mobilome 
This is a quick-start example analysis of sRNAseq data to locate putative mobile
root-to-shoot sRNAs from a plant grafting experiment between eggplant and 
tomato. 
<br>

## Quick Start

###  Merging Genome Assemblies 
Merge the FASTA genome assemblies of tomato and eggplant into a single
reference file stored in your desired directory. Eggplant represents the scion 
as genome A, and tomato represents the rootstock (foreign/mobile) as genome B. 

```{r, message=FALSE}
fasta_1 <- system.file("extdata","reduced_chr12_Eggplant.fa.gz", 
                       package="mobileRNA")

fasta_2 <-system.file("extdata","reduced_chr2_Tomato.fa.gz",
                      package="mobileRNA")
# define temporary output directory - replace with your directory
output_assembly_file <- file.path(tempfile("merged_assembly", 
                                           fileext = ".fa"))

# merge
merged_reference <- RNAmergeGenomes(genomeA = fasta_1,
                                    genomeB = fasta_2,
                                    output_file = output_assembly_file)
```

<br>

###  Merging Genome Annotations 
Now, repeat for the genome annotations (GFF) - this is required for downstream 
analysis or for mRNA mapping.

*It is important that the same alterations are made to each genome in the merged
files. Otherwise, the annotation file will not align with the chromosome names 
in the assembly file.*
<br>

```{r, message=FALSE}
anno1 <- system.file("extdata","reduced_chr12_Eggplant.gff.gz",
                     package="mobileRNA")

anno2 <- system.file("extdata","reduced_chr2_Tomato.gff.gz", 
                     package="mobileRNA")

# define temporary output directory 
output_annotation_file <- file.path(tempfile("merged_annotation", 
                                             fileext = ".gff3"))

# merge annotation files into a single file
merged_annotation <- RNAmergeAnnotations(annotationA = anno1,
                                         annotationB = anno2,
                                         output_file = output_annotation_file)
```
<br>


###  Alignment 
Here we will align our samples containing small RNA sequencing reads to the 
merged genome assembly. The `mapRNA()` function invokes a system 
command to `ShortStack`; an application which employs `Bowtie` [@Langmead2009] 
mapping and performs comprehensive de novo annotation and quantification of 
sRNA genes. The function first undertakes de novo sRNA cluster detection 
(stored in `1_de_novo_detection`) and then quantification of sRNA genes 
(stored in`2_sRNA_results`). Since we are using chimeric samples, we 
use `mmap = n` to exclude multi-mapped reads. We exclude multi-mappers as we 
currently do not have a method to distinguish whether a read is mapped to 
multiple locations within one or both of the genomes in the merged reference. 

**PLEASE NOTE:** For the alignment & import demo, we are using fastq files which 
have a reduced size for the package. This data will not be used for the 
continued analysis step, instead, you will need to load the full dataset. 

```{r, eval=FALSE}
# directory containing only sRNAseq samples 
samples <- system.file("extdata/sRNAseq",package="mobileRNA")

# output location
output_location <- tempdir()

mapRNA(input = "sRNA",
       input_files_dir = samples, 
       output_dir = output_location, 
       genomefile = output_assembly_file,
       condaenv = "/Users/user-name/miniconda3/envs/ShortStack4",
       mmap = "n")
```

If there are issues utilising this function, the manual steps are illustrated in 
the [Appendix](#Appendix)
<br>


###  Import Pre-Processed Data into R 
Import the results from the alignment step into R using the `RNAimport()` 
function. 

```{r, eval=FALSE}
# Directory containing results
results_dir <-  file.path(output_location,"2_sRNA_results")

# Sample names and total number of reads, in the same order. 
sample_names <- c("selfgraft_demo_1", "selfgraft_demo_2", 
                  "selfgraft_demo_3", "heterograft_demo_1",
                  "heterograft_demo_2", "heterograft_demo_3")


sRNA_data_demo <- RNAimport(input = "sRNA", 
                            directory = results_dir,
                            samples = sample_names)
```
<br>

This will generate a dataframe where rows represent sRNA clusters and 
contains the following columns: 
  
- `Locus`: Genomic location
- `chr`: Name of the chromosome or scaffold
- `start` : Start position of the cluster
- `end` : End position of the cluster
- `Cluster`: Cluster Name

For each sample, the following columns will be present. Where the sample name 
follows after the underscore: 
  
- `DicerCall_` : The size of most abundant small RNA size
- `Count_` : Number of uniquely aligned reads that overlap the locus.
- `RPM_` : Reads per Million
- `FPKM_` : Fragments Per Kilobase of transcript per Million
- `MajorRNA_` : RNA sequence of the most abundant sRNA in the cluster

###  Import Example Data 
Load the full analysis dataset for a more comprehensive analysis: 

```{r}
data("sRNA_data")
```


###  Identify Potential Mobile sRNA clusters

Select the putative mobile sRNA clusters using `RNAmobile()`. This
requires supplying the function with a unique identifier of the
rootstock genome, which is the prefix "B" to the tomato chromosome names. Here, 
the function retains sRNA clusters which were aligned to the tomato genome. 

```{r, message=FALSE}
# define control samples
controls <- c("selfgraft_1", "selfgraft_2", "selfgraft_3")

mobile_sRNA <- RNAmobile(input = "sRNA",
                         data = sRNA_data, 
                         controls = controls,
                         genome.ID = "B",
                         task = "keep")
```


```{r, eval=FALSE}
# save output as txt file 
write.table(mobile_sRNA, "./sRNA_mobile_output.txt")
```

<br>


 
## Advancing the Analysis
For a more advanced analysis, users can include further steps. Here we 
demonstrate a more advanced analysis for the Core RNA analysis and Mobile 
RNA analysis, both demonstrated with the sRNAseq dataset.


### Core sRNA Analysis
#### Quality control
A useful step before analysis is to assess the overall similarity between
sample replicates to understand which samples are similar and different. This
is known as sample-level quality control and can help us understand where the 
largest variation is introduced, whether the data meets the expectations and if 
there are outliers. 
<br> 

##### Plot the distribution of sRNA classes within each sample
Here, the `RNAdistribution()` function can generate a number of different 
customized plots to represent the number of sRNA clusters within each 
dicercall sRNA class in a sample. In plants, sRNAs are known to be produced 
with the length between 20-24 nucleotides, and the lengths signify the sRNA 
class and specific functional role in (epi)genetic regulation. If there was an 
inconsistent size profile of sRNAs within the cluster, the dicercall is defined
as "N", ie, unclassified. 

Plotting the distribution of dicercall sRNA classes within each replicate can 
support expectation for samples. For instance, if a significant number of sRNA 
clusters are unclassified it might suggest the data contains degraded 
RNA fragments, or novel types of sRNA genes. 

```{r, echo=FALSE}
cap1 <- "An example facet line graph to show the distribution of sRNA classes within each sample."
cap2 <- "An example facet bar graph to show the distribution of sRNA classes within each sample."
```

```{r}
# plot each replicate as a line, separately, and facet 
sample_distribution_line <- RNAdistribution(sRNA_data,
                                            style = "line",
                                            overlap =  FALSE, 
                                            facet = TRUE,
                                            colour = "darkgreen")

                                            
 # plot each replicate as a bar, separately, and facet 
sample_distribution_bar <- RNAdistribution(sRNA_data,
                                           style = "bar",
                                           facet = TRUE,
                                           colour ="lightblue")
```

Let's view the plots:

```{r, fig.cap=cap1, fig.show="hold", fig.height=10, fig.width=15}
# View plot (only)
sample_distribution_line$plot
```
<br>
```{r, fig.cap=cap2, fig.show="hold", fig.height=10, fig.width=15}
# View plot (only)
sample_distribution_bar$plot
```
<br>


##### PCA
Principal Component Analysis (PCA) is a useful technique to illustrate sample
distance as it emphasizes the variation through the reduction of dimensions in
the data set. Here, we introduce the function `plotSamplePCA()`

```{r, echo=FALSE}
cap4 <-"An example of a PCA, illustrating  the sRNA data set sample similarity"
```

```{r, message=FALSE, fig.cap=cap4, fig.show="hold", fig.height=8, fig.width=15}
groups <- c("Heterograft", "Heterograft", "Heterograft",
            "Selfgraft", "Selfgraft", "Selfgraft")

 plotSamplePCA(data = sRNA_data, group = groups, size.ratio = 2)
```
<br>

##### Distance matrix heatmap
Similarly to a PCA plot, the `plotSampleDistance()` function undertakes
hierarchical clustering with an unbiased log transformation to calculate sample
distance illustrated with a distance matrix heatmap.

```{r, echo=FALSE}
cap5 <-"An example of a heatmap, illustrating the sRNA data set sample similarity"

```

```{r ,message=FALSE, fig.cap=cap5, fig.show="hold"}
plotSampleDistance(sRNA_data)
```
<br>


#### Define the consensus dicercall
Have a look at the `sRNA_data` data frame, you will see that for each sample the
sRNA class for a given cluster has been determined (see columns with names 
containing with "DicerCall_") which, in this data, will state a number from 
20-24. This value represent the length in nucleotides of the most abundant 
sRNA within the cluster. For some clusters, there is no particular sRNA which 
is more abundant than another, hence, it is stated as "NA" or "N", which is 
referred to as being unclassified. 

The `RNAdicercall()` function is used to calculate the consensus dicercall
for each sRNA cluster. This is based on the classification predicted for the 
cluster by each sample within the analysis. There are several parameters which
will alter the output, including the handling of ties and the
method to draw the consensus from. 

When working along the mobile sRNA analysis workflow, the function contains 
a specialised parameter which can be utilized. This is `chimeric=TRUE`, plus
with the `genome.ID` and `controls` parameters. In the example below `B_` 
represents the prefix added to the mobile/foreign genotype, which is 
the rootstock tomato genome. This helps optimise classification by removal of 
potential mapping errors. 

```{r, message=FALSE}
# define consensus, store as a data summary file.
sRNA_data_dicercall <- RNAdicercall(data = sRNA_data, 
                                     chimeric = TRUE, 
                                     genome.ID = "B_", 
                                     controls = c("selfgraft_1", 
                                                  "selfgraft_2", 
                                                  "selfgraft_3"))
```

For the downstream analysis, it can be useful to define distinct groups of 
sRNA classes depending on your organism. For plant samples, it is beneficial to 
select a group of 24-nt and another containing 21/22-nt sRNAs. 
To subset the data, use the `RNAsubset()` function to choose which sRNA 
populations.

```{r, message=FALSE}
# Subset data for analysis: 24-nt sRNAs
sRNA_24 <- RNAsubset(sRNA_data_dicercall, class = 24)

# Subset data for analysis: 21/22-nt sRNAs
sRNA_2122 <- RNAsubset(sRNA_data_dicercall, class = c(21, 22))
```
<br>


##### Plot the consensus dicercall

The `RNAdistriution()` function can be used to visualize the 
distribution of the consensus dicercall classes across the total data set.   

```{r, message=FALSE}
consensus_plot <- RNAdistribution(data = sRNA_data_dicercall,
                                  style = "bar",
                                  data.type = "consensus")
```

```{r, echo=FALSE}
cap6<-"An example of the distribution of small RNA consensus dicer classifications. "
```
Now, view the plot:
```{r, fig.cap=cap6, fig.height=10, fig.width=15}
# view 
consensus_plot$plot
```
<br>


#### Differential analysis with `DESeq2` or `edgeR`
Differential analysis is undertaken to identify RNAs which 
are statistically significant to discover quantitative changes in the abundance
levels between the treatment and the control groups. This technique can be 
undertaken with either the `DESeq2` [@Love2014] or `edgeR` [@edgeR_GLM] 
analytical method. 

First, let's re-order the data frame so we can compare control vs treatment
(i.e. Selfgraft vs Heterograft). When the data is imported, it may not be in the
correct order/levels for comparison.  
```{r, message=FALSE}
#reorder df
controls <- c("selfgraft_1", "selfgraft_2", "selfgraft_3")
reorder_df <- RNAreorder(sRNA_data_dicercall, controls)

# sample conditions in order within dataframe
groups <- c("Selfgraft", "Selfgraft", "Selfgraft", 
            "Heterograft", "Heterograft", "Heterograft")

## Differential analysis of whole dataset: DESeq2 method 
sRNA_DESeq2 <- RNAdifferentialAnalysis(data = reorder_df,
                              group = groups,
                              method = "DESeq2")
```

We can summarise the results using `RNAsummary()`:

```{r, results='asis'}
RNAsummary(sRNA_DESeq2)
 
```

How about looking at the sRNA population which are statistically significant:

```{r, results='asis'}
RNAsummary(sRNA_DESeq2, alpha=0.05)

```


##### Save output 
```{r, eval = FALSE}
write.table(sRNA_DESeq2, "./sRNA_core_dataset.txt")
```


#### Differences in RNA abundance 
When comparing treatment to control conditions, it might be the case that 
the same sRNA clusters are found within both, yet, there could be difference in 
the total abundance of the shared clusters. For instance, for a given sRNA 
cluster the samples in the treatment condition might have a greater abundance 
than the samples in the control condition. 

The statistical analysis calculated the log2FC values for each sRNA cluster by 
comparing the normalised counts between treatment and control. Here, 
a positive log2FC indicates an increased abundance of transcripts for a given 
sRNA cluster in the treatment compared to the control, while negative log2FC 
indicates decreased abundance of transcripts for a given sRNA cluster. The 
statistical significance of the log2FC is determined by the adjusted p-value.

Here we will filter the data to select sRNA clusters which are statistically 
significant, and then plot the results as a heatmap to compare the conditions. 

*NOTE:* the data used here will not yield any results as the 
treatment and control samples contain the exact same population of eggplant 
sRNAs, the only difference in the treatment samples are the spiked tomato 
sRNA clusters. 
```{r, fig.show="hold"}
# summary of statistical sRNA clusters
RNAsummary(sRNA_DESeq2, alpha=0.05)

# select significant 
significant_sRNAs <-  sRNA_DESeq2[sRNA_DESeq2$padjusted < 0.05, ]
```


```{r, echo = FALSE}
capp1 <- "Heatmap of statistically significant sRNA clusters"
```

Plot the results:
<br>
```{r, fig.show="hold", message=FALSE}
p1 <- plotHeatmap(significant_sRNAs, value = "RPM", row.names = FALSE,
                  title = "Heatmap of log-transformed FPKM")
```


```{r, fig.show="hold", message=FALSE, fig.cap=capp1}
p1$plot
```


#### Identify gain & loss of RNA populations
The `RNApopulation()` function can be utilised to identify unique 
sRNA populations found in the treatment or control conditions. This represents 
the sRNA which are gained or lost due to the treatment conditions. 

First let's look at the sRNA clusters gained to the treatment condition.
In the chimeric heterografts, we expect that the foreign sRNAs will also be 
selected in this pick-up, therefore, we can use the parameter `genome.ID` to 
remove sRNA cluster related to the foreign genome. 

```{r, message=FALSE}
# select sRNA clusters only found in treatment & not in the control samples
gained_sRNA <- RNApopulation(data = sRNA_DESeq2, 
                                  conditions = c("heterograft_1", 
                                                 "heterograft_2" , 
                                                 "heterograft_3"),
                                  chimeric = TRUE, 
                                  genome.ID = "B_", 
                                  controls = c("selfgraft_1",
                                               "selfgraft_2", 
                                               "selfgraft_3"))

# look at number of sRNA cluster only found in treatment 
nrow(gained_sRNA)
```

Now, the sRNA clusters lost and only produced in the control condition:
```{r, message=FALSE}
# select sRNA clusters only found in control & not in the treatment samples
lost_sRNA <- RNApopulation(data = sRNA_DESeq2, 
                                conditions = c("selfgraft_1", 
                                               "selfgraft_2" , 
                                               "selfgraft_3"), 
                                  chimeric = TRUE, 
                                  genome.ID = "B_", 
                                  controls = c("selfgraft_1",
                                               "selfgraft_2", 
                                               "selfgraft_3"))
# look at number of sRNA cluster only found in control  
nrow(lost_sRNA)
```


#### Functional analysis of gained sRNA populations 
Now we have identified unique populations produced or not produced in our 
treatment samples compared to our control samples, we can extract the RNA 
sequences to undertaken target prediction and then onward to gene ontology 
enrichment analysis. 

```{r, message=FALSE}
gained_sRNA_sequences <- RNAsequences(gained_sRNA, method = "consensus" )
```

Moreover, we can identify genomic features associated with these sRNA clusters 
which are unique to the treatment and absent in the control (i.e. gained).

```{r, message=FALSE}
gained_sRNA_attributes <- RNAattributes(data = gained_sRNA, 
                                        match ="genes",
                            annotation = output_annotation_file)
```
<br>

### Mobile sRNA Analysis 
We identify candidate mobile RNAs by identifying those which are mapped 
to the genotype representing the mobile RNAs. These can be isolated using the 
`RNAmobile()` function. Then the user can undertake further steps to assist 
functional analysis. 

In respect to the example data set, we are looking to identify sRNAs traveling 
from the tomato rootstock to the eggplant scion in the heterografts. Hence, this
function will look to select clusters mapped to the tomato genome and remove 
those mapped to the eggplant genome. Previously, the example of the prefix `B_` 
was added to the chromosomes of the tomato genome while prefix `A_` added to 
the eggplant genome. To remove or keep specific clusters, we align this request
with the `"task"` parameter.

```{r , message=FALSE}
# vector of control names
control_names <- c("selfgraft_1", "selfgraft_2", "selfgraft_3")


## Identify potential tomato mobile molecules
mobile_sRNA <- RNAmobile(input = "sRNA",
                        data = sRNA_DESeq2, 
                         controls = control_names,
                         genome.ID = "B_",
                         task = "keep", 
                         statistical = FALSE)
```
<br>

#### Heatmap plots to represent mobile molecules
We can plot our results as a heatmap, which represents the normalised
reads-per-million (RPM) values which have been log transformed.  
<br>

Here we will plot all potential mobile molecules and those which are 
statistically significant:

```{r, echo=FALSE}
cap7 <- "An example heatmap of candidate mobile small RNAs. Where the columns represent the sample replicates and the rows represent the small RNA cluster."

```

```{r,fig.cap=cap7, fig.show="hold" , message=FALSE}
p2 <- plotHeatmap(mobile_sRNA, row.names = FALSE)

p2$plot
```
<br>

#### Save output 

```{r, eval = FALSE}
write.table(mobile_sRNA, "./candidate_mobile_sRNAs.txt")
```

<br>

#### Functional analysis of putative mobile sRNA clusters
Now, we can extrapolate information to assist the prediction of their targets 
and role in the biological system. **mobileRNA** offer three different tools to 
assist the functional analysis. 

**IMPORTANT:** Alterations to the genome assemblies by the `RNAmergeGenomes()`
function must be replicated in the annotations. A merged annotation with the 
same amendments can be created with the function `RNAmergeAnnotations()`. 
<br>

##### Add genomic attributes to sRNA clusters   
Each sRNA cluster contains coordinates, these can be matched with coordinates in
an annotation file. A match occurs when the cluster is found within the 
coordinates of a feature. If there is a match, the function returns the input 
dataframe with additional fields of information from the annotation file. 

This enables users to identify the genomic features producing the mobile 
sRNAs. Here we will be overlapping the data with genes and adding a buffer 
region of 1 kb upstream and downstream of each gene. 

```{r}
annotation_file <- system.file("extdata",
                     "prefix_reduced_chr2_Tomato.gff", 
                     package="mobileRNA")

mobile_attributes <- RNAattributes(data = mobile_sRNA, 
                                      match ="genes",
                                      annotation = annotation_file)


```
<br>

##### Summarise sRNA cluster overlaps with genomic features 
Very similar to before, we can find stricter overlaps between our candidate 
sRNA clusters and genomic features. However, this time we can calculate the 
number of sRNA clusters which are associated to each type of feature. These 
include promoter regions, exon, introns, untranslated regions and repeat 
regions. The results can either be displayed in the data frame as an 
absolute value or as a percentage of the total:

```{r}
mobile_features <- RNAfeatures(data = mobile_sRNA, 
                               annotation = annotation_file)
print(mobile_features)

# plot as stacked bar chart
features_plot <- plotRNAfeatures(data = mobile_sRNA,  
                                 annotation = annotation_file)

plot(features_plot)
```
<br>

##### Retrieve RNA sequence from mobile sRNA clusters
To predict the targets of the mobile sRNA candidates, we need to extract
the RNA sequence. Here, we introduce the `RNAsequences()` function which
extrapolates the most common RNA sequence for a cluster and determines the 
complementary sequences.


```{r, message=FALSE}
mobile_sequences <- RNAsequences(mobile_sRNA, method = "consensus") 
```
<br>

The output consists of a dataframe of 6 columns where rows represent each 
putative sRNA cluster. The columns include:

- `Cluster`: name of sRNA cluster
- `Match`: whether the RNA sequence is consistent across replicates (either "No", "Yes" or "Duplicate"; where "Duplicate" indicates a tie)
- `Sequence`:  RNA sequence of the most abundant sRNA within a cluster across samples
- `Width`: length of nucleotide sequence
- `Complementary_RNA`: complementary RNA nucleotide sequence
- `Complementary_DNA`: complementary DNA nucleotide sequence


```{r, eval = FALSE}
write.table(mobile_sequences, "./candidate_mobile_sRNA_sequences.txt")
```

To predict the potential targets in a recipient tissue, a target prediction 
tool such as `psRNATarget` [@Xinbin2018] can be used. For such a tool, we can 
manipulate the output of `RNAsequences()` to match the input style for target 
prediction using the following code:

```{r, message=FALSE}
# load `dplyr` package
library(dplyr)

# select the cluster and sequence columns 
sequences <- mobile_sequences %>% select(Cluster, Sequence)

# add prefix, remove row with NA
prefix <- ">"
sequences$Cluster <- paste0(prefix, sequences$Cluster)
sequences <- na.omit(sequences)

# convert to required format:
res <- do.call(rbind, lapply(seq(nrow(sequences)), 
                             function(i) t(sequences[i, ])))
```

Save output:
```{r, eval = FALSE, message=FALSE}
# save output 
write.table(res, file ="./mobile_sRNA_sequences.txt",
            row.names = FALSE, col.names = FALSE, quote = FALSE)
```
<br>

Other steps can be taken at this stage including alignment of the mobile sRNA 
sequences to identify consensus sequences. For example, this can be undertaken 
with the R package `bioseq`:

```{r, eval = FALSE}
# load `bioseq` package
library(bioseq)

# build a RNA vector from a character vector: 
mobileRNA_seq <- bioseq::rna(mobile_sequences$Sequence)

# Find a consensus sequence for a set of sequences:
bioseq::seq_consensus(mobileRNA_seq)
```



# Appendix 

## Manual sRNA Alignment Pipeline
If users wish to undertake the alignment step independently, the manual steps 
are shown below, of which, will need modifying to suit your files and 
directory names. 

### Core sRNA Analysis
#### Step 1 - De novo sRNA analysis
Here, `ShortStack` [@Axtell2013] aligns the reads (includes multimapped reads) 
with Bowtie [@Langmead2009] and undertakes de novo sRNA clustering analysis.

*bash scripting*
```{bash, eval=FALSE} 
ShortStack \
--readfile "[fastqfile.fq]" \
--genomefile "[genomefile.fa.gz]" \
--threads 6 \
--mmap u \
--pad 200 \
--mincov 0.5 \
--nohp \
--outdir "[output_dir]"
```

#### Step 2 - Build sRNA cluster list 
Step 2 collates all the sRNA loci information from each sample into a text file.

*R scripting*
```{r, eval=FALSE}
# names of samples, represented by folder names produced in previous step
samples <- c("[sample names]")

# location of output folders from previous step
dir <- "[output_dir]"

# merge information of the detected de novo sRNA clusters
gff_alignment <- GenomicRanges::GRangesList()
for (i in samples) {
  file_path <- file.path(dir, i, "Results.gff.gz3")
  if (file.exists(file_path)) {
    gff_alignment[[i]] <- rtracklayer::import.gff(file_path)
  } else{
    Stop("File does not exist:", file_path, "\n")
  }
}

gff_merged <- GenomicRanges::reduce(unlist(gff_alignment), 
                                    ignore.strand = TRUE)

gff_merged <- as.data.frame(gff_merged)
colnames(gff_merged)[1] <- "chr"
if('*' %in% gff_merged$strand){
    gff_merged <- gff_merged[, -match("strand", colnames(gff_merged))]
  }

locifile_txt <- data.frame(Locus = paste0(gff_merged$chr, ":", 
                                          gff_merged$start,"-", 
                                          gff_merged$end), 
                           Cluster = paste0("cluster_", 
                                            seq_len(nrow(gff_merged))))

# save output to location 
dir_locifile <- "[output directory]"
loci_out <- file.path(dir_locifile,"locifile.txt")
utils::write.table(locifile_txt, file = loci_out, quote = FALSE, 
                   sep = "\t", row.names = FALSE, col.names = TRUE)

```


#### Step 3 - sRNA clustering    
Finally, we repeat the sRNA clustering using the de novo sRNA loci list to 
produce our results. The output folders are used as input for the `RNAimport()`
function.

*bash scripting*
```{bash, eval=FALSE}
ShortStack \
--readfile "[fastqfile.fq]" \
--genomefile "[genomefile.fa.gz]" \
--locifile "[locifile]"  \
--threads 6 \
--mmap u \
--nohp \
--pad 200 \
--mincov 0.5 \
--outdir "[output_dir_2]"
```
<br>
  
### Mobile sRNA Analysis
#### Step 1 - De novo sRNA analysis 
Here, `Bowtie` [@Langmead2009] aligns the reads (excluding multimappers) and 
`ShortStack` [@Axtell2013] undertakes de novo sRNA clustering analysis.

*bash scripting*
```{bash, eval=FALSE}
#index reference genome 
bowtie-build --threads 6 [genomefile.fa.gz] [genomefile]

# alignment 
bowtie -p 6 -v 0 -a -m 1 --sam -x [genomefile] [fastqfile.fq] | samtools view -bS | samtools sort -o [outputfile.bam]

# cluster analysis with ShortStack - use the alignment files as input
ShortStack \
--bamfile "[outputfile.bam]" \
--genomefile "[genomefile.fa.gz]" \
--threads 6 \
--pad 200 \
--mincov 0.5 \
--nohp \
--outdir "[output_dir]"
```

#### Step 2 - Build sRNA cluster list 
Step 2 collates all the sRNA loci information from each sample into a text file.

*R scripting*
```{r, eval=FALSE}
# names of samples, represented by folder names produced in previous step
samples <- c("[sample names]")

# location of output folders from previous step
dir <- "[output_dir]"

# merge information of the detected de novo sRNA clusters
gff_alignment <- GenomicRanges::GRangesList()
for (i in samples) {
  file_path <- file.path(dir, i, "Results.gff.gz3")
  if (file.exists(file_path)) {
    gff_alignment[[i]] <- rtracklayer::import.gff(file_path)
  } else{
    Stop("File does not exist:", file_path, "\n")
  }
}

gff_merged <- GenomicRanges::reduce(unlist(gff_alignment), 
                                    ignore.strand = TRUE)

gff_merged <- as.data.frame(gff_merged)
colnames(gff_merged)[1] <- "chr"
if('*' %in% gff_merged$strand){
    gff_merged <- gff_merged[, -match("strand", colnames(gff_merged))]
  }

locifile_txt <- data.frame(Locus = paste0(gff_merged$chr, ":", 
                                          gff_merged$start,"-", 
                                          gff_merged$end), 
                           Cluster = paste0("cluster_", 
                                            seq_len(nrow(gff_merged))))

# save output to location 
dir_locifile <- "[output directory]"
loci_out <- file.path(dir_locifile,"locifile.txt")
utils::write.table(locifile_txt, file = loci_out, quote = FALSE, 
                   sep = "\t", row.names = FALSE, col.names = TRUE)
```

#### Step 3 - sRNA clustering    
Finally, we repeat the sRNA clustering using the de novo sRNA loci list to 
produce our results. The output folders are used as input for the `RNAimport()`
function.

*bash scripting*
```{bash, eval=FALSE}
ShortStack \
--bamfile "[outputfile.bam]" \
--genomefile "[genomefile.fa.gz]" \
--locifile "[locifile.txt]" \
--threads 6 \
--nohp \
--mincov 0.5 \
--pad 200 \
--outdir "[output_dir_2]"
```
<br>
  
  
## Manual mRNA Alignment pipeline 
Below states the manual steps for mRNAseq alignment for mobile mRNA 
identification. Keep in mind these commands need modifying to suit your files 
and directory names. 

These steps utilise HISAT2 [@Kim2015] and HTSeq [@Anders2014] OS software. 

If required, index the genome assembly:
*bash scripting*
```{bash, eval=FALSE}
hisat2-build --threads 6 [genomefile.fa.gz] [genomefile]
```


### Single-End Sequencing Reads

*bash scripting*
```{bash, eval=FALSE}
# alignment with hisat2
hist2 -p 6 -x [genomefile] -U [fastqfile_1.fq] -S [outputfile.sam]

# select reads only mapped to one location:
grep "NH:i:1" [outputfile.sam] > [outputfile_uniqueReads.sam]

# reheader the sam file:
samtools view -H [outputfile.sam] > [outputfile_header.txt]
cat [outputfile_header.txt] [outputfile_uniqueReads.sam] > [outputfile_uniqueReads_H.sam]

# convert to bam and sort
samtools view -Sb [outputfile_uniqueReads_H.sam] | samtools sort -o [outputfile_uniqueReads_H.bam]


# make folder to store output for sample:
mkdir [samplename]

# raw count with HTSeq
python -m HTSeq.scripts.count \
--format=bam  \
--order=pos \
--stranded=no \
--mode=union \
--nonunique=none \
--type=mRNA \
--idattr=Name \
[outputfile_uniqueReads_H.bam] \
[annotationfile.gff] \
> [./samplename/Results.txt]

```

### Pair-End Sequencing Reads 

*bash scripting*
```{bash ,eval=FALSE}
# alignment with hisat2
hist2 -p 6 -x [genomefile] \
-1 [fastqfile_1.fq] \
-2 [fastqfile_2.fq] \
-S [outputfile.sam]

# select reads only mapped to one location:
grep "NH:i:1" [outputfile.sam] > [outputfile_uniqueReads.sam]

# reheader the sam file:
samtools view -H [outputfile.sam] > [outputfile_header.txt]
cat [outputfile_header.txt] [outputfile_uniqueReads.sam] > [outputfile_uniqueReads_H.sam]

# convert to bam and sort
samtools view -Sb [outputfile_uniqueReads_H.sam] | samtools sort -o [outputfile_uniqueReads_H.bam]


# make folder to store output for sample:
mkdir [samplename]

# raw count with HTSeq
python -m HTSeq.scripts.count \
--format=bam  \
--order=pos \
--stranded=no \
--mode=union \
--nonunique=none \
--type=mRNA \
--idattr=Name \
[outputfile_uniqueReads_H.bam] \
[annotationfile.gff] \
> [./samplename/Results.txt]

```



# Session Information
```{r}
sessionInfo()
```
<br>

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSamplePCA.R
\name{plotSamplePCA}
\alias{plotSamplePCA}
\title{PCA plot of PC1 and PC2}
\usage{
plotSamplePCA(
  data,
  group,
  vst = FALSE,
  labels = TRUE,
  boxed = TRUE,
  legend.title = "Conditions",
  size.ratio = 2,
  colours = NULL,
  point.shape = TRUE,
  ggplot.theme = NULL,
  label.box.padding = 1,
  title = "PCA plot",
  legend.position = "top",
  legend.direction = "horizontal"
)
}
\arguments{
\item{data}{data.frame; originally generated by \code{\link[=RNAimport]{RNAimport()}}}

\item{group}{character; contains experimental conditions for each
replicate.

\emph{IMPORTANT}: Ensure this is in the same order as the replicates are
found in the data frame supplied to the \code{data} argument (from left to right).}

\item{vst}{logical; variance stabilizing transformation. By default, the
function uses a regularized log transformation on the data set, however, this
will not suit all experimental designs.}

\item{labels}{logical; include sample name labels on PCA. Default
\code{labels=TRUE}}

\item{boxed}{logical; add a box around each sample name label. Default
\code{boxed=TRUE}}

\item{legend.title}{character; title for legend key. Default
\code{legend.title = "Conditions"}}

\item{size.ratio}{numeric; set plot ratio, broadens axis dimensions by ratio.
Default \code{size.ratio=2}, double the plot dimension.}

\item{colours}{character; vector of HEX colour codes. Must match the number of
conditions.}

\item{point.shape}{logical; set whether the point shapes should be different
for each condition.}

\item{ggplot.theme}{character; state the \code{ggplot2} theme (without ()
brackets). For example, \code{ggplot.theme=ggplot2::theme_classic}.}

\item{label.box.padding}{numeric; Amount of padding around bounding box,
as a unit or number. Defaults to 1.}

\item{title}{character; title for plot.}

\item{legend.position}{character; the position of legends
("none", "left", "right", "bottom", "top", or two-element numeric vector)}

\item{legend.direction}{character; layout of items in legends
("horizontal" or "vertical")}
}
\value{
A PCA plot to show sample distance.
}
\description{
Draws a principal component analysis (PCA) plot of PC1 and PC2.
The function undertakes rlog transformation of the data in an unbiased manner
(\code{blind=TRUE}).
}
\details{
This function uses the \code{DESeq2} package to organise and plot the
data. It organises the data into a DESeqDataSet which undergoes
log-transformation where the results are used to undertake the PCA analysis.
The results are plotted against the principal  components 1 and 2.

In special conditions, regularized log transformation will not suit
the experimental design. For example, an experimental design without
replicates. In this instance, it is preferable to change the default setting
and switch to a variance stabilizing transformation method
(\code{`vst=TRUE`}).
}
\examples{
data("sRNA_data")

groups <- c("Heterograft", "Heterograft", "Heterograft",
            "Selfgraft", "Selfgraft", "Selfgraft")
            
            
p <-  plotSamplePCA(data = sRNA_data, group = groups)

plot(p)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mobileRNA-package.R
\docType{package}
\name{mobileRNA}
\alias{mobileRNA}
\alias{mobileRNA-package}
\title{mobileRNA: Explore RNA mobilome & population-scale changes}
\description{
Uses small RNA or messenger RNA sequencing data in two conditions and
identifies changes in the RNA population. \code{mobileRNA} was primarily designed
for the identification of a putative RNA mobilome in a chimeric system. For
example, in plant graft systems. As input, \code{mobileRNA} takes sRNAseq or
mRNAseq fastq files. Output consists of a data frame with putative
differences between two conditions along with a number of plots.
}
\details{
The most important functions in the \pkg{mobileRNA} are:
\describe{
\item{\code{\link{RNAmergeGenomes}}}{Merge two genome assembly files (FASTA).}
\item{\code{\link{RNAmergeAnnotations}}}{Merge two genome annotation files
(GFF).}
\item{\code{\link{mapRNA}}}{Pre-processing of sRNAseq and mRNAseq
(alignment, raw count, cluster analysis).}
\item{\code{\link{RNAimport}}}{Reads the pre-processing report files into a
dataframe for all conditions}
\item{\code{\link{RNAdicercall}}}{Calculates the consensus sRNA
dicercall class.}
\item{\code{\link{RNAsubset}}}{Subsets the data set based on the sRNA class.}
\item{\code{\link{RNAdifferentialAnalysis}}}{Undertakes differential
analysis with either the edgeR or DESeq2 method.}
\item{\code{\link{RNAmobile}}}{Identify putative RNA molecules produced by
the non-tissue sample genome}
\item{\code{\link{RNApopulation}}}{Identify gained/lost RNA populations
between treatment and control conditions.}
\item{\code{\link{RNAsummary}}}{Summarise the differential abundance of
RNAs.}
\item{\code{\link{RNAreorder}}}{Reorder the data frame for differential
analysis, ensuring control verse treatment comparison.}
\item{\code{\link{RNAsequences}}}{Extract RNA sequence from sRNA clusters.}

\item{\code{\link{RNAattributes}}}{Overlap the genomic features related to
the sRNA clusters.}
\item{\code{\link{RNAdistribution}}}{Plot the distribution of sRNA classes
based on nucleotide length.}
\item{\code{\link{plotHeatmap}}}{Heatmap of log-transformed normalization
data.}
\item{\code{\link{plotSampleDistance}}}{Plots a sample distance heatmap for
quality control.}
\item{\code{\link{plotSamplePCA}}}{Plots a PCA plot, customize ratio,
colours and shapes.}
\item{\code{\link{RNAfeatures}}}{Summarise the distribution of sRNA clusters
across genomic features.}
\item{\code{\link{RNAdf2se}}}{Convert a \code{mobileRNA} dataframe to a
SummarizedExperiment object. }
}
}
\seealso{
See \code{vignette("mobileRNA", package = "mobieRNA")} for an
overview of the package.
}
\author{
Katie Jeynes-Cupper \email{kej031@student.bham.ac.uk},
Marco Catoni \email{m.catoni@bham.ac.uk}
Maintainer: Katie Jeynes-Cupper \email{kej031@student.bham.ac.uk}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAmergeAnnotations.R
\name{RNAmergeAnnotations}
\alias{RNAmergeAnnotations}
\title{Merge two genome annotation files (GFF Format)}
\usage{
RNAmergeAnnotations(
  annotationA,
  annotationB,
  output_file,
  AnnoA.ID = "A",
  AnnoB.ID = "B",
  format = "gff3"
)
}
\arguments{
\item{annotationA}{path; path to a genome annotation assembly file in GFF format.}

\item{annotationB}{path; path to a genome annotation assembly file in GFF format.}

\item{output_file}{path; a character string or a \code{base::connections()}
open for writing. Including file output name, and must have a GFF file
extension.}

\item{AnnoA.ID}{character; string to represent prefix added to
existing chromosome names in \code{annotationA}. Default set as "A".}

\item{AnnoB.ID}{character; string to represent prefix added to
existing chromosome names in \code{annotationB}. Default set as "B".}

\item{format}{format of GFF output, either "gff", "gff1", "gff2", "gff3."
Default is "gff3".}
}
\value{
A GFF format file containing the annotations of two genomes distinguishable by
the appended prefixes.
}
\description{
Merges two genomes annotation files (GFF) into one
single GFF format file saved to the desired directory. This function adds a
unique prefix to the chromosome names in each genome annotation to ensure
each is distinguishable within the merged file.
}
\details{
As default, the function removes periods and adds a prefix to the existing
chromosome names. The prefix is separated from the original chromosome name
by an underscore. For example, based on the default settings, it will add the
prefix "A_" to the chromosome names in \code{annotationA}, for instance,
A_0, A_1, A_2 etc.

The merged genome is saved to the specified output directory, and requires
the user to set the name with a GFF format.

\strong{IMPORTANT:} The genome reference and annotation of a species
must have chromosomes with matching names. It is critical that if you used
the \code{\link[=RNAmergeGenomes]{RNAmergeGenomes()}} function to create a merged reference
genome,that you treat the input annotations in the same way.
}
\examples{

anno1 <- system.file("extdata", "reduced_chr12_Eggplant.gff.gz",
package="mobileRNA")

anno2 <- system.file("extdata","reduced_chr2_Tomato.gff.gz",
package="mobileRNA")

output_file <- tempfile("merged_annotation", fileext = ".gff3")

merged_anno <- RNAmergeAnnotations(annotationA = anno1, annotationB = anno2,
                                   output_file = output_file)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotRNAfeatures.R
\name{plotRNAfeatures}
\alias{plotRNAfeatures}
\title{Plots the distribution of genomic features in the genome and those that
overlap with sRNA clusters}
\usage{
plotRNAfeatures(
  data,
  annotation,
  repeats = NULL,
  promoterRegions = 1000,
  repeat.type = NULL,
  colors = c("#EEB05AFF", "#E35E28FF", "#4DA284FF", "#4692B0FF", "#134B73FF",
    "#B5361CFF"),
  legend.position = "bottom",
  rmFeatures = NULL
)
}
\arguments{
\item{data}{data.frame; generated by \code{\link[=RNAimport]{RNAimport()}}}

\item{annotation}{path; URL or connection to a GFFFile object. A genome
reference annotation file (.gff/.gff1/.gff2/.gff3). Can be in compressed
format (gzip).}

\item{repeats}{path; URL or connection to a GFFFile object. A genome
reference annotation file, which only contains information on repeat
sequences in the genome (.gff/.gff1/.gff2/.gff3). By default, this is not
required, however if there is a specific repeats annotation file for the
genome it is suggested to supply it. Can be in compressed format (gzip).}

\item{promoterRegions}{numeric; defines the upstream promoter region of
genes. Default is 1000, which refers to promoters set at 1Kb upstream of
genes}

\item{repeat.type}{character; features type in \code{annotation} file to represent
repeats when \code{repeats} not supplied.}

\item{colors}{vector; colours for each feature.}

\item{legend.position}{character; position of legend. Either "none", "left",
"right", "bottom", "top", "inside".}

\item{rmFeatures}{vector; type of genomic features to not consider such as
"gene" or "exon" etc.}
}
\value{
Returns a table containing the number or percentage of overlaps in
the supplied sRNA data set with specific regions in the genome annotation
such as genes, repeats, introns, exons.
}
\description{
Using the RNAfeatures() function, this function plots the
percentage distribution of genomic features in the provided genome annotation
and percentage the distibution of genomic features which overlap sRNA
clusters. This is illustrated as a stacked bar plot.
}
\details{
\code{RNAfeatures} calculates the number or percentage of sRNA clusters which
overlap with genomic features based on their genomic coordinates.
}
\examples{
data("sRNA_data")
features_plot <- plotRNAfeatures(data = sRNA_data,
                       annotation = system.file("extdata",
                       "reduced_chr2_Tomato.gff.gz", package="mobileRNA"))

}
\seealso{
\code{\link[=RNAmergeAnnotations]{RNAmergeAnnotations()}} to merge 2 GFF files into 1.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAsequences.R
\name{RNAsequences}
\alias{RNAsequences}
\title{Extract RNA sequence from sRNA clusters}
\usage{
RNAsequences(
  data,
  original = FALSE,
  method = c("consensus", "set"),
  match.threshold = 1,
  duplicates = "random",
  tidy = FALSE
)
}
\arguments{
\item{data}{data.frame; generated by \code{\link[=RNAimport]{RNAimport()}}}

\item{original}{logical; output results to working date as additional
columns (\code{original=TRUE}), or output as new data frame (\code{original=FALSE}).
by default, FALSE}

\item{method}{character; string to define method. Either "consensus" or "set".
The "consensus" method identifies the consensus sequences across replicated
based on the \code{bioseq} package method. Whereas the "set" is based on the fixed
sequences calculated for each replicate and whether they are exact matches or
not.}

\item{match.threshold}{numeric; the minimum number of replicates
required to share the sRNA sequence to count as a match. Default is 1. Only
applicable to the "set" method.}

\item{duplicates}{character; string to define how to deal with a tie,
"random" as default. Options include "random" and "exclude". Only
applicable to the "set" method.}

\item{tidy}{logical; tidy-up data set by removing sRNA clusters with a
unknown or unclassified consensus sRNA sequence result. By default,
\code{tidy=FALSE}, while \code{tidy=TRUE} removes sRNA clusters with
an undetermined consensus RNA sequence.}
}
\value{
The results can be added as additional columns to the working
data frame supplied to the function or stored as a new data frame containing
only the results from the function. The results includes:
\itemize{
\item Match: whether the RNA sequence is consistent across replicates
\item Sequence:  character; sequence of the most abundant sRNA within a cluster
\item Complementary_RNA: character; complementary RNA nucleotide sequence
\item Complementary_DNA: character; complementary DNA nucleotide sequence
\item Width: numeric; length of nucleotide sequence
}
}
\description{
\code{RNAsequences} extrapolates the RNA sequence for sRNA clusters
through two different methods utilising the RNA sequence of the most abundant
transcript identified within each replicate. This can either be determined
by extracting the consensus sequence across replicates or by comparing the
sequences across replicates and selecting the most abundant. In this second
method ties between sequences can be seen, hence, the user must decide
whether a sequence is then chosen at random from the most abundant or
will exclude any sequence determination.

The function also calculates the RNA & DNA complementary sequences, as well
as stating the length/width of the sequence.
}
\details{
The set method checks whether each sample in the data set shares
the same major sRNA sequence for a given sRNA cluster. If at least two
replicates share the same sRNA sequence, the sequence is pulled and the
complementary DNA and RNA sequences are calculated. Using the
\code{match.threshold} parameter, we can alter the minimum number of replicates
required to share the RNA sequence to count as a match. For example, if set
as \code{match.threshold=3}, at least 3 replicates must contain the same sequence.
As a general rule, if only one replicate has determined a sRNA sequence it is
noted that there is no match, but the sequence is pulled and the
complementary sequences calculated.

The match column can either return "Yes", "No" or "Duplicate". If a match
between replicates is found, "Yes" is supplied, if not, "No". While if
there is a tie between sequences "Duplicate" is supplied. For examples,
if an equal number of replicates have sequence "x" and sequence "y".

In the situation where duplicates are identified, as default, at random
a consensus sRNA sequence is selected. This parameter can be changed to
"exclude", and under this parameter no consensus sequence is pulled.

Whereas with the consensus method, the consensus sequence is pulled from
all replicates.
}
\examples{

data("sRNA_data")

# vector of control names
controls <- c("selfgraft_1", "selfgraft_2" , "selfgraft_3")

# Locate potentially mobile sRNA clusters associated to tomato, no
# statistical analysis
sRNA_data_mobile <- RNAmobile(input = "sRNA", data =  sRNA_data,
controls = controls, genome.ID = "B_", task = "keep", statistical = FALSE)


mobile_sequences <- RNAsequences(sRNA_data_mobile, method = "consensus") 

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAdf2se.R
\name{RNAdf2se}
\alias{RNAdf2se}
\title{Convert a \code{mobileRNA} dataframe to a SummarizedExperiment object}
\usage{
RNAdf2se(input = c("sRNA", "mRNA"), data)
}
\arguments{
\item{input}{character; must be either "sRNA" or "mRNA"}

\item{data}{data.frame produced by the \pkg{mobileRNA} package.}
}
\value{
A \code{SummarizedExperiment} object containing information from working
data frame.

#'\strong{For sRNAseq data}
\itemize{
\item The rownames contain the locus name and the cluster name.
\item The assays represent the additional information including DicerCall, Count, RPM, MajorRNA.
\item The rowData includes the Cluster ID, the DicerCounts & the DicerConsensus.
\item The colnames represents the sample replicate names.
}

\strong{For mRNAseq data}
\itemize{
\item The rownames contain the gene names.
\item The assays represent the additional information including Count & FPKM.
\item The rowData includes the gene & the SampleCounts.
\item The colnames represents the sample replicate names.
}
}
\description{
Convert any \code{mobileRNA} output dataframe into a SummarizedExperiment object.
}
\details{
The function relies on the naming structure of columns created by functions
in the \pkg{mobileRNA} package. It is able to extract the sample names
based on these additions, and organise the data appropriately.
}
\examples{
# load data.frame
data("sRNA_data")

se <- RNAdf2se(input = "sRNA", data = sRNA_data)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAdifferentialAnalysis.R
\name{RNAdifferentialAnalysis}
\alias{RNAdifferentialAnalysis}
\title{Differential Analysis using \code{DESeq2} or \code{edgeR}}
\usage{
RNAdifferentialAnalysis(
  data,
  group,
  method = c("edgeR", "DESeq2"),
  dispersionValue = NULL
)
}
\arguments{
\item{data}{data.frame; originally generated by \code{\link[=RNAimport]{RNAimport()}}.}

\item{group}{character; the condition of each sample in the experimental
design, formatted in the order of samples shown in the \code{data} object from
left to right.}

\item{method}{character; method to undertaken differential analysis, choose
from methods of either \link[DESeq2:DESeq]{DESeq2::DESeq} or \link[edgeR:edgeR-package]{edgeR::edgeR}.
Must be stated as either "DESeq2" or "edgeR" in the function.}

\item{dispersionValue}{numeric; value to represent the dispersion value for
the \link[edgeR:edgeR-package]{edgeR::edgeR} method. Recommended for analysis in experiments without
biological replicates.}
}
\value{
Undertakes differential analysis, based on a specified method, and
appends the results to the supplied data frame. This includes:
\itemize{
\item Count mean
\item Log fold change
\item p-value
\item Adjusted p-value
\item Comparison order
}
}
\description{
\code{RNAdifferentialAnalysis} function computes the differential
analysis with \code{DESeq2} or \code{edgeR} of sRNA or mRNA data produced by the
\code{mobileRNA} package pipeline.
}
\details{
The user has the flexibility to choose the method that best suits
their data. In this function, the \code{DESeq2} method, calculates the
differentials based on the normalized count data based on the
size factors. Whereas the \code{edgeR} method, calculates normalization factors
estimates dispersion, and returns the common dispersion. After
normalization, the mean expression levels across samples are calculated, and
differential expression analysis is performed using the exact test
within groups, and the adjusted p-values are calculated using the
Benjamini-Hochberg method. Note that this function is only capable of
handling one replicate per condition with the \code{edgeR} method. This requires
setting a suitable dispersion value. The dispersion value is other wise known
as the common Biological squared coefficient of variation. See the
User’s Guide for the \code{edgeR} package for more details, \link[edgeR:edgeR-package]{edgeR::edgeR}.
}
\examples{
# load data 
data("sRNA_data")


# sample conditions.
groups <- c("Selfgraft", "Selfgraft", "Selfgraft", "Heterograft", "Heterograft", "Heterograft")


## Differential analysis: DEseq2 method
sRNA_DESeq2 <- RNAdifferentialAnalysis(data = sRNA_data,
                             group = groups,
                             method = "DESeq2" )


## Differential analysis: edgeR method
sRNA_edgeR <- RNAdifferentialAnalysis(data = sRNA_data,
                            group = groups,
                            method = "edgeR" )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mapRNA.R
\name{mapRNA}
\alias{mapRNA}
\title{mobileRNA pre-processing method for sRNAseq & mRNAseq (alignment, raw count or cluster analysis)}
\usage{
mapRNA(
  input = c("mRNA", "sRNA"),
  sampleData = NULL,
  tidy = TRUE,
  input_files_dir,
  output_dir,
  genomefile,
  annotationfile = NULL,
  condaenv,
  threads = 6,
  mmap = "n",
  dicermin = 20,
  dicermax = 24,
  mincov = 0.5,
  pad = 200,
  order = "pos",
  stranded = "no",
  a = 10,
  mode = "union",
  nonunique = "none",
  type = "mRNA",
  idattr = "Name",
  python = "python"
)
}
\arguments{
\item{input}{string; define type of Next-Generation Sequencing data set.
"sRNA" for sRNAseq data and "mRNA" for mRNAseq data.}

\item{sampleData}{dataframe; stores mRNA sample data where rows represent
each sample in the analysis. Column one stores the sample names, while column
two stores the the name(s) of the fastq file(s) for mate 1 (e.g. flyA_1.fq,
flyB_1.fq) and column three stores the the name(s) of the fastq file(s) for
mate 2 (e.g. flyA_2.fq,flyB_2.fq). If data is single ended, column three
will not hold any values. Only for mRNA analysis.}

\item{tidy}{logical; removes unnecessary extra output files when set to TRUE.}

\item{input_files_dir}{path; directory containing only the FASTQ samples for
analysis. Note that all samples in this directory will be used by this
function.}

\item{output_dir}{path; directory to store output.}

\item{genomefile}{path; path to a FASTA genome reference file.}

\item{annotationfile}{path; path to a GFF file. For mRNA analysis only.}

\item{condaenv}{character; name or directory of the Conda environment to use
where OS dependencies are stored.}

\item{threads}{numeric; set the number of threads to use where more threads
means a faster completion time. Default is 6.}

\item{mmap}{character; define how to handle multi-mapped reads. Choose from
"u", "f" , "r" or "n". For core sRNA analysis, use either "u", "f" or "r"
options. Where "u" means only uniquely-aligned reads are used as
weights for placement of multi-mapped reads. Where "f" means fractional
weighting scheme for placement of multi-mapped reads and "r" mean
multi-mapped read placement is random. For core mRNA analysis, to include
multimapped reads, use any parameter, other than "n". While for mobile sRNA
or mRNA, it is important to use "n", to not consider multi-mapped reads,
only unique reads as we cannot distinguish which genome the reads mapped to
multiple locations in.}

\item{dicermin}{integer; the minimum size in nucleotides of a valid small
RNA. This option sets the bounds to discriminate dicer-derived small RNA loci
from other loci. Default is 20. For sRNA analysis only.}

\item{dicermax}{integer; the maximum size in nucleotides of a valid small
RNA. This option sets the bounds to discriminate dicer-derived small RNA loci
from other loci. Default is 24. For sRNA analysis only.}

\item{mincov}{numeric; minimum alignment depth, in units of reads per
million, required to nucleate a small RNA cluster during de novo cluster
search. Must be a number > 0. Default is 2. For sRNA analysis only.}

\item{pad}{integer; initial peaks are merged if they are this distance or
less from each other. Must >= 1, default is 75. For sRNA analysis only.}

\item{order}{character; either "name" or "pos" to indicate how the input data
has been sorted. For paired-end data only, this sorts the data either by
read name or by alignment position. Default is "pos", to sort by position.
For mRNA analysis only.}

\item{stranded}{whether the data is from a strand-specific assay, either
"yes"/"no"/"reverse". Default is "no".  For mRNA analysis only.}

\item{a}{numeric; skip all reads with alignment quality lower than the given
minimum value (default: 10). For mRNA analysis only.}

\item{mode}{character; states mode to handle reads overlapping more than one
feature. Either "union", "intersection-strict" and "intersection-nonempty".
Default is "union". For mRNA analysis only.}

\item{nonunique}{character; states the mode to handle reads that align to or
are assigned to more than one feature in the overlap. Either "none" and
"all". Default is "none". For mobile mRNA, ensure the default is utilized to
exclude multimapped reads. For mRNA analysis only.}

\item{type}{character; feature type (3rd column in GFF file) to be used,
all features of other type are ignored. Default is "mRNA".
For mRNA analysis only.}

\item{idattr}{character; GFF attribute to be used as feature ID. Several GFF
lines with the same feature ID will be considered as parts of the same
feature. The feature ID is used to identity the counts in the output table.
Default is "Name". For mRNA analysis only.}

\item{python}{character; phython version. default is python but could be
python3 etc. This is for defining HTseq.}
}
\value{
** For sRNA analysis**
The OS commands generate output into the users desired location, generating
two folders:
\itemize{
\item 1_de_novo_detection: Stores output from the detection of de novo sRNA-producing loci
\item 2_sRNA_results: Stores results
}

The first folder stores the alignment (BAM) and the de novo sRNA-producing
loci for each sample (.txt) within the samples respective folder. The
analyses joins the de novo sRNA clusters across the experimental design which
is stored in "locifile.txt". The second folder stores the final clustering
results for each sample, and as before the results of each sample are stored
within it's respective folder. These results (.txt) are imported into R for
downstream analysis by utilizing the \code{\link[=RNAimport]{RNAimport()}} function.

The function generates a number of extra files for each sample and are not
required for the downstream analysis. These are generated by \code{ShortStack},
see documentation for more information
(\url{https://github.com/MikeAxtell/ShortStack}). As default
these files are deleted. This is determined by the \code{tidy} argument.

** For mRNA analysis**
For mRNA analysis, generate a new folder which stores the results in the
users desired output location, known as "1_mRNA_preprocessing". Within this
folder, there will contain one folder per sample storing it's sorted
alignment file (BAM) and raw counts file ("Result.txt"). Note, that the
function excludes multi-mapped mRNAs.
}
\description{
The mobileRNA workflow includes specific pre-processing
guidelines. For sRNAseq, this undertakes alignment with Bowtie and sRNA
cluster analysis with ShortStack. For mRNAseq, this undertakes alignment with
HISAT2 and HTSeq. All OS software should be installed within a Conda
environment.
}
\details{
Please ensure all OS software is installed within a Conda environment.
See appendix of vignette for manual pipeline. Alignment statistics are
reported for each analysis within log plain text files (log.txt).

In order to align reads, the function will check whether a genome reference
index has already been generated and, if not, will generate one. The method
varies between sRNA and mRNA analysis depending on the alignment tool. This
is generated in the same location as the reference file.

NOTE: This function utilises the \code{reticulate} R package to connect to the
conda environment. Hence, restart R if you wish to change the employed Conda
environment during a session.

\strong{For sRNA analysis}
The function invokes a number of OS commands, and is dependent
on the installation of \code{ShortStack} (>= 4.0) with Conda. Please note that
\code{ShortStack} is only compatible with Linux and Mac operating systems.

The pipeline undertakes de novo detection of sRNA-producing loci and
alignment, where the output of each are stored in their respective folders in
the users desired location. The de novo detection of sRNA-producing loci
analyses each sample to identify de novo sRNA-producing loci (ie. sRNA
clusters), and joins these results into a single file called "locifile.txt".
The alignment step aligns and clusters each sample to the genome reference
along with the file containing the de novo sRNA clusters. The final reports
are imported into R using \code{\link[=RNAimport]{RNAimport()}}.

\strong{For mRNA analysis}

The function invokes a number of OS commands, and is dependent
on the installation of \code{HISAT2},\code{HTSeq} and \code{SAMtools} with \code{Conda.}
The pipeline can undertake single- or pair-end analysis, and to do so
requires a data frame stating the sample information where each row
represents a sample. The reads are mapped using \code{HISAT} and then the
raw counts are estimated by \code{HTSeq}. The output alignment file (BAM) and
raw counts file for each sample are stored within the samples own folder
within the desired directory.
}
\examples{
\dontrun{

## EXAMPLE 1 - sRNAseq
samples <- file.path(system.file("extdata/sRNAseq",package="mobileRNA"))
GenomeRef <- system.file("extdata","reduced_chr12_Eggplant.fa.gz", package="mobileRNA")
output_location <- tempdir()

mapRNA(input = "sRNA", 
input_files_dir = samples, 
output_dir = output_location, 
genomefile = GenomeRef,
condaenv = "ShortStack4", 
mmap = "n")


## EXAMPLE 2 - mRNAseq
GenomeRef <- system.file("extdata","reduced_chr12_Eggplant.fa.gz", package="mobileRNA")
GenomeGFF <- system.file("extdata","reduced_chr12_Eggplant.gff.gz", package="mobileRNA")
# create sample data including name, and file mates: 
sampleData <- data.frame(sample = c("selfgraft_1", "selfgraft_2", 
                                   "heterograft_1", "heterograft_2"),
                        mate1 = c("selfgraft_mRNAdemo_1.fq.gz", "selfgraft_mRNAdemo_2.fq.gz", 
                                  "heterograft_mRNAdemo_1.fq.gz", "heterograft_mRNAdemo_2.fq.gz"))
# location of samples:                                 
samples <- system.file("extdata/mRNAseq", package="mobileRNA")

# location to store output
output_location <- tempdir()

# run alignment
mapRNA(input = "mRNA",
      input_files_dir = samples, 
      output_dir = output_location, 
      genomefile = output_assembly_file,
      annotationfile = output_annotation_file,
      sampleData = sampleData, 
      condaenv = "/Users/user-name/miniconda3")
}

}
\references{
ShortStack \url{https://github.com/MikeAxtell/ShortStack},
HISAT2 \url{https://anaconda.org/bioconda/hisat2},
HTSeq \url{https://htseq.readthedocs.io/en/master/install.html},
SAMtools \url{https://anaconda.org/bioconda/samtools}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotHeatmap.R
\name{plotHeatmap}
\alias{plotHeatmap}
\title{Heatmap of log-transformed normalization data}
\usage{
plotHeatmap(
  data,
  value = "RPM",
  pseudocount = 1e-06,
  colours = (grDevices::colorRampPalette(RColorBrewer::brewer.pal(9, "GnBu")))(100),
  cluster = TRUE,
  scale = "none",
  clustering_method = "complete",
  row.names = FALSE,
  border.color = NA,
  column.angle = 45,
  title = NA
)
}
\arguments{
\item{data}{data.frame; originally generated by \code{\link[=RNAimport]{RNAimport()}}}

\item{value}{character; state the values to plot, either \code{FPKM} or \code{RPM}.}

\item{pseudocount}{numeric; pseudo count, default is \code{1e-6}}

\item{colours}{character; colors. Default is
\code{grDevices::colorRampPalette(RColorBrewer::brewer.pal(9, "GnBu"))(100)}}

\item{cluster}{logical; include hierarchical clustering when default
\code{cluster= TRUE}}

\item{scale}{character; indicating whether the values should be centered &
scaled in either the row direction or the column direction, or none.
Respective options are "row", "column" & "none". Default is \code{scale="none"}.}

\item{clustering_method}{character; clustering method used. Accepts the same
values as hclust. Default \code{clustering_method= "complete"}}

\item{row.names}{logical; indicated whether to include rownames from column
1 of data frame. Default \code{row.names=FALSE}}

\item{border.color}{character; the border colour. Default is no border (NA).}

\item{column.angle}{numeric; angle of the column labels, choose from 0, 45,
90, 270 or 315.}

\item{title}{character; states plot title, placed at the top center}
}
\value{
Produces a list objects storing the heatmap plot and the data.
}
\description{
Undertakes normalisation of RPM/FPKM using a pseudocount and
transforms the data using log-scale, to enable visualization of the
differences and patterns in expression across samples using a heatmap.
}
\details{
Undertakes FPKM/RPM normalisation using a pseudocount and then
transforms the normalised-RPM data using log-scale.

This function expects to receive a data frame containing FPKM/RPM data.
This function employs the use of a pseudo count during
normalisation as the function is expected to be used when identifying mobile
sRNAs in a chimeric system. In such system, it is expected that control
replicates will contain zero values for the candidate mobile sRNA clusters.
}
\examples{
data("sRNA_data")

# vector of control names
controls <- c("selfgraft_1", "selfgraft_2" , "selfgraft_3")

# Locate potentially mobile sRNA clusters associated to tomato, no
# statistical analysis
sRNA_data_mobile <- RNAmobile(input = "sRNA", data =  sRNA_data,
controls = controls, genome.ID = "B_", task = "keep", statistical = FALSE)

# plot heatmap of potential mobile sRNAs
 p1 <-  plotHeatmap(sRNA_data_mobile)




}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAsubset.R
\name{RNAsubset}
\alias{RNAsubset}
\title{Subset sRNA data based on dicercall size}
\usage{
RNAsubset(data, class, statistical = FALSE, alpha = 0.05)
}
\arguments{
\item{data}{data.frame; generated by \code{\link[=RNAimport]{RNAimport()}}, containing
the additional information generated by \code{\link[=RNAdicercall]{RNAdicercall()}} which
defines the consensus sRNA class for each sRNA dicer-derived clusters}

\item{class}{numeric; sRNA dicercall class(es) to select. Based on size in
nucleotides.}

\item{statistical}{logical; filter and select statistically significant sRNA.
If \code{statistical=TRUE}, sRNA clusters are selected based on
p-adjusted alpha threshold.}

\item{alpha}{numeric; user-defined numeric value to represent the adjusted
p-value threshold to define statistical significance. Defaults setting
\code{alpha=0.05}.}
}
\value{
A data frame containing only sRNA clusters defined with a specific
sRNA dicer-derived consensus size.
}
\description{
Subset the existing dataframe to contain only the desired sRNA
class(s) based on the consensus dicercall determination and statistical
significance.
}
\details{
See \code{\link[=RNAdicercall]{RNAdicercall()}} for information on defining the consensus
sRNA dicercall class for each cluster. The function allows the choice to
filtered the data by statistical significance based on differential expression
analysis, see \code{\link[=RNAdifferentialAnalysis]{RNAdifferentialAnalysis()}}. Set
\code{statistical=TRUE} to filtered by statistical significance (p-adjusted).

It is important to consider what point in your analysis the data is subset
as it will drastically reduce your sample size, altering the output of
statistical analyse.
}
\examples{
# load data 
 data("sRNA_data")

# define consensus sRNA classes.
conditions <- c("heterograft_1", "heterograft_2", "heterograft_3")

# Run function to define sRNA class for each cluster.
sRNA_data_dicercall <- RNAdicercall(data = sRNA_data,
                                  conditions = conditions,
                                  tidy=TRUE)

# Subset data for  24-nt sRNAs
sRNA_24 <- RNAsubset(sRNA_data_dicercall, class = 24)


# Subset data for 21/22-nt sRNAs
sRNA_2122 <- RNAsubset(sRNA_data_dicercall, class = c(21, 22))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAfeatures.R
\name{RNAfeatures}
\alias{RNAfeatures}
\title{Summarise the distribution of sRNA clusters across genomic features}
\usage{
RNAfeatures(
  data,
  annotation,
  repeats = NULL,
  repeat.type = NULL,
  promoterRegions = 1000,
  rmFeatures = NULL
)
}
\arguments{
\item{data}{data.frame; generated by \code{\link[=RNAimport]{RNAimport()}}}

\item{annotation}{path; URL or connection to a GFFFile object. A genome
reference annotation file (.gff/.gff1/.gff2/.gff3). Can be in compressed
format (gzip).}

\item{repeats}{path; URL or connection to a GFFFile object. A genome
reference annotation file, which only contains information on repeat
sequences in the genome (.gff/.gff1/.gff2/.gff3). By default, this is not
required, however if there is a specific repeats annotation file for the
genome it is suggested to supply it. Can be in compressed format (gzip).}

\item{repeat.type}{character; features type in \code{annotation} file to represent
repeats when \code{repeats} not supplied.}

\item{promoterRegions}{numeric; defines the upstream promoter region of
genes. Default is 1000, which refers to promoters set at 1Kb upstream of
genes}

\item{rmFeatures}{vector; type of genomic features to not consider such as
"gene" or "exon" etc.}
}
\value{
Returns a table containing the number and percentage of overlaps in
the supplied sRNA data set with genomic features within supplied annotation
and/or with repeats.
}
\description{
Calculates the number/proportion of genomic features within the
supplied annotations and calculates the number/proportion of sRNA clusters
which overlap with these genomic features.
}
\details{
\code{RNAfeatures} calculates the number/percentage of sRNA clusters which
overlap with genomic features based on their genomic coordinates.
}
\examples{
data("sRNA_data")
features <- RNAfeatures(data = sRNA_data,
                       annotation = system.file("extdata",
                       "reduced_chr2_Tomato.gff.gz", package="mobileRNA"))

}
\seealso{
\code{\link[=RNAmergeAnnotations]{RNAmergeAnnotations()}} to merge 2 GFF files into 1.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNApopulation.R
\name{RNApopulation}
\alias{RNApopulation}
\title{Identify gained/lost RNA populations between treatment and control conditions}
\usage{
RNApopulation(
  data,
  conditions,
  statistical = FALSE,
  alpha = 0.05,
  chimeric = FALSE,
  controls = NULL,
  genome.ID = NULL,
  dual = TRUE
)
}
\arguments{
\item{data}{data.frame; generated by \code{\link[=RNAimport]{RNAimport()}}}

\item{conditions}{character; containing names of samples within
conditions to locate unique sRNA clusters.}

\item{statistical}{logical; If TRUE, will undertake statistical filtering
based on the adjusted p-value cutoff stated by \code{alpha}.
Default setting \code{statistical=FALSE}. Requires presence of columns
containing statistical data. To filter by the adjusted p-value, a
column named \code{padjusted} must be present. See
\code{\link[=RNAdifferentialAnalysis]{RNAdifferentialAnalysis()}} to calculate statistical values.}

\item{alpha}{numeric; user-defined numeric value to represent the adjusted
p-value threshold to define statistical significance. Defaults setting
\code{alpha=0.05}. Returns sRNA clusters or mRNA with adjusted p-values equal
or lower than the threshold value.}

\item{chimeric}{logical; state whether system is chimeric containing multiple
genomes/genotypes.}

\item{controls}{character; vector of control condition sample names.}

\item{genome.ID}{character; chromosome identifier of the genome representing
either the origin of mobile molecules or the other genome in the chimeric
system.}

\item{dual}{logical; works in corporation when \code{chimeric=TRUE} and removes
sRNA clusters mapped to the genome of mobile molecules.}
}
\value{
A subset of the supplied data and prints summary metric of
results including:
\itemize{
\item the total number of sRNA clusters or mRNA in the data set
\item the number & percentage of unique sRNA clusters or mRNA to your condition
\item the samples in the condition
}
}
\description{
Identify unique sRNA or mRNA populations within a set of
samples, typically within the same condition, compared to the other samples
in the analysis. This can be known as lost or gained populations due to
a treatment.
}
\details{
The function selects RNA which are unique to a given
condition and absent in the samples within the other condition(s).
For instance, a treatment might encourage the production of unique sRNAs
which are not produced in the control samples. The function can also select
the unique populations which show statistical significance, based on a
adjusted p-value cutoff. This must have been calculated previously, see
\code{\link[=RNAdifferentialAnalysis]{RNAdifferentialAnalysis()}} function.

If users are working with a chimeric system, utilise the \code{chimeric=TRUE}
parameter and state \code{genome.ID} and \code{controls} parameter variables. This will
remove any potential mapping errors which could lead to false
interpretation.
}
\examples{

data("sRNA_data")

# Select sRNA clusters only in the heterograft samples (ie. treatment)

heterograft_pop <- RNApopulation(data = sRNA_data, 
                                 conditions = c("heterograft_1", 
                                                "heterograft_2", 
                                                "heterograft_3"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAsummary.R
\name{RNAsummary}
\alias{RNAsummary}
\title{Summarise differential analysis results}
\usage{
RNAsummary(
  data,
  alpha = 0.1,
  chimeric = FALSE,
  controls = NULL,
  genome.ID = NULL
)
}
\arguments{
\item{data}{data.frame; generated by \code{\link[=RNAdifferentialAnalysis]{RNAdifferentialAnalysis()}}}

\item{alpha}{numeric; user-defined numeric value to represent the adjusted
p-value threshold to define statistical significance. Defaults setting
\code{alpha=0.1}.}

\item{chimeric}{logical; state whether system is chimeric: contains multiple
genomes/genotypes.}

\item{controls}{character; vector of control condition sample names.}

\item{genome.ID}{character; chromosome identifier of the genome representing
either the origin of mobile molecules or the other genome in the chimeric
system.}
}
\value{
Prints a summary of the RNAs which align with the
adjusted p-value cutoff and states the number which has a positive and
negative log-fold change. Where a positive log-fold change represents an
increase in abundance and a negative value represents a decrease in abundance
between the conditions.
}
\description{
Print a summary of the statistical analysis of sRNA clusters
(sRNAseq) or mRNAs (mRNAseq) from a mobileRNA analysis
}
\details{
To look only at the differential abundance from RNAs in the mobilome, use the
\code{chimeric=TRUE} parameter and supply the chromosome identifier of the genome
from which mobile molecules originate from to the \code{genome.ID} parameter &
the control condition samples names to the \code{controls} parameter.
}
\examples{

# load data 
data("sRNA_data")


# sample conditions.
groups <- c("Selfgraft", "Selfgraft", "Selfgraft", "Heterograft", "Heterograft", "Heterograft")


## Differential analysis: DEseq2 method
sRNA_DESeq2 <- RNAdifferentialAnalysis(data = sRNA_data,
                             group = groups,
                             method = "DESeq2" )
                          
                   
res <- RNAsummary(sRNA_DESeq2)
                                 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAreorder.R
\name{RNAreorder}
\alias{RNAreorder}
\title{Reorder the data frame for differential analysis, ensuring control verse
treatment comparison}
\usage{
RNAreorder(data, controls)
}
\arguments{
\item{data}{data.frame; generated by \code{\link[=RNAimport]{RNAimport()}}}

\item{controls}{character; vector of control condition sample names.}
}
\value{
A re-ordered/re-organised working data frame with control samples
after the 5 cluster information columns, and treatment sample columns after
the control sample columns.
}
\description{
Re-organise the working data frame, placing control samples
before treatment samples. This ensures differential analysis comparison
between controls and treatment are in the correct arrangement.
}
\examples{
# load data 
data("sRNA_data")

controlReps <- c("selfgraft_1", "selfgraft_2", "selfgraft_3")

reorder_df <- RNAreorder(data = sRNA_data, controls = controlReps)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAimport.R
\name{RNAimport}
\alias{RNAimport}
\title{Import and organise sRNAseq & mRNAseq data sets}
\usage{
RNAimport(
  input = c("sRNA", "mRNA"),
  directory,
  samples,
  analysisType = "mobile",
  annotation,
  idattr = "Name",
  FPKM = FALSE,
  featuretype = "mRNA"
)
}
\arguments{
\item{input}{string; define type of dataset.
"sRNA" for sRNAseq data and "mRNA" for mRNAseq data.}

\item{directory}{path; directory containing of sample folders generated by
\code{ShortStack}}

\item{samples}{character; vector naming samples correlating
to outputted folders within the \code{directory} path.}

\item{analysisType}{character; either "core" or "mobile" to represent the sRNA
analysis workflow. Where the "core" sRNA analysis imports all reads (unique
& multi-map), while "mobile" sRNA analysis imports only uniquely aligned read
counts. Only for sRNA data, default is "mobile".}

\item{annotation}{path; directory to genome annotation (GFF) file used for
pre-processing. Only for mRNA data.}

\item{idattr}{character; GFF attribute to be used as feature ID containing
mRNA names. Several GFF lines with the same feature ID will be considered as
parts of the same  feature. The feature ID is used to identity the counts in
the output table. Default is "Name". Only for mRNA data.}

\item{FPKM}{logical; calculate the FPKM for each sample. Default is FALSE.}

\item{featuretype}{character; type of feature. Default is "mRNA",
only for mRNA data.}
}
\value{
\strong{For sRNAseq:}
A dataframe where rows represent sRNA clusters and columns represent
replicate information extracted from the ShortStack output. Replicate
information includes Dicercall, Counts, and MajorRNA sequence. Each replicate
information is distinguishable as the replicate name is joined as a suffix to
each column name. For example, for a sample called "Sample1", the columns will
include DicerCall_Sample1, Count_Sample1, MajorRNA_Sample1 and RPM_Sample1.

The breakdown of each column:
\itemize{
\item \code{Locus} : sRNA cluster locus
\item \code{chr} : Chromosome
\item \code{start} : start coordinate of cluster
\item \code{end} : end coordinate of cluster
\item \code{Cluster} : name of cluster
\item \code{DicerCall_} : the size in nucleotides of most abundant sRNA in the cluster
\item \code{Count_} :  number of uniquely aligned sRNA-seq reads that overlap the locus
\item \code{MajorRNA_} : RNA sequence of the most abundant sRNA in the cluster
\item \code{RPM_} : reads per million
\item \code{FPKM_} : Fragments Per Kilobase of transcript per Million mapped reads (only if option activated)
}

\strong{For mRNAseq:}
A dataframe where rows represent genes and columns represent replicate
information extracted from HTseq result. Replicate information includes Counts
and FPKM.  For example, for a sample called "Sample1", the columns will
include Count_Sample1, and FPKM_Sample1.

The breakdown of each column:
\itemize{
\item \code{mRNA} : Name of mRNA
\item \code{Locus}: Genomic loci of mRNA
\item \code{chr} : Chromosome
\item \code{start} : start coordinate
\item \code{end} : end coordinate
\item \code{width}: width in nucleotides of regions
\item \code{Count_} : number of uniquely aligned mRNA-seq reads that overlap the locus
\item \code{FPKM_} : Fragments Per Kilobase of transcript per Million mapped reads
}
}
\description{
Load and organise either sRNAseq or mRNAseq pre-processing
results into a single dataframe containing all experimental replicates
specified where rows represent either a sRNA cluster
(ie. sRNA producing-locus) or gene, respectively. Based on using the
mobileRNA pre-processing method (See \code{\link[=mapRNA]{mapRNA()}}).
}
\details{
The \code{RNAimport()} function requires the user to supply a directory path and
a character vector. The path must be to the pre-processing output.

Following the \code{mobileRNA} method, for sRNA analysis, the path will be to the
\verb{2_alignment_results} folder. While for mRNA analysis, the path will be to
the \verb{2_raw_counts} folder. Both folders are generated by the
\code{\link[=mapRNA]{mapRNA()}} function. The vector should contain strings
that represent and mirror the names of the sample replicate folders in the
above directory.

Together this information allows the function to extract the information
stored in "Result.txt" files of each sample.
}
\examples{
\dontrun{
# import sRNAseq data
df_sRNA <- RNAimport(input = "sRNA",
                     directory = "./analysis/sRNA_mapping_results",
                     samples = c("heterograft_1", "heterograft_2",
                     "heterograft_3","selfgraft_1" , "selfgraft_2" ,
                     "selfgraft_3"))


# The output of this function can be explored in the data object sRNA_data
data("sRNA_data")
head(sRNA_data)


# import sRNAseq data
df_mRNA <- RNAimport(input = "mRNA",
                     directory = "./analysis/mRNA_mapping_results",
                     samples = c("heterograft_1", "heterograft_2",
                     "heterograft_3","selfgraft_1" , "selfgraft_2" ,
                     "selfgraft_3"), 
                     annotation = "./merged_annotation.gff3")


}

}
\references{
ShortStack \url{https://github.com/MikeAxtell/ShortStack},
HISAT2 \url{https://anaconda.org/bioconda/hisat2},
HTSeq \url{https://htseq.readthedocs.io/en/master/install.html},
SAMtools \url{https://anaconda.org/bioconda/samtools}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAdicercall.R
\name{RNAdicercall}
\alias{RNAdicercall}
\title{Define the consensus dicercall for each sRNA cluster}
\usage{
RNAdicercall(
  data,
  conditions = NULL,
  ties.method = NULL,
  tidy = FALSE,
  chimeric = FALSE,
  controls = NULL,
  genome.ID = NULL
)
}
\arguments{
\item{data}{data.frame; originally generated by \code{\link[=RNAimport]{RNAimport()}}.}

\item{conditions}{character; vector containing sample replicate names. When
supplied, the data from the named replicates will be the only ones used to
calculate the dicercall consensus for each sRNA cluster. Each
string should represent a sample name present in the dataframe supplied to
the \code{data} argument.}

\item{ties.method}{character; string specifying how ties are handled, choose
either "exclude" or "random". When using \code{random}, if there is a tie one of
the classes will be chosen at random. While, when using \code{exclude} if there is
a tie the class is set to undefined, however, if there is a tie between a
undefined and a known class, the known class takes president (eg 3x24-nt and
3xN-nt, then it will be classed as 24nt). Default setting
\code{ties.method="exclude"}.}

\item{tidy}{logical; tidy-up data by removing sRNA clusters with an unknown
or unclassified result. Default setting \code{tidy=FALSE}, removes excess
background noise.}

\item{chimeric}{logical; state whether the system is chimeric and contains
multiple genomes/genotypes.}

\item{controls}{character; vector of control condition sample names.}

\item{genome.ID}{character; chromosome identifier of the genome representing
either the origin of mobile molecules or the other genome in the chimeric
system.}
}
\value{
The original input data with two additional columns appended known as
\code{DicerCounts} and \code{DicerConsensus}. The \code{DicerCounts} column stores the number
of replicates that contributed to defining the consensus dicer-derived sRNA
class. Note that when utilising the \code{exclude} ties methods, the \code{DicerCounts}
will be represented as 0 when a tie is identified. While, the \code{DicerConsensus}
stores the consensus dicercall.
}
\description{
The sRNA dicercall represents the length in nucleotides of the
most abundant sRNA sequence within a cluster. The function calculates the
consensus dicercall classification.
}
\details{
For each sample, the alignment/clustering step predicted the sRNA
dicercall for each cluster. This value is stored in the columns starting
with "DicerCall_".  This value represents the length of nucleotides of
the most abundant sRNA within the cluster. For some clusters, there is no
particular sRNA which is more abundant than another, hence, it is stated as
"NA" or "N", which is referred to as unclassified. The \code{RNAdicercall()}
function calculate the consensus dicercall for each sRNA cluster based on
the values across replicates. There are several parameters which will alter
the output, including the handling of ties and the method to draw the
consensus from.

When ties.method = "random", as per default, ties are broken at random.
In this case, the determination of a tie assumes that the entries are
probabilities: there is a relative tolerance of 1e-5, relative to the
largest (in magnitude, omitting infinity) entry in the row.

When ties.method = "exclude", ties between sRNA classification are ruled as
unclassified ("N"). However, when there is a tie between the choice of a
class or unclassified result the \code{exclude} option will always select the
class choice over the unclassified result.

If users are working with a chimeric system, utilise the \code{chimeric=TRUE}
parameter and state \code{genome.ID} and \code{controls} parameter variables. This will
remove any potential mapping errors which could introduce false interpretation.

To remove excess data noise, \code{tidy=TRUE} can be used to removed unclassified
("N") sRNA clusters, resulting in a reduced data set size.
}
\examples{
 # load data 
 data("sRNA_data")

# define consensus sRNA classes.
conditions <- c("heterograft_1", "heterograft_2", "heterograft_3")

# Run function to define sRNA class for each cluster.
sRNA_data_dicercall <- RNAdicercall(data = sRNA_data,
                                  conditions = conditions,
                                  tidy=TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mobileRNA-package.R
\docType{data}
\name{mRNA_data}
\alias{mRNA_data}
\title{mRNA_data: simulated messenger RNA data for biological replicates}
\usage{
data(mRNA_data)
}
\value{
Dataframe in global environment
}
\description{
Simulated mRNAseq dataset
}
\details{
Simulates data is taken from eggplant and tomato mRNAseq samples and
created to simulate to movement of mRNA molecules from an Tomato rootstock to
an Eggplant Scion. Two Eggplant replicates were spiked with the same 150
tomato mRNA clusters, and named "heterograft_" 1 to 2. The analysis compares
these heterografts to two Eggplant self-grafts which are the original
un-spiked Eggplant replicates, called "selfgraft_" 1 to 2.

This data was imported and organised by the \code{\link[=RNAimport]{RNAimport()}} function.
}
\examples{
 data("mRNA_data")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAattributes.R
\name{RNAattributes}
\alias{RNAattributes}
\title{Overlap the genomic features related to the sRNA clusters}
\usage{
RNAattributes(
  data,
  annotation,
  match = c("within", "genes"),
  bufferRegion = 1000
)
}
\arguments{
\item{data}{data.frame; originally generated by \code{\link[=RNAimport]{RNAimport()}} or
containing \code{chr}, \code{start} and \code{end} columns.}

\item{annotation}{path; URL, connection or GFFFile object. A genome
reference annotation file (.gff/.gff1/.gff2/.gff3).}

\item{match}{character; must be either  "within" or "genes". Where
"within" will return matches where the clusters can be found within any
annotation, while "genes" will return matches where the clusters can be found
within only genes.}

\item{bufferRegion}{numeric; a buffer region in base-pairs to extend the
start and end coordinates upstream and downstream respectively.}
}
\value{
Appends the attribute columns from the GFF file to the supplied data based on
overlapping genomic regions.
}
\description{
Overlap the genomic features related to the sRNA clusters
}
\details{
Based on genomic coordinates, assign sRNA clusters with matching annotation
information. This function can be used to find the genomic features from
which the sRNA clusters originate from. This includes genes or repetitive
regions. An additional buffer region at the start/end of the gene is added
to improve hits, and align with the assumptions about promoter regions.

It is important that any alteration which were made to the genome reference
(FASTA) used for aligment/clustering,  such as alterations to the chromosome
name, must be carried forth to the genome annotation file. See
\code{\link[=RNAmergeGenomes]{RNAmergeGenomes()}} and \code{\link[=RNAmergeAnnotations]{RNAmergeAnnotations()}} for
more information.
}
\examples{
 # load data
data("sRNA_data")

attributes_df <- RNAattributes(data = sRNA_data,
                    annotation = system.file("extdata",
                    "prefix_reduced_chr2_Tomato.gff", package="mobileRNA"),
                    match = "genes")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAmobile.R
\name{RNAmobile}
\alias{RNAmobile}
\title{Identify putative RNA molecules produced by the non-tissue sample genome}
\usage{
RNAmobile(
  input = c("sRNA", "mRNA"),
  data,
  controls,
  genome.ID,
  task = NULL,
  statistical = FALSE,
  alpha = 0.1,
  threshold = NULL
)
}
\arguments{
\item{input}{character; must be either "sRNA" or "mRNA" to represent the type
of data.}

\item{data}{data.frame; generated through the \pkg{mobileRNA} method.}

\item{controls}{character vector; containing names of control samples.}

\item{genome.ID}{character; string or chromosome identifier related to the
chromosomes in a given genome. A distinguishing feature of the genome of
interest or non-interest in the chromosome name (\code{chr} column).}

\item{task}{character; string to set the method to keep or remove the
chromosomes containing the identifying string. To keep the chromosomes with
the ID, set task=keep. To remove, set \code{task="remove"}. As default, task is
set to \code{keep}.}

\item{statistical}{If TRUE, will undertake statistical filtering based on the
a p-value or adjusted p-value threshold stated by \code{alpha}.Default
set at FALSE. Requires presence of columns containing statistical data.
In order to filter by the adjusted p-value, a column named \code{padjusted} must
be present. See \code{\link[=RNAdifferentialAnalysis]{RNAdifferentialAnalysis()}} to calculate
statistical values.}

\item{alpha}{numeric; adjusted p-value cutoff as the target FDR for
independent filtering. Default is 0.1. Only mobile molecules with adjusted
p-values equal or lower than specified are returned.}

\item{threshold}{numeric; set a threshold level. For sRNA analysis, this
represents filtering by the minimum number of replicates that defined the
consensus dicercall which is stored in the \code{DicerCounts} column. While,
for mRNA analysis this represents the number of replicates which contained
reads for the mRNA molecule which is stored in the \code{SampleCounts} column.}
}
\value{
A data frame containing candidate mobile sRNAs or mRNAs, which could
have been further filtered based on statistical significance and the ability
to by-pass the thresholds which determine the number of replicates that
defined the consensus dicercall (sRNA) or contributed to reads counts (mRNA).
}
\description{
A function to identify the putative sRNA or mRNA  molecules
produced by the non-tissue sample genome. Includes putative RNA mobilome or
RNAs not expected to be found within the tissue of origin.
}
\details{
The function identifies candidate sRNAs or mRNAs produced by a specific
genome/genotype. It does so by either keeping or removing those mapped to a
given genome. To do so, it requires a common pre-fix across chromosomes of
the given genome. See\code{\link[=RNAmergeGenomes]{RNAmergeGenomes()}} for more information.
In addition, it removes RNAs which were likely to be falsely mapped. These
are those which were mapped to the non-tissue genotype in the control
samples.

\strong{For sRNAseq:}
A greater confidence in the sRNA candidates can be achieved by setting
a threshold that considers the number of replicates which contributed to
defining the consensus dicercall (ie. consensus sRNA classification). This
parameter filters based on the \code{DicerCounts} column introduced by the
\code{\link[=RNAdicercall]{RNAdicercall()}} function.

\strong{For mRNAseq:}
A greater confidence in the mRNA candidates can be achieved by setting
a threshold that considers the number of replicates which contained reads
for the mRNA molecule. This parameter filters based on the \code{SampleCounts}
column introduced by the \code{\link[=RNAimport]{RNAimport()}} function.

Alternatively, utilize the \code{baymobil} algorithm, which identifies the mobile
mRNAs using exact Bayesian inference based on SNP variant information. This
option requires the user to input substantially more information. Please
be aware this option requires significant processing time (so, maybe get a
brew while this runs). Note that this option produces additional files, see
\code{Value} section for more details.

\strong{Statistical Analysis}
The function also allows for filtering using statistical inference generated
from the differential analysis of the total data set using the function
\code{\link[=RNAdifferentialAnalysis]{RNAdifferentialAnalysis()}}. When \code{statistical=TRUE}, the feature
is enabled and selects molecules that meet the adjusted p-value
cutoff defined by \code{alpha}.
}
\examples{
data("sRNA_data")


# vector of control names
controls <- c("selfgraft_1", "selfgraft_2" , "selfgraft_3")

# Locate potentially mobile sRNA clusters associated to tomato, no
# statistical analysis
mobile_df1 <- RNAmobile(input = "sRNA", data =  sRNA_data,
controls = controls, genome.ID = "B_", task = "keep", statistical = FALSE)



}
\references{
baymobil \url{https://doi.org/10.21203/rs.3.rs-2520491/v1}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mobileRNA-package.R
\docType{data}
\name{sRNA_data}
\alias{sRNA_data}
\title{sRNA_data: simulated data for biological replicates}
\usage{
data(sRNA_data)
}
\value{
Dataframe in global environment
}
\description{
Simulated sRNAseq dataset
}
\details{
Simulates data is taken from eggplant and tomato sRNAseq samples and
created to simulate to movement of sRNA molecules from an Tomato rootstock to
an Eggplant Scion. Three Eggplant replicates were spiked with the same 150
tomato sRNA clusters, and named "heterograft_" 1 to 3. The analysis compares
these heterografts to three Eggplant self-grafts which are the original
un-spiked Eggplant replicates, called "selfgraft_" 1 to 3.

This data was imported and organised by the \code{\link[=RNAimport]{RNAimport()}} function.
}
\examples{
 data("sRNA_data")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAmergeGenomes.R
\name{RNAmergeGenomes}
\alias{RNAmergeGenomes}
\title{Merge two genome reference assemblies (FASTA format)}
\usage{
RNAmergeGenomes(
  genomeA,
  genomeB,
  output_file,
  GenomeA.ID = "A",
  GenomeB.ID = "B",
  compress.output = FALSE
)
}
\arguments{
\item{genomeA}{path; path to a genome reference assembly file in FASTA format.}

\item{genomeB}{path; path to a genome reference assembly file in FASTA format.}

\item{output_file}{path; a character string or a \code{base::connections()}
open for writing. Including file output name, and file extension of \code{.fa} or
\code{.fasta}.}

\item{GenomeA.ID}{character; string to represent prefix added to
existing chromosome names in \code{genomeA}. Default set as "A"}

\item{GenomeB.ID}{character; string to represent prefix added to
existing chromosome names in \code{genomeB}. Default set as "B".}

\item{compress.output}{logical; state whether the output file should be in
a compressed format (gzip)}
}
\value{
Returns a single FASTA format file containing both genome assemblies
with edited chromosome names (prefixes, and removal of periods) to the given
directory.
}
\description{
Merges two reference genomes (FASTA) into one single
reference with modified chromosome names.

Typically, use genomeA as the origin tissue genome assembly, and genomeB as
the genome from which mobile RNAs are produced by.
}
\details{
The function merges two FASTA files, however, when merging genomic files it
is critical that the two genomes are distinguishable by the chromosome names.
As a default setting, the function extracts the chromosome names for the
given FASTA files and alters adds a unique prefix while retaining the
identifying number. Plus, removes any periods.

As default, the function will rename the chromosome names in \code{genome_A} to
"A" and separates the prefix and the existing chromosome names with an
underscore ("_"). For example, A_0, A_1, A_2 etc.

Please note that the underscore is added automatically, hence, when setting a
custom prefix just includes character values.

\strong{IMPORTANT:}  The genome reference and annotation of the same
species/accession/variety must have chromosomes with matching names. It is
critical that if you use the \code{\link[=RNAmergeAnnotations]{RNAmergeAnnotations()}} function to
create a merged genome annotation, that you treat the input references in the
same way.
}
\examples{
fasta_1 <- system.file("extdata","reduced_chr12_Eggplant.fa.gz", 
package="mobileRNA")

fasta_2 <-system.file("extdata","reduced_chr2_Tomato.fa.gz",
package="mobileRNA")


output_file <- file.path(tempfile("merged_annotation", fileext = ".fa"))

merged_ref <- RNAmergeGenomes(genomeA = fasta_1, 
genomeB = fasta_2,
output_file = output_file)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAdistribution.R
\name{RNAdistribution}
\alias{RNAdistribution}
\title{Plot the distribution of sRNA classes based on nucleotide length}
\usage{
RNAdistribution(
  data,
  samples = NULL,
  style,
  data.type = "samples",
  facet = TRUE,
  facet.arrange = 3,
  colour = "#0868AC",
  outline = "black",
  wrap.scales = "fixed",
  overlap = TRUE,
  relative = FALSE,
  non.classified = TRUE
)
}
\arguments{
\item{data}{data.frame; generated originally by \code{\link[=RNAimport]{RNAimport()}}}

\item{samples}{character; states a subset of samples to plot. This argument
is based on the sample names within the data.}

\item{style}{character; \code{style="line"} or \code{style="bar"}.
Instructs how to plot the data. Where \code{style="line"} plots a line graph
and \code{style="bar"} plots a bar graph.}

\item{data.type}{character; either plotting "samples" or the "consensus"
stored in the 'DicerConsensus' column.}

\item{facet}{logical; forms a matrix of panels defined by row and column
faceting variables. It plots the results for each sample as a bar chart
and contains it within a single plot. The number of rows in the facet can
be changed using the argument \code{facet.arrange}.
Default \code{facet = TRUE} , plots each sample separately when
\code{facet = FALSE} .}

\item{facet.arrange}{numeric; value supplied to define the number of columns
to include in the facet. This argument is piped into the \code{ ncol}  argument in
\code{\link[ggplot2:facet_wrap]{ggplot2::facet_wrap()}} to define the number of columns. By default, this is
set to 3.}

\item{colour}{character; fill colour, Default is "#0868AC".}

\item{outline}{character; states the outline colour for a box plot.
Default is "black".}

\item{wrap.scales}{character; scales be fixed ("fixed", the default), free
("free"), or free in one dimension ("free_x", "free_y")}

\item{overlap}{logical; generates a single line graph, containing all
sample replicate information. Default \code{overlap=TRUE}.}

\item{relative}{logical; used in conjunction with \code{data.type="consensus"}.
Instructs plotting of the relative frequency of all sRNA classes across the
data defined by the consensus dicer-derived sRNA column (see
\code{\link[=RNAdicercall]{RNAdicercall()}} function for more information).}

\item{non.classified}{logical; to include distribution of sRNAs which were
unclassified. Default is TRUE, ie. maintain.}
}
\value{
The function returns a list containing the results: a data frame and
the plot(s). To access an element, simply use the "$" symbol,
and the elements "data" and "plot" will appear.
}
\description{
\code{RNAdistribution} plots the distribution of dicer-derived
sRNA classes across samples or the sRNA consensus determined by the
\code{\link[=RNAdicercall]{RNAdicercall()}} function. This can be displayed as a line or bar
plot.
}
\details{
The function can be used to plot a variety of different comparisons and plots.
It can be used to plot the distribution of sRNA classes within each sample
replicate, which can be represented as a bar chart \code{style="bar"} or a
line graph \code{style="line"}. These plots can be represented individually or
in a single facet plot when \code{facet="TRUE"}.

Additionally, there is the option to plot the distribution of sRNA classes
within individual samples or to plot the distribution of the consensus
dicer-derived sRNA classes determined by the \code{\link[=RNAdicercall]{RNAdicercall()}} function and
stored in the column \code{DicerConsensus} when \code{data.type="consensus"}.
When plotting samples individually, there is the option to overlap the
results onto a single line graph when \code{overlap=TRUE}. This is not an
option for bar plots.
}
\examples{
# load data 
data('sRNA_data')

p1 <- RNAdistribution(data = sRNA_data, style = "line")

p2 <- RNAdistribution(data = sRNA_data, style = "line", overlap = FALSE)

p3 <- RNAdistribution(data = sRNA_data, style = "bar")

p3.2 <- RNAdistribution(data = sRNA_data, style = "bar",
                       samples = c("heterograft_1", "heterograft_2",
                       "heterograft_3"))

p4 <- RNAdistribution(data = sRNA_data, style = "bar", facet = FALSE)

p5 <- RNAdistribution(data = sRNA_data, style = "bar",
                      facet = TRUE, facet.arrange = 2 )


# Run function to define sRNA class for each cluster.
sRNA_data_dicercall <- mobileRNA::RNAdicercall(data = sRNA_data, tidy=TRUE)

p6 <- RNAdistribution(data = sRNA_data_dicercall, style = "bar", data.type = "consensus")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSampleDistance.R
\name{plotSampleDistance}
\alias{plotSampleDistance}
\title{Sample distance matrix}
\usage{
plotSampleDistance(
  data,
  colours = (grDevices::colorRampPalette(rev(RColorBrewer::brewer.pal(9, "GnBu"))))(255),
  vst = FALSE,
  cellheight = 40,
  cellwidth = 40
)
}
\arguments{
\item{data}{data.frame; originally generated by \code{\link[=RNAimport]{RNAimport()}}}

\item{colours}{character; the colour palette. Default is
\code{ grDevices::colorRampPalette(RColorBrewer::brewer.pal(9, "GnBu"))(100)}}

\item{vst}{logical; to undertake variance stabilizing transformation.
By default, the function uses a regularized log transformation on the data
set, however, this will not suit all experimental designs.}

\item{cellheight}{numeric; individual cell height in points. Default is 40.}

\item{cellwidth}{numeric; individual cell width in points. Default is 40.}
}
\value{
A blue/green scale heatmap illustrating the sample distance.
}
\description{
Draws a simple hierarchical clustered heatmap to observe
sample distance.
}
\details{
In special conditions, regularized log transformation will not suit
the experimental design. For example, an experimental design without
replicates. In this instance, it is preferable to change the default setting
and switch to a variance stabilizing transformation method (\code{vst=TRUE}).
}
\examples{

data("sRNA_data")
p1 <- plotSampleDistance(sRNA_data)

}
